package alicebob0;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class BobBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short I = 1;

	public static final short CS = 2;

	private final short informal2;

	private final short informal3;

	public BobBehavior(SymbolsTable symbols) {
		super("Bob", idSeed++, symbols);
		informal2 = symbols.getInformalId("{b1}");
		informal3 = symbols.getInformalId("{b2}");
	}

	private final String[] stateNames = new String[] {"I", "CS"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			BobConfiguration me = (BobConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != I) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final BobConfiguration me = (BobConfiguration) configuration.behaviorConfigurations[id];
			actions.add(new InformalAction(id, informal2));
			me.state = CS;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			BobConfiguration me = (BobConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != CS) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final BobConfiguration me = (BobConfiguration) configuration.behaviorConfigurations[id];
			actions.add(new InformalAction(id, informal3));
			me.state = I;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		BobConfiguration me = new BobConfiguration();
		//Initial action code.
		me.state = I;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		BobConfiguration me = (BobConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case BobBehavior.I: 
			text.append("@I,");
			break;
		case BobBehavior.CS: 
			text.append("@CS,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		BobConfiguration me = (BobConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case BobBehavior.I: 
			text.append("@I,");
			break;
		case BobBehavior.CS: 
			text.append("@CS,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		BobConfiguration me = new BobConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		BobConfiguration me = (BobConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

