package ccs_hand_crafted_standalone_system;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class ActuationBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short UnSet = 1;

	public static final short UnsetSetting = 2;

	public static final short Set = 3;

	public static final short SetSetting = 4;

	public static final short Engaged = 5;

	public static final short EngagedSetting = 6;

	public static final short Paused = 7;

	public static final short PausedSetting = 8;

	private final ReferencedArgument<T_event_Actuation[]> eventPoolRef;

	private final ReferencedArgument<T_event_SystemCenter[]> itsSystemCenterRef;

	private final ReferencedArgument<T_event_Car[]> itsCarRef;

	public ActuationBehavior(SymbolsTable symbols, ReferencedArgument<T_event_Actuation[]> eventPool, ReferencedArgument<T_event_SystemCenter[]> itsSystemCenter, ReferencedArgument<T_event_Car[]> itsCar) {
		super("Actuation", idSeed++, symbols);
		this.eventPoolRef = eventPool;
		this.itsSystemCenterRef = itsSystemCenter;
		this.itsCarRef = itsCar;
	}

	private final String[] stateNames = new String[] {"unSet", "unsetSetting", "set", "setSetting", "engaged", "engagedSetting", "paused", "pausedSetting"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
			modifiedBehaviors[itsSystemCenterRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UnSet) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Actuation(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtRequestEngagement.class) {
					if (( (itsSystemCenter.length >= 2 )) == false) {
						itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtNAck(), actions);
					} else {
						if (true) { return false; }
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = UnsetSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
					speed = ((T_event_Actuation.EvtSpeedA)  FiacreQueueUtil.first(eventPool)).value;
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = UnSet;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UnsetSetting) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Actuation(eventPool, new boolean[] {true, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.setPointSpeed = CCS_hand_crafted_standalone_systemRoot.UNINITIALIZED;
					me.state = UnSet;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
					speed = ((T_event_Actuation.EvtSpeedA)  FiacreQueueUtil.first(eventPool)).value;
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (((speed) < (40)) || ((speed) > (180))) {
						me.setPointSpeed = CCS_hand_crafted_standalone_systemRoot.UNINITIALIZED;
						me.state = UnSet;
						if (true) return true;
					} else {
						me.setPointSpeed = speed;
						me.state = Set;
						if (true) return true;
					}
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = UnsetSetting;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
			modifiedBehaviors[itsSystemCenterRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Set) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Actuation(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtRequestEngagement.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsSystemCenter.length >= 2 )) == false) {
						itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtAck(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = Engaged;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.setPointSpeed = CCS_hand_crafted_standalone_systemRoot.UNINITIALIZED;
					me.state = UnSet;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = SetSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
					me.setPointSpeed = (me.setPointSpeed) + (CCS_hand_crafted_standalone_systemRoot.SPEED_INCREMENT);
					if ((me.setPointSpeed) > (180)) {
						me.setPointSpeed = 180;
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
					me.setPointSpeed = (me.setPointSpeed) - (CCS_hand_crafted_standalone_systemRoot.SPEED_INCREMENT);
					if ((me.setPointSpeed) < (40)) {
						me.setPointSpeed = 40;
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
					speed = ((T_event_Actuation.EvtSpeedA)  FiacreQueueUtil.first(eventPool)).value;
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Set;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
			modifiedBehaviors[itsSystemCenterRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != SetSetting) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Actuation(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtRequestEngagement.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsSystemCenter.length >= 2 )) == false) {
						itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtAck(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = EngagedSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.setPointSpeed = CCS_hand_crafted_standalone_systemRoot.UNINITIALIZED;
					me.state = UnSet;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
					speed = ((T_event_Actuation.EvtSpeedA)  FiacreQueueUtil.first(eventPool)).value;
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (((speed) < (40)) || ((speed) > (180))) {
						me.state = Set;
						if (true) return true;
					} else {
						me.setPointSpeed = speed;
						me.state = Set;
						if (true) return true;
					}
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = SetSetting;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
			modifiedBehaviors[itsCarRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Engaged) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Actuation(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtRequestEngagement.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Set;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Paused;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = EngagedSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
					me.setPointSpeed = (me.setPointSpeed) + (CCS_hand_crafted_standalone_systemRoot.SPEED_INCREMENT);
					if ((me.setPointSpeed) > (180)) {
						me.setPointSpeed = 180;
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
					me.setPointSpeed = (me.setPointSpeed) - (CCS_hand_crafted_standalone_systemRoot.SPEED_INCREMENT);
					if ((me.setPointSpeed) < (40)) {
						me.setPointSpeed = 40;
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
					speed = ((T_event_Actuation.EvtSpeedA)  FiacreQueueUtil.first(eventPool)).value;
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if ((speed) < (me.setPointSpeed)) {
						if (( (itsCar.length >= 2 )) == false) {
							itsCar = FiacreQueueUtil.enqueue(id, itsCar,new T_event_Car.EvtIncreaseSpeed((me.setPointSpeed) - (speed)), actions);
						} else {
							if (true) { return false; }
						}
					} else {
						if ((speed) > (me.setPointSpeed)) {
							if (( (itsCar.length >= 2 )) == false) {
								itsCar = FiacreQueueUtil.enqueue(id, itsCar,new T_event_Car.EvtDecreaseSpeed((speed) - (me.setPointSpeed)), actions);
							} else {
								if (true) { return false; }
							}
						}
					}
					me.state = Engaged;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Engaged;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
				itsCarRef.set(configuration, itsCar);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EngagedSetting) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Actuation(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtRequestEngagement.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = SetSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = PausedSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
					speed = ((T_event_Actuation.EvtSpeedA)  FiacreQueueUtil.first(eventPool)).value;
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (((speed) < (40)) || ((speed) > (180))) {
						me.state = Engaged;
						if (true) return true;
					} else {
						me.setPointSpeed = speed;
						me.state = Engaged;
						if (true) return true;
					}
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = EngagedSetting;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Paused) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Actuation(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtRequestEngagement.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Set;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Engaged;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = PausedSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
					me.setPointSpeed = (me.setPointSpeed) + (CCS_hand_crafted_standalone_systemRoot.SPEED_INCREMENT);
					if ((me.setPointSpeed) > (180)) {
						me.setPointSpeed = 180;
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
					me.setPointSpeed = (me.setPointSpeed) - (CCS_hand_crafted_standalone_systemRoot.SPEED_INCREMENT);
					if ((me.setPointSpeed) < (40)) {
						me.setPointSpeed = 40;
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
					speed = ((T_event_Actuation.EvtSpeedA)  FiacreQueueUtil.first(eventPool)).value;
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Paused;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != PausedSetting) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ActuationConfiguration me = (ActuationConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Actuation(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtRequestEngagement.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = SetSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = EngagedSetting;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
					speed = ((T_event_Actuation.EvtSpeedA)  FiacreQueueUtil.first(eventPool)).value;
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (((speed) < (40)) || ((speed) > (180))) {
						me.state = Paused;
						if (true) return true;
					} else {
						me.setPointSpeed = speed;
						me.state = Paused;
						if (true) return true;
					}
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = PausedSetting;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		ActuationConfiguration me = new ActuationConfiguration();
		int speed;
		//Initial action code.
		me.setPointSpeed = CCS_hand_crafted_standalone_systemRoot.UNINITIALIZED;
		me.state = UnSet;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ActuationConfiguration me = (ActuationConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ActuationBehavior.UnSet: 
			text.append("@unSet,");
			break;
		case ActuationBehavior.UnsetSetting: 
			text.append("@unsetSetting,");
			break;
		case ActuationBehavior.Set: 
			text.append("@set,");
			break;
		case ActuationBehavior.SetSetting: 
			text.append("@setSetting,");
			break;
		case ActuationBehavior.Engaged: 
			text.append("@engaged,");
			break;
		case ActuationBehavior.EngagedSetting: 
			text.append("@engagedSetting,");
			break;
		case ActuationBehavior.Paused: 
			text.append("@paused,");
			break;
		case ActuationBehavior.PausedSetting: 
			text.append("@pausedSetting,");
			break;
		}
		text.append("\n\t- setPointSpeed=");
		text.append(Integer.toString(me.setPointSpeed));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ActuationConfiguration me = (ActuationConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ActuationBehavior.UnSet: 
			text.append("@unSet,");
			break;
		case ActuationBehavior.UnsetSetting: 
			text.append("@unsetSetting,");
			break;
		case ActuationBehavior.Set: 
			text.append("@set,");
			break;
		case ActuationBehavior.SetSetting: 
			text.append("@setSetting,");
			break;
		case ActuationBehavior.Engaged: 
			text.append("@engaged,");
			break;
		case ActuationBehavior.EngagedSetting: 
			text.append("@engagedSetting,");
			break;
		case ActuationBehavior.Paused: 
			text.append("@paused,");
			break;
		case ActuationBehavior.PausedSetting: 
			text.append("@pausedSetting,");
			break;
		}
		text.append(" setPointSpeed=");
		text.append(Integer.toString(me.setPointSpeed));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		ActuationConfiguration me = new ActuationConfiguration();
		me.state = boost.readShort();
		me.setPointSpeed = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		ActuationConfiguration me = (ActuationConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.setPointSpeed);
	}

}

