package ccs_hand_crafted_standalone_system;

import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Program;
import obp.explorer.runtime.Component;
import java.util.Map;
import java.util.HashMap;
import java.util.Collections;

public class CCS_hand_crafted_standalone_systemRoot implements Program {

	public Map<String, String> getMetaInformations() {
		return Collections.emptyMap();
	}

	private Map<String, Integer> ioQueueSizeMap;

	public int getIoQueueSize(String name) {
		if ( ioQueueSizeMap == null ) {
			ioQueueSizeMap = new HashMap<String, Integer>();
			ioQueueSizeMap.put("ControlPannel_1", 1 );
			ioQueueSizeMap.put("SystemCenter_1", 2 );
			ioQueueSizeMap.put("HealthMonitoring_1", 2 );
			ioQueueSizeMap.put("Actuation_1", 3 );
			ioQueueSizeMap.put("Car_1", 2 );
		}
		Integer size = ioQueueSizeMap.get(name);
		if ( size == null ) {
			throw new IllegalArgumentException("Queue named '"+ name +"' doesn't exists.");
		}
		return size.intValue();
	}

	public static final int SIZE_eventPool_ControlPannel = 1;

	public static final int SIZE_eventPool_SystemCenter = 2;

	public static final int SIZE_eventPool_HealthMonitoring = 2;

	public static final int SIZE_eventPool_Actuation = 3;

	public static final int SIZE_eventPool_Car = 2;

	public static final int UNINITIALIZED =  - (1);

	public static final int SPEED_INCREMENT = 5;

	public static final int NUMBER_OF_EVENT_ControlPannel = 7;

	public static T_event_ControlPannel[] preProcess_eventPool_ControlPannel(T_event_ControlPannel[] eventPool, boolean[] deferMask) {
		T_event_ControlPannel[] defered = new T_event_ControlPannel[] {};
		T_event_ControlPannel[] result = new T_event_ControlPannel[] {};
		boolean continue_ = true;
		while (( !( (eventPool.length == 0))) && (continue_)) {
			if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnStart.class) {
				if (deferMask[0]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnStop.class) {
				if (deferMask[1]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnResume.class) {
				if (deferMask[2]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnSet.class) {
				if (deferMask[3]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnInc.class) {
				if (deferMask[4]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnDec.class) {
				if (deferMask[5]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnDisengage.class) {
				if (deferMask[6]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			}
		}
		if ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		while ( !( (defered.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(defered));
			defered =  FiacreQueueUtil.dequeue(defered);
		}
		while ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		return result;
	}

	public static final int NUMBER_OF_EVENT_SystemCenter = 9;

	public static T_event_SystemCenter[] preProcess_eventPool_SystemCenter(T_event_SystemCenter[] eventPool, boolean[] deferMask) {
		T_event_SystemCenter[] defered = new T_event_SystemCenter[] {};
		T_event_SystemCenter[] result = new T_event_SystemCenter[] {};
		boolean continue_ = true;
		while (( !( (eventPool.length == 0))) && (continue_)) {
			if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOn.class) {
				if (deferMask[0]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOff.class) {
				if (deferMask[1]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtResume.class) {
				if (deferMask[2]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtAck.class) {
				if (deferMask[3]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtNAck.class) {
				if (deferMask[4]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDisengage.class) {
				if (deferMask[5]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtSet.class) {
				if (deferMask[6]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtInc.class) {
				if (deferMask[7]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDec.class) {
				if (deferMask[8]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			}
		}
		if ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		while ( !( (defered.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(defered));
			defered =  FiacreQueueUtil.dequeue(defered);
		}
		while ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		return result;
	}

	public static final int NUMBER_OF_EVENT_HealthMonitoring = 7;

	public static T_event_HealthMonitoring[] preProcess_eventPool_HealthMonitoring(T_event_HealthMonitoring[] eventPool, boolean[] deferMask) {
		T_event_HealthMonitoring[] defered = new T_event_HealthMonitoring[] {};
		T_event_HealthMonitoring[] result = new T_event_HealthMonitoring[] {};
		boolean continue_ = true;
		while (( !( (eventPool.length == 0))) && (continue_)) {
			if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtEngageHM.class) {
				if (deferMask[0]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtDisengageHM.class) {
				if (deferMask[1]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtBrakePressed.class) {
				if (deferMask[2]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtClutchDepressed.class) {
				if (deferMask[3]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtAccelPressed.class) {
				if (deferMask[4]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtAccelReleased.class) {
				if (deferMask[5]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtSpeed.class) {
				if (deferMask[6]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			}
		}
		if ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		while ( !( (defered.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(defered));
			defered =  FiacreQueueUtil.dequeue(defered);
		}
		while ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		return result;
	}

	public static final int NUMBER_OF_EVENT_Actuation = 9;

	public static T_event_Actuation[] preProcess_eventPool_Actuation(T_event_Actuation[] eventPool, boolean[] deferMask) {
		T_event_Actuation[] defered = new T_event_Actuation[] {};
		T_event_Actuation[] result = new T_event_Actuation[] {};
		boolean continue_ = true;
		while (( !( (eventPool.length == 0))) && (continue_)) {
			if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtRequestEngagement.class) {
				if (deferMask[0]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDisengageActuation.class) {
				if (deferMask[1]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtResetActuation.class) {
				if (deferMask[2]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPause.class) {
				if (deferMask[3]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtPauseEnd.class) {
				if (deferMask[4]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSetA.class) {
				if (deferMask[5]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtIncA.class) {
				if (deferMask[6]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtDecA.class) {
				if (deferMask[7]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Actuation.EvtSpeedA.class) {
				if (deferMask[8]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			}
		}
		if ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		while ( !( (defered.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(defered));
			defered =  FiacreQueueUtil.dequeue(defered);
		}
		while ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		return result;
	}

	public static final int NUMBER_OF_EVENT_Car = 4;

	public static T_event_Car[] preProcess_eventPool_Car(T_event_Car[] eventPool, boolean[] deferMask) {
		T_event_Car[] defered = new T_event_Car[] {};
		T_event_Car[] result = new T_event_Car[] {};
		boolean continue_ = true;
		while (( !( (eventPool.length == 0))) && (continue_)) {
			if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Car.EvtSetSpeed.class) {
				if (deferMask[0]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Car.EvtTick.class) {
				if (deferMask[1]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Car.EvtIncreaseSpeed.class) {
				if (deferMask[2]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Car.EvtDecreaseSpeed.class) {
				if (deferMask[3]) {
					defered = FiacreQueueUtil.enqueue(defered, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			}
		}
		if ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		while ( !( (defered.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(defered));
			defered =  FiacreQueueUtil.dequeue(defered);
		}
		while ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		return result;
	}

	@Override
	public void unloadExternalLibrary() { }
	private Component root;

	@Override
	public Component getRoot(SymbolsTable symbols) {
		if (root == null) {
			symbols.newInformalId("evtBrakePressed");
			symbols.newInformalId("evtClutchDepressed");
			symbols.newInformalId("evtAccelPressed");
			symbols.newInformalId("evtAccelReleased");
			symbols.newInformalId("evtBtnStart");
			symbols.newInformalId("evtBtnResume");
			symbols.newInformalId("evtBtnSet");
			symbols.newInformalId("evtBtnInc");
			symbols.newInformalId("evtBtnDec");
			symbols.newInformalId("evtBtnDisengage");
			symbols.newInformalId("evtSetSpeed 0");
			symbols.newInformalId("evtSetSpeed 25");
			symbols.newInformalId("evtSetSpeed 100");
			symbols.newInformalId("evtSetSpeed 200");
			symbols.newInformalId("evtTick");
			root = new CruiseControlComposition(symbols);
		}
		return root;
	}

}

