package ccs_hand_crafted_standalone_system;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class CarBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Idle = 1;

	private final ReferencedArgument<T_event_Car[]> eventPoolRef;

	private final ReferencedArgument<T_event_HealthMonitoring[]> itsHealthMonitoringRef;

	private final ReferencedArgument<T_event_Actuation[]> itsActuationRef;

	public CarBehavior(SymbolsTable symbols, ReferencedArgument<T_event_Car[]> eventPool, ReferencedArgument<T_event_HealthMonitoring[]> itsHealthMonitoring, ReferencedArgument<T_event_Actuation[]> itsActuation) {
		super("Car", idSeed++, symbols);
		this.eventPoolRef = eventPool;
		this.itsHealthMonitoringRef = itsHealthMonitoring;
		this.itsActuationRef = itsActuation;
	}

	private final String[] stateNames = new String[] {"idle"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			CarConfiguration me = (CarConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] eventPool = eventPoolRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsActuationRef.ownerId] = true;
			modifiedBehaviors[eventPoolRef.ownerId] = true;
			modifiedBehaviors[itsHealthMonitoringRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CarConfiguration me = (CarConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CarConfiguration me = (CarConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] eventPool = eventPoolRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_Car(eventPool, new boolean[] {false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Car.EvtSetSpeed.class) {
					speed = ((T_event_Car.EvtSetSpeed)  FiacreQueueUtil.first(eventPool)).value;
					me.currentSpeed = speed;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Car.EvtTick.class) {
					if (( (itsHealthMonitoring.length >= 2 )) == false) {
						itsHealthMonitoring = FiacreQueueUtil.enqueue(id, itsHealthMonitoring,new T_event_HealthMonitoring.EvtSpeed(me.currentSpeed), actions);
					} else {
						if (true) { return false; }
					}
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtSpeedA(me.currentSpeed), actions);
					} else {
						if (true) { return false; }
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Car.EvtIncreaseSpeed.class) {
					speed = ((T_event_Car.EvtIncreaseSpeed)  FiacreQueueUtil.first(eventPool)).value;
					me.currentSpeed = (me.currentSpeed) + (speed);
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_Car.EvtDecreaseSpeed.class) {
					speed = ((T_event_Car.EvtDecreaseSpeed)  FiacreQueueUtil.first(eventPool)).value;
					me.currentSpeed = (me.currentSpeed) - (speed);
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				eventPoolRef.set(configuration, eventPool);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		CarConfiguration me = new CarConfiguration();
		int speed;
		//Initial action code.
		me.currentSpeed = 0;
		me.state = Idle;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CarConfiguration me = (CarConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case CarBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("\n\t- currentSpeed=");
		text.append(Integer.toString(me.currentSpeed));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CarConfiguration me = (CarConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case CarBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append(" currentSpeed=");
		text.append(Integer.toString(me.currentSpeed));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		CarConfiguration me = new CarConfiguration();
		me.state = boost.readShort();
		me.currentSpeed = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		CarConfiguration me = (CarConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.currentSpeed);
	}

}

