package ccs_hand_crafted_standalone_system;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class ControlPannelBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Idle = 1;

	private final ReferencedArgument<T_event_ControlPannel[]> eventPoolRef;

	private final ReferencedArgument<T_event_SystemCenter[]> itsSystemCenterRef;

	public ControlPannelBehavior(SymbolsTable symbols, ReferencedArgument<T_event_ControlPannel[]> eventPool, ReferencedArgument<T_event_SystemCenter[]> itsSystemCenter) {
		super("ControlPannel", idSeed++, symbols);
		this.eventPoolRef = eventPool;
		this.itsSystemCenterRef = itsSystemCenter;
	}

	private final String[] stateNames = new String[] {"idle"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ControlPannelConfiguration me = (ControlPannelConfiguration) configuration.behaviorConfigurations[id];
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_ControlPannel[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[itsSystemCenterRef.ownerId] = true;
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ControlPannelConfiguration me = (ControlPannelConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ControlPannelConfiguration me = (ControlPannelConfiguration) configuration.behaviorConfigurations[id];
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_ControlPannel[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length >= 2 )) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_ControlPannel(eventPool, new boolean[] {false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnStart.class) {
					itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtPowerOn(), actions);
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnStop.class) {
					itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtPowerOff(), actions);
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnResume.class) {
					itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtResume(), actions);
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnDisengage.class) {
					itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtDisengage(), actions);
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnSet.class) {
					itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtSet(), actions);
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnInc.class) {
					itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtInc(), actions);
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_ControlPannel.EvtBtnDec.class) {
					itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtDec(), actions);
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		ControlPannelConfiguration me = new ControlPannelConfiguration();
		//Initial action code.
		me.state = Idle;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ControlPannelConfiguration me = (ControlPannelConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ControlPannelBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ControlPannelConfiguration me = (ControlPannelConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ControlPannelBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		ControlPannelConfiguration me = new ControlPannelConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		ControlPannelConfiguration me = (ControlPannelConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

