package ccs_hand_crafted_standalone_system;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class CruiseControlBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public CruiseControlBehavior(SymbolsTable symbols) {
		super("CruiseControl", idSeed++, symbols);
	}

	public ReferencedArgument<T_event_Actuation[]> getActuation_1Ref() {
return 		new ReferencedArgument<T_event_Actuation[]>(id) {
			@Override
			public T_event_Actuation[] get(Configuration configuration) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.actuation_1;
			}

			@Override
			public void set(Configuration configuration, T_event_Actuation[] value) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				me.actuation_1 = value;
			}

			@Override
			public  Class<T_event_Actuation[]> getArgumentType() {
				return T_event_Actuation[].class;
			}

		}

;	}

	public ReferencedArgument<T_event_SystemCenter[]> getSystemCenter_1Ref() {
return 		new ReferencedArgument<T_event_SystemCenter[]>(id) {
			@Override
			public T_event_SystemCenter[] get(Configuration configuration) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.systemCenter_1;
			}

			@Override
			public void set(Configuration configuration, T_event_SystemCenter[] value) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				me.systemCenter_1 = value;
			}

			@Override
			public  Class<T_event_SystemCenter[]> getArgumentType() {
				return T_event_SystemCenter[].class;
			}

		}

;	}

	public ReferencedArgument<T_event_ControlPannel[]> getControlPannel_1Ref() {
return 		new ReferencedArgument<T_event_ControlPannel[]>(id) {
			@Override
			public T_event_ControlPannel[] get(Configuration configuration) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.controlPannel_1;
			}

			@Override
			public void set(Configuration configuration, T_event_ControlPannel[] value) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				me.controlPannel_1 = value;
			}

			@Override
			public  Class<T_event_ControlPannel[]> getArgumentType() {
				return T_event_ControlPannel[].class;
			}

		}

;	}

	public ReferencedArgument<T_event_HealthMonitoring[]> getHealthMonitoring_1Ref() {
return 		new ReferencedArgument<T_event_HealthMonitoring[]>(id) {
			@Override
			public T_event_HealthMonitoring[] get(Configuration configuration) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.healthMonitoring_1;
			}

			@Override
			public void set(Configuration configuration, T_event_HealthMonitoring[] value) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				me.healthMonitoring_1 = value;
			}

			@Override
			public  Class<T_event_HealthMonitoring[]> getArgumentType() {
				return T_event_HealthMonitoring[].class;
			}

		}

;	}

	public ReferencedArgument<T_event_Car[]> getCar_1Ref() {
return 		new ReferencedArgument<T_event_Car[]>(id) {
			@Override
			public T_event_Car[] get(Configuration configuration) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.car_1;
			}

			@Override
			public void set(Configuration configuration, T_event_Car[] value) {
				CruiseControlConfiguration me = (CruiseControlConfiguration) configuration.behaviorConfigurations[ownerId];
				me.car_1 = value;
			}

			@Override
			public  Class<T_event_Car[]> getArgumentType() {
				return T_event_Car[].class;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		CruiseControlConfiguration me = new CruiseControlConfiguration();
		//Initial action code.
		me.controlPannel_1 = new T_event_ControlPannel[] {};
		me.systemCenter_1 = new T_event_SystemCenter[] {};
		me.healthMonitoring_1 = new T_event_HealthMonitoring[] {};
		me.actuation_1 = new T_event_Actuation[] {};
		me.car_1 = new T_event_Car[] {};
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CruiseControlConfiguration me = (CruiseControlConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- ControlPannel_1=");
		text.append(Arrays.deepToString(me.controlPannel_1));
		text.append("\n\t- SystemCenter_1=");
		text.append(Arrays.deepToString(me.systemCenter_1));
		text.append("\n\t- HealthMonitoring_1=");
		text.append(Arrays.deepToString(me.healthMonitoring_1));
		text.append("\n\t- Actuation_1=");
		text.append(Arrays.deepToString(me.actuation_1));
		text.append("\n\t- Car_1=");
		text.append(Arrays.deepToString(me.car_1));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CruiseControlConfiguration me = (CruiseControlConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" ControlPannel_1=");
		text.append(Arrays.deepToString(me.controlPannel_1));
		text.append(" SystemCenter_1=");
		text.append(Arrays.deepToString(me.systemCenter_1));
		text.append(" HealthMonitoring_1=");
		text.append(Arrays.deepToString(me.healthMonitoring_1));
		text.append(" Actuation_1=");
		text.append(Arrays.deepToString(me.actuation_1));
		text.append(" Car_1=");
		text.append(Arrays.deepToString(me.car_1));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		CruiseControlConfiguration me = new CruiseControlConfiguration();
		me.controlPannel_1 = new T_event_ControlPannel[CCS_hand_crafted_standalone_systemRoot.SIZE_eventPool_ControlPannel];
		me.controlPannel_1 = new T_event_ControlPannel[boost.readInt()];
		for (int i=0; i<me.controlPannel_1.length; i++) {
			me.controlPannel_1[i] = boost.readObject(T_event_ControlPannel.class);
		}
		me.systemCenter_1 = new T_event_SystemCenter[CCS_hand_crafted_standalone_systemRoot.SIZE_eventPool_SystemCenter];
		me.systemCenter_1 = new T_event_SystemCenter[boost.readInt()];
		for (int i=0; i<me.systemCenter_1.length; i++) {
			me.systemCenter_1[i] = boost.readObject(T_event_SystemCenter.class);
		}
		me.healthMonitoring_1 = new T_event_HealthMonitoring[CCS_hand_crafted_standalone_systemRoot.SIZE_eventPool_HealthMonitoring];
		me.healthMonitoring_1 = new T_event_HealthMonitoring[boost.readInt()];
		for (int i=0; i<me.healthMonitoring_1.length; i++) {
			me.healthMonitoring_1[i] = boost.readObject(T_event_HealthMonitoring.class);
		}
		me.actuation_1 = new T_event_Actuation[CCS_hand_crafted_standalone_systemRoot.SIZE_eventPool_Actuation];
		me.actuation_1 = new T_event_Actuation[boost.readInt()];
		for (int i=0; i<me.actuation_1.length; i++) {
			me.actuation_1[i] = boost.readObject(T_event_Actuation.class);
		}
		me.car_1 = new T_event_Car[CCS_hand_crafted_standalone_systemRoot.SIZE_eventPool_Car];
		me.car_1 = new T_event_Car[boost.readInt()];
		for (int i=0; i<me.car_1.length; i++) {
			me.car_1[i] = boost.readObject(T_event_Car.class);
		}
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		CruiseControlConfiguration me = (CruiseControlConfiguration) processConfiguration;
		boost.writeInt(me.controlPannel_1.length);
		for (int i=0; i<me.controlPannel_1.length; i++) {
			boost.writeObject(me.controlPannel_1[i]);
		}
		boost.writeInt(me.systemCenter_1.length);
		for (int i=0; i<me.systemCenter_1.length; i++) {
			boost.writeObject(me.systemCenter_1[i]);
		}
		boost.writeInt(me.healthMonitoring_1.length);
		for (int i=0; i<me.healthMonitoring_1.length; i++) {
			boost.writeObject(me.healthMonitoring_1[i]);
		}
		boost.writeInt(me.actuation_1.length);
		for (int i=0; i<me.actuation_1.length; i++) {
			boost.writeObject(me.actuation_1[i]);
		}
		boost.writeInt(me.car_1.length);
		for (int i=0; i<me.car_1.length; i++) {
			boost.writeObject(me.car_1[i]);
		}
	}

}

