package ccs_hand_crafted_standalone_system;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class CruiseControlComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public CruiseControlComposition(SymbolsTable symbols) {
		CruiseControlBehavior me = new CruiseControlBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		channels = new Channel[] {  };
		
		components = new Component[] {
				me,
				new ControlPannelBehavior(symbols, me.getControlPannel_1Ref(), me.getSystemCenter_1Ref()),
				new SystemCenterBehavior(symbols, me.getSystemCenter_1Ref(), me.getHealthMonitoring_1Ref(), me.getActuation_1Ref()),
				new HealthMonitoringBehavior(symbols, me.getHealthMonitoring_1Ref(), me.getSystemCenter_1Ref(), me.getActuation_1Ref()),
				new ActuationBehavior(symbols, me.getActuation_1Ref(), me.getSystemCenter_1Ref(), me.getCar_1Ref()),
				new CarBehavior(symbols, me.getCar_1Ref(), me.getHealthMonitoring_1Ref(), me.getActuation_1Ref()),
				new UserBehavior(symbols, me.getHealthMonitoring_1Ref(), me.getControlPannel_1Ref(), me.getCar_1Ref(), me.getSystemCenter_1Ref(), me.getActuation_1Ref())
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

