package ccs_hand_crafted_standalone_system;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class CruiseControlConfiguration extends BehaviorConfiguration {

	public T_event_ControlPannel[] controlPannel_1;

	public T_event_SystemCenter[] systemCenter_1;

	public T_event_HealthMonitoring[] healthMonitoring_1;

	public T_event_Actuation[] actuation_1;

	public T_event_Car[] car_1;

	//Create initial configuration
	public CruiseControlConfiguration() {
		this.controlPannel_1 = new T_event_ControlPannel[]{};
		this.systemCenter_1 = new T_event_SystemCenter[]{};
		this.healthMonitoring_1 = new T_event_HealthMonitoring[]{};
		this.actuation_1 = new T_event_Actuation[]{};
		this.car_1 = new T_event_Car[]{};
	}

	//Create configuration as a copy
	public CruiseControlConfiguration(CruiseControlConfiguration other) {
		this.controlPannel_1 = new T_event_ControlPannel[other.controlPannel_1.length];
		for (int i=0; i<other.controlPannel_1.length; i++) {
			this.controlPannel_1[i] = T_event_ControlPannel.copy(other.controlPannel_1[i]);
		}
		this.systemCenter_1 = new T_event_SystemCenter[other.systemCenter_1.length];
		for (int i=0; i<other.systemCenter_1.length; i++) {
			this.systemCenter_1[i] = T_event_SystemCenter.copy(other.systemCenter_1[i]);
		}
		this.healthMonitoring_1 = new T_event_HealthMonitoring[other.healthMonitoring_1.length];
		for (int i=0; i<other.healthMonitoring_1.length; i++) {
			this.healthMonitoring_1[i] = T_event_HealthMonitoring.copy(other.healthMonitoring_1[i]);
		}
		this.actuation_1 = new T_event_Actuation[other.actuation_1.length];
		for (int i=0; i<other.actuation_1.length; i++) {
			this.actuation_1[i] = T_event_Actuation.copy(other.actuation_1[i]);
		}
		this.car_1 = new T_event_Car[other.car_1.length];
		for (int i=0; i<other.car_1.length; i++) {
			this.car_1[i] = T_event_Car.copy(other.car_1[i]);
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new CruiseControlConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof CruiseControlConfiguration) {
			CruiseControlConfiguration other = (CruiseControlConfiguration) object;
			if (!Arrays.deepEquals(controlPannel_1, other.controlPannel_1)) return false;
			if (!Arrays.deepEquals(systemCenter_1, other.systemCenter_1)) return false;
			if (!Arrays.deepEquals(healthMonitoring_1, other.healthMonitoring_1)) return false;
			if (!Arrays.deepEquals(actuation_1, other.actuation_1)) return false;
			if (!Arrays.deepEquals(car_1, other.car_1)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.deepHashCode(controlPannel_1);
		total = total * 37 + Arrays.deepHashCode(systemCenter_1);
		total = total * 37 + Arrays.deepHashCode(healthMonitoring_1);
		total = total * 37 + Arrays.deepHashCode(actuation_1);
		total = total * 37 + Arrays.deepHashCode(car_1);
		return total;
	}

}

