package ccs_hand_crafted_standalone_system;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class HealthMonitoringBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Disengaged = 1;

	public static final short Engaged = 2;

	public static final short DisengageRequested = 3;

	private final ReferencedArgument<T_event_HealthMonitoring[]> eventPoolRef;

	private final ReferencedArgument<T_event_SystemCenter[]> itsSystemCenterRef;

	private final ReferencedArgument<T_event_Actuation[]> itsActuationRef;

	public HealthMonitoringBehavior(SymbolsTable symbols, ReferencedArgument<T_event_HealthMonitoring[]> eventPool, ReferencedArgument<T_event_SystemCenter[]> itsSystemCenter, ReferencedArgument<T_event_Actuation[]> itsActuation) {
		super("HealthMonitoring", idSeed++, symbols);
		this.eventPoolRef = eventPool;
		this.itsSystemCenterRef = itsSystemCenter;
		this.itsActuationRef = itsActuation;
	}

	private final String[] stateNames = new String[] {"disengaged", "engaged", "disengageRequested"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			T_event_HealthMonitoring[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Disengaged) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_HealthMonitoring[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_HealthMonitoring(eventPool, new boolean[] {false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtEngageHM.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Engaged;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtDisengageHM.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtBrakePressed.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtClutchDepressed.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtAccelPressed.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtAccelReleased.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtSpeed.class) {
					speed = ((T_event_HealthMonitoring.EvtSpeed)  FiacreQueueUtil.first(eventPool)).value;
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Disengaged;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_HealthMonitoring[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[itsSystemCenterRef.ownerId] = true;
			modifiedBehaviors[itsActuationRef.ownerId] = true;
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Engaged) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_HealthMonitoring[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_HealthMonitoring(eventPool, new boolean[] {false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtEngageHM.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtDisengageHM.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Disengaged;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtBrakePressed.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsSystemCenter.length >= 2 )) == false) {
						itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtDisengage(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = DisengageRequested;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtClutchDepressed.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsSystemCenter.length >= 2 )) == false) {
						itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtDisengage(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = DisengageRequested;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtAccelPressed.class) {
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtPause(), actions);
					} else {
						if (true) { return false; }
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtAccelReleased.class) {
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtPauseEnd(), actions);
					} else {
						if (true) { return false; }
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtSpeed.class) {
					speed = ((T_event_HealthMonitoring.EvtSpeed)  FiacreQueueUtil.first(eventPool)).value;
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (((speed) < (40)) || ((speed) > (180))) {
						if (( (itsSystemCenter.length >= 2 )) == false) {
							itsSystemCenter = FiacreQueueUtil.enqueue(id, itsSystemCenter,new T_event_SystemCenter.EvtDisengage(), actions);
						} else {
							if (true) { return false; }
						}
						me.state = DisengageRequested;
						if (true) return true;
					} else {
						me.state = Engaged;
						if (true) return true;
					}
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Engaged;
				if (true) return true;
			} finally {
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsActuationRef.set(configuration, itsActuation);
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			T_event_HealthMonitoring[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DisengageRequested) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) configuration.behaviorConfigurations[id];
			int speed =  - (1);
			T_event_HealthMonitoring[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_HealthMonitoring(eventPool, new boolean[] {false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtEngageHM.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtDisengageHM.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Disengaged;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtBrakePressed.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtClutchDepressed.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtAccelPressed.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtAccelReleased.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_HealthMonitoring.EvtSpeed.class) {
					speed = ((T_event_HealthMonitoring.EvtSpeed)  FiacreQueueUtil.first(eventPool)).value;
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = DisengageRequested;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		HealthMonitoringConfiguration me = new HealthMonitoringConfiguration();
		int speed;
		//Initial action code.
		me.state = Disengaged;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case HealthMonitoringBehavior.Disengaged: 
			text.append("@disengaged,");
			break;
		case HealthMonitoringBehavior.Engaged: 
			text.append("@engaged,");
			break;
		case HealthMonitoringBehavior.DisengageRequested: 
			text.append("@disengageRequested,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case HealthMonitoringBehavior.Disengaged: 
			text.append("@disengaged,");
			break;
		case HealthMonitoringBehavior.Engaged: 
			text.append("@engaged,");
			break;
		case HealthMonitoringBehavior.DisengageRequested: 
			text.append("@disengageRequested,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		HealthMonitoringConfiguration me = new HealthMonitoringConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		HealthMonitoringConfiguration me = (HealthMonitoringConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

