package ccs_hand_crafted_standalone_system;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class SystemCenterBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Off = 1;

	public static final short Idle = 2;

	public static final short RequestingEngagement = 3;

	public static final short Engaged = 4;

	private final ReferencedArgument<T_event_SystemCenter[]> eventPoolRef;

	private final ReferencedArgument<T_event_HealthMonitoring[]> itsHealthMonitoringRef;

	private final ReferencedArgument<T_event_Actuation[]> itsActuationRef;

	public SystemCenterBehavior(SymbolsTable symbols, ReferencedArgument<T_event_SystemCenter[]> eventPool, ReferencedArgument<T_event_HealthMonitoring[]> itsHealthMonitoring, ReferencedArgument<T_event_Actuation[]> itsActuation) {
		super("SystemCenter", idSeed++, symbols);
		this.eventPoolRef = eventPool;
		this.itsHealthMonitoringRef = itsHealthMonitoring;
		this.itsActuationRef = itsActuation;
	}

	private final String[] stateNames = new String[] {"off", "idle", "requestingEngagement", "engaged"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			T_event_SystemCenter[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Off) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			T_event_SystemCenter[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_SystemCenter(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOn.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Idle;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOff.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtResume.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtAck.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtNAck.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDisengage.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtSet.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtInc.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDec.class) {
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Off;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_SystemCenter[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[itsActuationRef.ownerId] = true;
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_SystemCenter[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_SystemCenter(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOn.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOff.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtResetActuation(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = Off;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtResume.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtRequestEngagement(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = RequestingEngagement;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtAck.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtNAck.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDisengage.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtSet.class) {
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtSetA(), actions);
					} else {
						if (true) { return false; }
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtInc.class) {
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtIncA(), actions);
					} else {
						if (true) { return false; }
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDec.class) {
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtDecA(), actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			T_event_SystemCenter[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[itsHealthMonitoringRef.ownerId] = true;
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != RequestingEngagement) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			T_event_SystemCenter[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_SystemCenter(eventPool, new boolean[] {false, true, false, false, false, true, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOn.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtResume.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtAck.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsHealthMonitoring.length >= 2 )) == false) {
						itsHealthMonitoring = FiacreQueueUtil.enqueue(id, itsHealthMonitoring,new T_event_HealthMonitoring.EvtEngageHM(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = Engaged;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtNAck.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					me.state = Idle;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtSet.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtInc.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDec.class) {
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = RequestingEngagement;
				if (true) return true;
			} finally {
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			T_event_SystemCenter[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[itsActuationRef.ownerId] = true;
			modifiedBehaviors[itsHealthMonitoringRef.ownerId] = true;
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Engaged) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SystemCenterConfiguration me = (SystemCenterConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			T_event_SystemCenter[] eventPool = eventPoolRef.get(configuration);
			try {
				if (( (eventPool.length == 0)) == false) {
				} else {
					if (true) { return false; }
				}
				eventPool = CCS_hand_crafted_standalone_systemRoot.preProcess_eventPool_SystemCenter(eventPool, new boolean[] {false, false, false, false, false, false, false, false, false});
				if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOn.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtPowerOff.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsHealthMonitoring.length >= 2 )) == false) {
						itsHealthMonitoring = FiacreQueueUtil.enqueue(id, itsHealthMonitoring,new T_event_HealthMonitoring.EvtDisengageHM(), actions);
					} else {
						if (true) { return false; }
					}
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtDisengageActuation(), actions);
					} else {
						if (true) { return false; }
					}
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtResetActuation(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = Off;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtResume.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtAck.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtNAck.class) {
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDisengage.class) {
					eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					if (( (itsHealthMonitoring.length >= 2 )) == false) {
						itsHealthMonitoring = FiacreQueueUtil.enqueue(id, itsHealthMonitoring,new T_event_HealthMonitoring.EvtDisengageHM(), actions);
					} else {
						if (true) { return false; }
					}
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtDisengageActuation(), actions);
					} else {
						if (true) { return false; }
					}
					me.state = Idle;
					if (true) return true;
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtSet.class) {
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtSetA(), actions);
					} else {
						if (true) { return false; }
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtInc.class) {
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtIncA(), actions);
					} else {
						if (true) { return false; }
					}
				} else if (( FiacreQueueUtil.first(eventPool).getClass()) == T_event_SystemCenter.EvtDec.class) {
					if (( (itsActuation.length >= 3 )) == false) {
						itsActuation = FiacreQueueUtil.enqueue(id, itsActuation,new T_event_Actuation.EvtDecA(), actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
				me.state = Engaged;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		SystemCenterConfiguration me = new SystemCenterConfiguration();
		//Initial action code.
		me.state = Off;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SystemCenterConfiguration me = (SystemCenterConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case SystemCenterBehavior.Off: 
			text.append("@off,");
			break;
		case SystemCenterBehavior.Idle: 
			text.append("@idle,");
			break;
		case SystemCenterBehavior.RequestingEngagement: 
			text.append("@requestingEngagement,");
			break;
		case SystemCenterBehavior.Engaged: 
			text.append("@engaged,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SystemCenterConfiguration me = (SystemCenterConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case SystemCenterBehavior.Off: 
			text.append("@off,");
			break;
		case SystemCenterBehavior.Idle: 
			text.append("@idle,");
			break;
		case SystemCenterBehavior.RequestingEngagement: 
			text.append("@requestingEngagement,");
			break;
		case SystemCenterBehavior.Engaged: 
			text.append("@engaged,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		SystemCenterConfiguration me = new SystemCenterConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		SystemCenterConfiguration me = (SystemCenterConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

