package ccs_hand_crafted_standalone_system;

import org.xid.basics.serializer.BoostObject;
import org.xid.basics.serializer.Boost;

public abstract class T_event_Car implements BoostObject {

	public static class EvtSetSpeed extends T_event_Car {

		public int value;

		public EvtSetSpeed() {
			this.value = 0;
		}

		public EvtSetSpeed(int value) {
			this.value = value;
		}

		public EvtSetSpeed(EvtSetSpeed other) {
			this.value = other.value;
		}

		public EvtSetSpeed(Boost boost) {
			boost.register(this);
			this.value = boost.readInt();
		}

		public void writeToBoost(Boost boost) {
			boost.writeInt(value);
		}

		@Override
		public boolean equals(Object object) {
			if (object instanceof EvtSetSpeed) {
				EvtSetSpeed other = (EvtSetSpeed) object;
				if (value != other.value) return false;
				return true;
			}
			return false;
		}

		@Override
		public int hashCode() {
			int total = 423088;
			total = total * 37 + value;
			return total;
		}

		public String toString() {
			StringBuilder text = new StringBuilder();
			text.append("{evtSetSpeed");
			text.append("@");
			text.append(Integer.toString(value));
			text.append("}");
			return text.toString();
		}

	}

	public static class EvtTick extends T_event_Car {

		public EvtTick() {
		}

		public EvtTick(EvtTick other) {
		}

		public EvtTick(Boost boost) {
			boost.register(this);
		}

		public void writeToBoost(Boost boost) {
		}

		@Override
		public boolean equals(Object object) {
			return object != null && object.getClass() == EvtTick.class;
		}

		@Override
		public int hashCode() {
			int total = 418802;
			return total;
		}

		public String toString() {
			StringBuilder text = new StringBuilder();
			text.append("{evtTick");
			text.append("}");
			return text.toString();
		}

	}

	public static class EvtIncreaseSpeed extends T_event_Car {

		public int value;

		public EvtIncreaseSpeed() {
			this.value = 0;
		}

		public EvtIncreaseSpeed(int value) {
			this.value = value;
		}

		public EvtIncreaseSpeed(EvtIncreaseSpeed other) {
			this.value = other.value;
		}

		public EvtIncreaseSpeed(Boost boost) {
			boost.register(this);
			this.value = boost.readInt();
		}

		public void writeToBoost(Boost boost) {
			boost.writeInt(value);
		}

		@Override
		public boolean equals(Object object) {
			if (object instanceof EvtIncreaseSpeed) {
				EvtIncreaseSpeed other = (EvtIncreaseSpeed) object;
				if (value != other.value) return false;
				return true;
			}
			return false;
		}

		@Override
		public int hashCode() {
			int total = 140668;
			total = total * 37 + value;
			return total;
		}

		public String toString() {
			StringBuilder text = new StringBuilder();
			text.append("{evtIncreaseSpeed");
			text.append("@");
			text.append(Integer.toString(value));
			text.append("}");
			return text.toString();
		}

	}

	public static class EvtDecreaseSpeed extends T_event_Car {

		public int value;

		public EvtDecreaseSpeed() {
			this.value = 0;
		}

		public EvtDecreaseSpeed(int value) {
			this.value = value;
		}

		public EvtDecreaseSpeed(EvtDecreaseSpeed other) {
			this.value = other.value;
		}

		public EvtDecreaseSpeed(Boost boost) {
			boost.register(this);
			this.value = boost.readInt();
		}

		public void writeToBoost(Boost boost) {
			boost.writeInt(value);
		}

		@Override
		public boolean equals(Object object) {
			if (object instanceof EvtDecreaseSpeed) {
				EvtDecreaseSpeed other = (EvtDecreaseSpeed) object;
				if (value != other.value) return false;
				return true;
			}
			return false;
		}

		@Override
		public int hashCode() {
			int total = 794992;
			total = total * 37 + value;
			return total;
		}

		public String toString() {
			StringBuilder text = new StringBuilder();
			text.append("{evtDecreaseSpeed");
			text.append("@");
			text.append(Integer.toString(value));
			text.append("}");
			return text.toString();
		}

	}

	public static T_event_Car copy(T_event_Car other) {
		if (other == null) {
			return null;
		}
		else if ( other.getClass() == EvtSetSpeed.class ) {
			return new EvtSetSpeed((EvtSetSpeed) other);
		}
		else if ( other.getClass() == EvtTick.class ) {
			return new EvtTick((EvtTick) other);
		}
		else if ( other.getClass() == EvtIncreaseSpeed.class ) {
			return new EvtIncreaseSpeed((EvtIncreaseSpeed) other);
		}
		else if ( other.getClass() == EvtDecreaseSpeed.class ) {
			return new EvtDecreaseSpeed((EvtDecreaseSpeed) other);
		}
		throw new IllegalArgumentException("Unknown constructor for 'T_event_Car'.");
	}

}

