package ccs_hand_crafted_standalone_system;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class UserBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Idle = 1;

	private final short informal0;

	private final short informal1;

	private final short informal2;

	private final short informal3;

	private final short informal4;

	private final short informal5;

	private final short informal6;

	private final short informal7;

	private final short informal8;

	private final short informal9;

	private final short informal10;

	private final short informal11;

	private final short informal12;

	private final short informal13;

	private final short informal14;

	private final ReferencedArgument<T_event_HealthMonitoring[]> itsHealthMonitoringRef;

	private final ReferencedArgument<T_event_ControlPannel[]> itsControlPannelRef;

	private final ReferencedArgument<T_event_Car[]> itsCarRef;

	private final ReferencedArgument<T_event_SystemCenter[]> itsSystemCenterRef;

	private final ReferencedArgument<T_event_Actuation[]> itsActuationRef;

	public UserBehavior(SymbolsTable symbols, ReferencedArgument<T_event_HealthMonitoring[]> itsHealthMonitoring, ReferencedArgument<T_event_ControlPannel[]> itsControlPannel, ReferencedArgument<T_event_Car[]> itsCar, ReferencedArgument<T_event_SystemCenter[]> itsSystemCenter, ReferencedArgument<T_event_Actuation[]> itsActuation) {
		super("User", idSeed++, symbols);
		this.itsHealthMonitoringRef = itsHealthMonitoring;
		this.itsControlPannelRef = itsControlPannel;
		this.itsCarRef = itsCar;
		this.itsSystemCenterRef = itsSystemCenter;
		this.itsActuationRef = itsActuation;
		informal0 = symbols.getInformalId("evtBrakePressed");
		informal1 = symbols.getInformalId("evtClutchDepressed");
		informal2 = symbols.getInformalId("evtAccelPressed");
		informal3 = symbols.getInformalId("evtAccelReleased");
		informal4 = symbols.getInformalId("evtBtnStart");
		informal5 = symbols.getInformalId("evtBtnResume");
		informal6 = symbols.getInformalId("evtBtnSet");
		informal7 = symbols.getInformalId("evtBtnInc");
		informal8 = symbols.getInformalId("evtBtnDec");
		informal9 = symbols.getInformalId("evtBtnDisengage");
		informal10 = symbols.getInformalId("evtSetSpeed 0");
		informal11 = symbols.getInformalId("evtSetSpeed 25");
		informal12 = symbols.getInformalId("evtSetSpeed 100");
		informal13 = symbols.getInformalId("evtSetSpeed 200");
		informal14 = symbols.getInformalId("evtTick");
	}

	private final String[] stateNames = new String[] {"idle"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsHealthMonitoringRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal0));
				itsHealthMonitoring = FiacreQueueUtil.enqueue(id, itsHealthMonitoring,new T_event_HealthMonitoring.EvtBrakePressed(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsHealthMonitoringRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal1));
				itsHealthMonitoring = FiacreQueueUtil.enqueue(id, itsHealthMonitoring,new T_event_HealthMonitoring.EvtClutchDepressed(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsHealthMonitoringRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal2));
				itsHealthMonitoring = FiacreQueueUtil.enqueue(id, itsHealthMonitoring,new T_event_HealthMonitoring.EvtAccelPressed(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsHealthMonitoringRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal3));
				itsHealthMonitoring = FiacreQueueUtil.enqueue(id, itsHealthMonitoring,new T_event_HealthMonitoring.EvtAccelReleased(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsControlPannelRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal4));
				itsControlPannel = FiacreQueueUtil.enqueue(id, itsControlPannel,new T_event_ControlPannel.EvtBtnStart(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsControlPannelRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal5));
				itsControlPannel = FiacreQueueUtil.enqueue(id, itsControlPannel,new T_event_ControlPannel.EvtBtnResume(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsControlPannelRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal6));
				itsControlPannel = FiacreQueueUtil.enqueue(id, itsControlPannel,new T_event_ControlPannel.EvtBtnSet(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsControlPannelRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal7));
				itsControlPannel = FiacreQueueUtil.enqueue(id, itsControlPannel,new T_event_ControlPannel.EvtBtnInc(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsControlPannelRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal8));
				itsControlPannel = FiacreQueueUtil.enqueue(id, itsControlPannel,new T_event_ControlPannel.EvtBtnDec(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsControlPannelRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal9));
				itsControlPannel = FiacreQueueUtil.enqueue(id, itsControlPannel,new T_event_ControlPannel.EvtBtnDisengage(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsCarRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal10));
				itsCar = FiacreQueueUtil.enqueue(id, itsCar,new T_event_Car.EvtSetSpeed(0), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsCarRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal11));
				itsCar = FiacreQueueUtil.enqueue(id, itsCar,new T_event_Car.EvtSetSpeed(25), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsCarRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal12));
				itsCar = FiacreQueueUtil.enqueue(id, itsCar,new T_event_Car.EvtSetSpeed(80), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsCarRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal12));
				itsCar = FiacreQueueUtil.enqueue(id, itsCar,new T_event_Car.EvtSetSpeed(120), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsCarRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal13));
				itsCar = FiacreQueueUtil.enqueue(id, itsCar,new T_event_Car.EvtSetSpeed(200), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			modifiedBehaviors[itsCarRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final UserConfiguration me = (UserConfiguration) configuration.behaviorConfigurations[id];
			T_event_Actuation[] itsActuation = itsActuationRef.get(configuration);
			T_event_Car[] itsCar = itsCarRef.get(configuration);
			T_event_ControlPannel[] itsControlPannel = itsControlPannelRef.get(configuration);
			T_event_SystemCenter[] itsSystemCenter = itsSystemCenterRef.get(configuration);
			T_event_HealthMonitoring[] itsHealthMonitoring = itsHealthMonitoringRef.get(configuration);
			try {
				if (( (itsHealthMonitoring.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsControlPannel.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsCar.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsSystemCenter.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				if (( (itsActuation.length == 0)) == true) {
				} else {
					if (true) { return false; }
				}
				actions.add(new InformalAction(id, informal14));
				itsCar = FiacreQueueUtil.enqueue(id, itsCar,new T_event_Car.EvtTick(), actions);
				me.state = Idle;
				if (true) return true;
			} finally {
				itsActuationRef.set(configuration, itsActuation);
				itsCarRef.set(configuration, itsCar);
				itsControlPannelRef.set(configuration, itsControlPannel);
				itsSystemCenterRef.set(configuration, itsSystemCenter);
				itsHealthMonitoringRef.set(configuration, itsHealthMonitoring);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		UserConfiguration me = new UserConfiguration();
		//Initial action code.
		me.state = Idle;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		UserConfiguration me = (UserConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case UserBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		UserConfiguration me = (UserConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case UserBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		UserConfiguration me = new UserConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		UserConfiguration me = (UserConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

