package crossed_sync;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class SysComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public SysComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("sys", idSeed++);
		BroadcastChannel c1 = new BroadcastChannel(name+":c1", symbols, 1, 1);
		BroadcastChannel c2 = new BroadcastChannel(name+":c2", symbols, 1, 1);
		channels = new Channel[] { c1, c2,  };
		
		components = new Component[] {
				new PBehavior(symbols, c1, c2),
				new PBehavior(symbols, c2, c1)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

