package abp;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class AbpComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public AbpComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("abp", idSeed++);
		BroadcastChannel minp = new BroadcastChannel(name+":minp", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel mout = new BroadcastChannel(name+":mout", symbols, 1, 1, 0, false, 1, false);
		BroadcastChannel ainp = new BroadcastChannel(name+":ainp", symbols, 1, 1, 0, false, 2, false);
		BroadcastChannel aout = new BroadcastChannel(name+":aout", symbols, 1, 1, 0, false, 1, false);
		channels = new Channel[] { minp, mout, ainp, aout,  };
		
		components = new Component[] {
				new SenderBehavior(symbols, minp, aout),
				new BufferBehavior(symbols, minp, mout),
				new BufferBehavior(symbols, ainp, aout),
				new ReceiverBehavior(symbols, mout, ainp)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

