package abp;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class BufferConfiguration extends BehaviorConfiguration {

	public short state;

	public boolean[] buff;

	public boolean pkt;

	//Create initial configuration
	public BufferConfiguration() {
		this.buff = new boolean[] {};
		this.pkt = false;
	}

	//Create configuration as a copy
	public BufferConfiguration(BufferConfiguration other) {
		this.state = other.state;
		this.buff = new boolean[other.buff.length];
		for (int i=0; i<other.buff.length; i++) {
			this.buff[i] = other.buff[i];
		}
		this.pkt = other.pkt;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new BufferConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof BufferConfiguration) {
			BufferConfiguration other = (BufferConfiguration) object;
			if (state != other.state) return false;
			if (!Arrays.equals(buff, other.buff)) return false;
			if (pkt != other.pkt) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + Arrays.hashCode(buff);
		total = total * 37 + (pkt? 1 : 0);
		return total;
	}

}

