package abp;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class ReceiverConfiguration extends BehaviorConfiguration {

	public short state;

	public boolean rsn;

	public boolean m;

	//Create initial configuration
	public ReceiverConfiguration() {
		this.rsn = false;
		this.m = true;
	}

	//Create configuration as a copy
	public ReceiverConfiguration(ReceiverConfiguration other) {
		this.state = other.state;
		this.rsn = other.rsn;
		this.m = other.m;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new ReceiverConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof ReceiverConfiguration) {
			ReceiverConfiguration other = (ReceiverConfiguration) object;
			if (state != other.state) return false;
			if (rsn != other.rsn) return false;
			if (m != other.m) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + (rsn? 1 : 0);
		total = total * 37 + (m? 1 : 0);
		return total;
	}

}

