package abp;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class SenderConfiguration extends BehaviorConfiguration {

	public short state;

	public boolean ssn;

	public boolean n;

	//Create initial configuration
	public SenderConfiguration() {
		this.ssn = false;
		this.n = false;
	}

	//Create configuration as a copy
	public SenderConfiguration(SenderConfiguration other) {
		this.state = other.state;
		this.ssn = other.ssn;
		this.n = other.n;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new SenderConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof SenderConfiguration) {
			SenderConfiguration other = (SenderConfiguration) object;
			if (state != other.state) return false;
			if (ssn != other.ssn) return false;
			if (n != other.n) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + (ssn? 1 : 0);
		total = total * 37 + (n? 1 : 0);
		return total;
	}

}

