package bridge_none_in;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentInt;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class BridgeBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public BridgeBehavior(SymbolsTable symbols) {
		super("bridge", idSeed++, symbols);
	}

	public ReferencedArgumentInt getRightRef() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				BridgeConfiguration me = (BridgeConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.right;
			}

			@Override
			public void set(Configuration configuration, int value) {
				BridgeConfiguration me = (BridgeConfiguration) configuration.behaviorConfigurations[ownerId];
				me.right = value;
			}

		}

;	}

	public ReferencedArgumentInt getLeftRef() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				BridgeConfiguration me = (BridgeConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.left;
			}

			@Override
			public void set(Configuration configuration, int value) {
				BridgeConfiguration me = (BridgeConfiguration) configuration.behaviorConfigurations[ownerId];
				me.left = value;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		BridgeConfiguration me = new BridgeConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		BridgeConfiguration me = (BridgeConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- left=");
		text.append(Integer.toString(me.left));
		text.append("\n\t- right=");
		text.append(Integer.toString(me.right));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		BridgeConfiguration me = (BridgeConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" left=");
		text.append(Integer.toString(me.left));
		text.append(" right=");
		text.append(Integer.toString(me.right));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		BridgeConfiguration me = new BridgeConfiguration();
		me.left = boost.readInt();
		me.right = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		BridgeConfiguration me = (BridgeConfiguration) processConfiguration;
		boost.writeInt(me.left);
		boost.writeInt(me.right);
	}

}

