package bridge_none_in;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class BridgeComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public BridgeComposition(SymbolsTable symbols) {
		BridgeBehavior me = new BridgeBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		BroadcastChannel d1 = new BroadcastChannel(me.name+":d1", symbols, 1, 0, 1, false);
		BroadcastChannel d2 = new BroadcastChannel(me.name+":d2", symbols, 1, 0, 2, false);
		BroadcastChannel d3 = new BroadcastChannel(me.name+":d3", symbols, 1, 0, 5, false);
		BroadcastChannel d4 = new BroadcastChannel(me.name+":d4", symbols, 1, 0, 8, false);
		channels = new Channel[] { d1, d2, d3, d4,  };
		
		components = new Component[] {
				me,
				new LampBehavior(symbols, me.getLeftRef(), me.getRightRef()),
				new ManBehavior(symbols, d1, me.getLeftRef(), me.getRightRef()),
				new ManBehavior(symbols, d2, me.getLeftRef(), me.getRightRef()),
				new ManBehavior(symbols, d3, me.getLeftRef(), me.getRightRef()),
				new ManBehavior(symbols, d4, me.getLeftRef(), me.getRightRef())
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

