package bridge_wait;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class BridgeComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public BridgeComposition(SymbolsTable symbols) {
		BridgeBehavior me = new BridgeBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		channels = new Channel[] {  };
		
		components = new Component[] {
				me,
				new LampBehavior(symbols, me.getLeftRef(), me.getRightRef()),
				new Man1Behavior(symbols, me.getLeftRef(), me.getRightRef()),
				new Man2Behavior(symbols, me.getLeftRef(), me.getRightRef())
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

