package peterson;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentInt;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public MainBehavior(SymbolsTable symbols) {
		super("Main", idSeed++, symbols);
	}

	public ReferencedArgument<boolean[]> getFlagRef() {
return 		new ReferencedArgument<boolean[]>(id) {
			@Override
			public boolean[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.flag;
			}

			@Override
			public void set(Configuration configuration, boolean[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.flag = value;
			}

			@Override
			public  Class<boolean[]> getArgumentType() {
				return boolean[].class;
			}

		}

;	}

	public ReferencedArgumentInt getTurnRef() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.turn;
			}

			@Override
			public void set(Configuration configuration, int value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.turn = value;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		MainConfiguration me = new MainConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- flag=");
		text.append(Arrays.toString(me.flag));
		text.append("\n\t- turn=");
		text.append(Integer.toString(me.turn));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" flag=");
		text.append(Arrays.toString(me.flag));
		text.append(" turn=");
		text.append(Integer.toString(me.turn));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		MainConfiguration me = new MainConfiguration();
		me.flag = new boolean[2];
		for (int i=0; i<me.flag.length; i++) {
			me.flag[i] = boost.readBoolean();
		}
		me.turn = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		MainConfiguration me = (MainConfiguration) processConfiguration;
		for (int i=0; i<me.flag.length; i++) {
			boost.writeBoolean(me.flag[i]);
		}
		boost.writeInt(me.turn);
	}

}

