package peterson;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainConfiguration extends BehaviorConfiguration {

	public boolean[] flag;

	public int turn;

	//Create initial configuration
	public MainConfiguration() {
		this.flag = new boolean[] {false, false};
		this.turn = 0;
	}

	//Create configuration as a copy
	public MainConfiguration(MainConfiguration other) {
		this.flag = new boolean[2];
		for (int i=0; i<other.flag.length; i++) {
			this.flag[i] = other.flag[i];
		}
		this.turn = other.turn;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new MainConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof MainConfiguration) {
			MainConfiguration other = (MainConfiguration) object;
			if (!Arrays.equals(flag, other.flag)) return false;
			if (turn != other.turn) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.hashCode(flag);
		total = total * 37 + turn;
		return total;
	}

}

