package sokoban;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class PlayBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Move = 1;

	public static final short Done = 2;

	public PlayBehavior(SymbolsTable symbols) {
		super("play", idSeed++, symbols);
	}

	private final String[] stateNames = new String[] {"move", "done"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if ((((((me.a[1][8] == 2) && (me.a[2][7] == 2)) && (me.a[2][8] == 2)) && (me.a[3][7] == 2)) && (me.a[3][8] == 2)) == true) {
			} else {
				if (true) { return false; }
			}
			me.state = Done;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if ((me.a[me.y][(me.x) - (1)] == 0) == true) {
			} else {
				if (true) { return false; }
			}
			me.x = (me.x) - (1);
			me.state = Move;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if ((me.a[me.y][(me.x) + (1)] == 0) == true) {
			} else {
				if (true) { return false; }
			}
			me.x = (me.x) + (1);
			me.state = Move;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if ((me.a[(me.y) - (1)][me.x] == 0) == true) {
			} else {
				if (true) { return false; }
			}
			me.y = (me.y) - (1);
			me.state = Move;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if ((me.a[(me.y) + (1)][me.x] == 0) == true) {
			} else {
				if (true) { return false; }
			}
			me.y = (me.y) + (1);
			me.state = Move;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (((me.a[me.y][(me.x) - (1)] == 2) && (me.a[me.y][(me.x) - (2)] == 0)) == true) {
			} else {
				if (true) { return false; }
			}
			//Start copy variable 'me.a'.
			{
				int[][] __tmp;
				__tmp = new int[6][];
				for (int j=0; j<me.a.length; j++) {
					__tmp[j] = new int[10];
					for (int k=0; k<me.a[j].length; k++) {
						__tmp[j][k] = me.a[j][k];
					}
				}
				me.a = __tmp;
			}
			//End copy variable 'me.a'.
			me.a[me.y][(me.x) - (2)] = 2;
			//Start copy variable 'me.a'.
			{
				int[][] __tmp;
				__tmp = new int[6][];
				for (int j=0; j<me.a.length; j++) {
					__tmp[j] = new int[10];
					for (int k=0; k<me.a[j].length; k++) {
						__tmp[j][k] = me.a[j][k];
					}
				}
				me.a = __tmp;
			}
			//End copy variable 'me.a'.
			me.a[me.y][(me.x) - (1)] = 0;
			me.x = (me.x) - (1);
			me.state = Move;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (((me.a[me.y][(me.x) + (1)] == 2) && (me.a[me.y][(me.x) + (2)] == 0)) == true) {
			} else {
				if (true) { return false; }
			}
			//Start copy variable 'me.a'.
			{
				int[][] __tmp;
				__tmp = new int[6][];
				for (int j=0; j<me.a.length; j++) {
					__tmp[j] = new int[10];
					for (int k=0; k<me.a[j].length; k++) {
						__tmp[j][k] = me.a[j][k];
					}
				}
				me.a = __tmp;
			}
			//End copy variable 'me.a'.
			me.a[me.y][(me.x) + (2)] = 2;
			//Start copy variable 'me.a'.
			{
				int[][] __tmp;
				__tmp = new int[6][];
				for (int j=0; j<me.a.length; j++) {
					__tmp[j] = new int[10];
					for (int k=0; k<me.a[j].length; k++) {
						__tmp[j][k] = me.a[j][k];
					}
				}
				me.a = __tmp;
			}
			//End copy variable 'me.a'.
			me.a[me.y][(me.x) + (1)] = 0;
			me.x = (me.x) + (1);
			me.state = Move;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (((me.a[(me.y) - (1)][me.x] == 2) && (me.a[(me.y) - (2)][me.x] == 0)) == true) {
			} else {
				if (true) { return false; }
			}
			//Start copy variable 'me.a'.
			{
				int[][] __tmp;
				__tmp = new int[6][];
				for (int j=0; j<me.a.length; j++) {
					__tmp[j] = new int[10];
					for (int k=0; k<me.a[j].length; k++) {
						__tmp[j][k] = me.a[j][k];
					}
				}
				me.a = __tmp;
			}
			//End copy variable 'me.a'.
			me.a[(me.y) - (2)][me.x] = 2;
			//Start copy variable 'me.a'.
			{
				int[][] __tmp;
				__tmp = new int[6][];
				for (int j=0; j<me.a.length; j++) {
					__tmp[j] = new int[10];
					for (int k=0; k<me.a[j].length; k++) {
						__tmp[j][k] = me.a[j][k];
					}
				}
				me.a = __tmp;
			}
			//End copy variable 'me.a'.
			me.a[(me.y) - (1)][me.x] = 0;
			me.y = (me.y) - (1);
			me.state = Move;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Move) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PlayConfiguration me = (PlayConfiguration) configuration.behaviorConfigurations[id];
			if (((me.a[(me.y) + (1)][me.x] == 2) && (me.a[(me.y) + (2)][me.x] == 0)) == true) {
			} else {
				if (true) { return false; }
			}
			//Start copy variable 'me.a'.
			{
				int[][] __tmp;
				__tmp = new int[6][];
				for (int j=0; j<me.a.length; j++) {
					__tmp[j] = new int[10];
					for (int k=0; k<me.a[j].length; k++) {
						__tmp[j][k] = me.a[j][k];
					}
				}
				me.a = __tmp;
			}
			//End copy variable 'me.a'.
			me.a[(me.y) + (2)][me.x] = 2;
			//Start copy variable 'me.a'.
			{
				int[][] __tmp;
				__tmp = new int[6][];
				for (int j=0; j<me.a.length; j++) {
					__tmp[j] = new int[10];
					for (int k=0; k<me.a[j].length; k++) {
						__tmp[j][k] = me.a[j][k];
					}
				}
				me.a = __tmp;
			}
			//End copy variable 'me.a'.
			me.a[(me.y) + (1)][me.x] = 0;
			me.y = (me.y) + (1);
			me.state = Move;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		PlayConfiguration me = new PlayConfiguration();
		//Initial action code.
		me.state = Move;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		PlayConfiguration me = (PlayConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case PlayBehavior.Move: 
			text.append("@move,");
			break;
		case PlayBehavior.Done: 
			text.append("@done,");
			break;
		}
		text.append("\n\t- x=");
		text.append(Integer.toString(me.x));
		text.append("\n\t- y=");
		text.append(Integer.toString(me.y));
		text.append("\n\t- a=");
		text.append(Arrays.deepToString(me.a));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		PlayConfiguration me = (PlayConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case PlayBehavior.Move: 
			text.append("@move,");
			break;
		case PlayBehavior.Done: 
			text.append("@done,");
			break;
		}
		text.append(" x=");
		text.append(Integer.toString(me.x));
		text.append(" y=");
		text.append(Integer.toString(me.y));
		text.append(" a=");
		text.append(Arrays.deepToString(me.a));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		PlayConfiguration me = new PlayConfiguration();
		me.state = boost.readShort();
		me.x = boost.readInt();
		me.y = boost.readInt();
		me.a = new int[6][];
		for (int i=0; i<me.a.length; i++) {
			me.a[i] = new int[10];
			for (int j=0; j<me.a[i].length; j++) {
				me.a[i][j] = boost.readInt();
			}
		}
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		PlayConfiguration me = (PlayConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.x);
		boost.writeInt(me.y);
		for (int i=0; i<me.a.length; i++) {
			for (int j=0; j<me.a[i].length; j++) {
				boost.writeInt(me.a[i][j]);
			}
		}
	}

}

