package sokoban;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class PlayConfiguration extends BehaviorConfiguration {

	public short state;

	public int x;

	public int y;

	public int[][] a;

	//Create initial configuration
	public PlayConfiguration() {
		this.x = 1;
		this.y = 1;
		this.a = new int[][] {{1, 1, 1, 1, 1, 1, 1, 1, 1, 1}, {1, 0, 0, 0, 1, 0, 0, 0, 0, 1}, {1, 0, 2, 0, 2, 0, 0, 0, 0, 1}, {1, 0, 2, 2, 2, 1, 1, 0, 0, 1}, {1, 0, 0, 0, 0, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1, 1, 1}};
	}

	//Create configuration as a copy
	public PlayConfiguration(PlayConfiguration other) {
		this.state = other.state;
		this.x = other.x;
		this.y = other.y;
		this.a = new int[6][];
		for (int i=0; i<other.a.length; i++) {
			this.a[i] = new int[10];
			for (int j=0; j<other.a[i].length; j++) {
				this.a[i][j] = other.a[i][j];
			}
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new PlayConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof PlayConfiguration) {
			PlayConfiguration other = (PlayConfiguration) object;
			if (state != other.state) return false;
			if (x != other.x) return false;
			if (y != other.y) return false;
			if (!Arrays.deepEquals(a, other.a)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + x;
		total = total * 37 + y;
		total = total * 37 + Arrays.deepHashCode(a);
		return total;
	}

}

