package p0waiting;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class OutPBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S0 = 1;

	private final BroadcastChannel cha;

	public OutPBehavior(SymbolsTable symbols, BroadcastChannel cha) {
		super("outP", idSeed++, symbols);
		this.cha = cha;
		outputChannels = new Channel[]{this.cha};
	}

	private final String[] stateNames = new String[] {"s0"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return cha.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			OutPConfiguration me = (OutPConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final OutPConfiguration me = (OutPConfiguration) configuration.behaviorConfigurations[id];
			cha.output(id, actions);
			me.v0 = 1;
			me.state = S0;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		OutPConfiguration me = new OutPConfiguration();
		//Initial action code.
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		OutPConfiguration me = (OutPConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case OutPBehavior.S0: 
			text.append("@s0,");
			break;
		}
		text.append("\n\t- v0=");
		text.append(Integer.toString(me.v0));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		OutPConfiguration me = (OutPConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case OutPBehavior.S0: 
			text.append("@s0,");
			break;
		}
		text.append(" v0=");
		text.append(Integer.toString(me.v0));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		OutPConfiguration me = new OutPConfiguration();
		me.state = boost.readShort();
		me.v0 = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		OutPConfiguration me = (OutPConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.v0);
	}

}

