package p0waiting;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class SysComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public SysComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("sys", idSeed++);
		BroadcastChannel chan = new BroadcastChannel(name+":chan", symbols, 1, 1);
		BroadcastChannel blo = new BroadcastChannel(name+":blo", symbols, 1, 0);
		channels = new Channel[] { chan, blo,  };
		
		components = new Component[] {
				new OutPBehavior(symbols, chan),
				new InPBehavior(symbols, chan, blo)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

