package syncorder;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentInt;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class SysBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public SysBehavior(SymbolsTable symbols) {
		super("sys", idSeed++, symbols);
	}

	public ReferencedArgumentInt getShardRef() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.shard;
			}

			@Override
			public void set(Configuration configuration, int value) {
				SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[ownerId];
				me.shard = value;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		SysConfiguration me = new SysConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SysConfiguration me = (SysConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- shard=");
		text.append(Integer.toString(me.shard));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SysConfiguration me = (SysConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" shard=");
		text.append(Integer.toString(me.shard));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		SysConfiguration me = new SysConfiguration();
		me.shard = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		SysConfiguration me = (SysConfiguration) processConfiguration;
		boost.writeInt(me.shard);
	}

}

