package syncorder;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class SysComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public SysComposition(SymbolsTable symbols) {
		SysBehavior me = new SysBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		BroadcastChannel chan = new BroadcastChannel(me.name+":chan", symbols, 4, 1);
		channels = new Channel[] { chan,  };
		
		components = new Component[] {
				me,
				new OutPBehavior(symbols, chan, me.getShardRef()),
				new InPBehavior(symbols, chan, 2, me.getShardRef()),
				new InPBehavior(symbols, chan, 3, me.getShardRef()),
				new InPBehavior(symbols, chan, 4, me.getShardRef()),
				new InPBehavior(symbols, chan, 5, me.getShardRef())
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

