package synchroselect2;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Receiver1Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S0 = 1;

	private final BroadcastChannel children;

	public Receiver1Behavior(SymbolsTable symbols, BroadcastChannel children) {
		super("receiver1", idSeed++, symbols);
		this.children = children;
		inputChannels = new Channel[]{this.children};
	}

	private final String[] stateNames = new String[] {"s0"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return children.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Receiver1Configuration me = (Receiver1Configuration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Receiver1Configuration me = (Receiver1Configuration) configuration.behaviorConfigurations[id];
			children.input(id, actions);
			me.v0 = children.value(int.class,0);
			if ( children.clockId != -1 ) {
				DBM.set(configuration.dbm, children.clockId, 0);
			}
			me.state = S0;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return children.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Receiver1Configuration me = (Receiver1Configuration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Receiver1Configuration me = (Receiver1Configuration) configuration.behaviorConfigurations[id];
			children.input(id, actions);
			me.v1 = children.value(int.class,0);
			if ( children.clockId != -1 ) {
				DBM.set(configuration.dbm, children.clockId, 0);
			}
			me.state = S0;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return children.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Receiver1Configuration me = (Receiver1Configuration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Receiver1Configuration me = (Receiver1Configuration) configuration.behaviorConfigurations[id];
			children.input(id, actions);
			me.v2 = children.value(int.class,0);
			if ( children.clockId != -1 ) {
				DBM.set(configuration.dbm, children.clockId, 0);
			}
			me.state = S0;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Receiver1Configuration me = new Receiver1Configuration();
		//Initial action code.
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Receiver1Configuration me = (Receiver1Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Receiver1Behavior.S0: 
			text.append("@s0,");
			break;
		}
		text.append("\n\t- v0=");
		text.append(Integer.toString(me.v0));
		text.append("\n\t- v1=");
		text.append(Integer.toString(me.v1));
		text.append("\n\t- v2=");
		text.append(Integer.toString(me.v2));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Receiver1Configuration me = (Receiver1Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Receiver1Behavior.S0: 
			text.append("@s0,");
			break;
		}
		text.append(" v0=");
		text.append(Integer.toString(me.v0));
		text.append(" v1=");
		text.append(Integer.toString(me.v1));
		text.append(" v2=");
		text.append(Integer.toString(me.v2));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Receiver1Configuration me = new Receiver1Configuration();
		me.state = boost.readShort();
		me.v0 = boost.readInt();
		me.v1 = boost.readInt();
		me.v2 = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Receiver1Configuration me = (Receiver1Configuration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.v0);
		boost.writeInt(me.v1);
		boost.writeInt(me.v2);
	}

}

