package t1_notime;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class SYSComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public SYSComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("SYS", idSeed++);
		BroadcastChannel chan = new BroadcastChannel(name+":chan", symbols, 1, 1);
		channels = new Channel[] { chan,  };
		
		components = new Component[] {
				new P0Behavior(symbols, chan),
				new P1Behavior(symbols, chan)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

