package t2;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Consumer2Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S0 = 1;

	public static final short S1 = 2;

	public static final short S2 = 3;

	private final BroadcastChannel chan0;

	private final BroadcastChannel chan1;

	public Consumer2Behavior(SymbolsTable symbols, BroadcastChannel chan0, BroadcastChannel chan1) {
		super("Consumer2", idSeed++, symbols);
		this.chan0 = chan0;
		this.chan1 = chan1;
		inputChannels = new Channel[]{this.chan0, this.chan1};
	}

	private final String[] stateNames = new String[] {"s0", "s1", "s2"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return chan0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Consumer2Configuration me = (Consumer2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Consumer2Configuration me = (Consumer2Configuration) configuration.behaviorConfigurations[id];
			chan0.input(id, actions);
			me.x = chan0.value(boolean.class,0);
			if ( chan0.clockId != -1 ) {
				DBM.set(configuration.dbm, chan0.clockId, 0);
			}
			me.state = S1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return chan1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Consumer2Configuration me = (Consumer2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != S1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Consumer2Configuration me = (Consumer2Configuration) configuration.behaviorConfigurations[id];
			chan1.input(id, actions);
			me.x = chan1.value(boolean.class,0);
			if ( chan1.clockId != -1 ) {
				DBM.set(configuration.dbm, chan1.clockId, 0);
			}
			me.state = S2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Consumer2Configuration me = new Consumer2Configuration();
		//Initial action code.
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Consumer2Configuration me = (Consumer2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Consumer2Behavior.S0: 
			text.append("@s0,");
			break;
		case Consumer2Behavior.S1: 
			text.append("@s1,");
			break;
		case Consumer2Behavior.S2: 
			text.append("@s2,");
			break;
		}
		text.append("\n\t- x=");
		text.append(Boolean.toString(me.x));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Consumer2Configuration me = (Consumer2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Consumer2Behavior.S0: 
			text.append("@s0,");
			break;
		case Consumer2Behavior.S1: 
			text.append("@s1,");
			break;
		case Consumer2Behavior.S2: 
			text.append("@s2,");
			break;
		}
		text.append(" x=");
		text.append(Boolean.toString(me.x));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Consumer2Configuration me = new Consumer2Configuration();
		me.state = boost.readShort();
		me.x = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Consumer2Configuration me = (Consumer2Configuration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.x);
	}

}

