package t2;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class SysComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public SysComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("sys", idSeed++);
		BroadcastChannel p0 = new BroadcastChannel(name+":p0", symbols, 1, 1);
		BroadcastChannel p1 = new BroadcastChannel(name+":p1", symbols, 2, 1);
		channels = new Channel[] { p0, p1,  };
		
		components = new Component[] {
				new Producer1Behavior(symbols, p0),
				new Producer2Behavior(symbols, p1),
				new Consumer1Behavior(symbols, p1),
				new Consumer2Behavior(symbols, p0, p1)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

