package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class AnalogSwitchBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INIT1 = 1;

	public static final short Open = 2;

	public static final short Emit1_intermediate_from_open_to_closed = 3;

	public static final short Emit2_intermediate_from_open_to_closed = 4;

	public static final short Intermediate_from_open_to_closed = 5;

	public static final short Emit1_closed1 = 6;

	public static final short Emit2_closed1 = 7;

	public static final short Closed1 = 8;

	public static final short Emit1_closed2 = 9;

	public static final short Emit2_closed2 = 10;

	public static final short Closed2 = 11;

	public static final short Emit1_intermediate_from_closed_to_open = 12;

	public static final short Emit2_intermediate_from_closed_to_open = 13;

	public static final short Intermediate_from_closed_to_open = 14;

	public static final short Emit1_blocked_open = 15;

	public static final short Emit2_blocked_open = 16;

	public static final short Blocked_open = 17;

	public static final short Emit1_blocked_closed = 18;

	public static final short Emit2_blocked_closed = 19;

	public static final short Blocked_closed = 20;

	private final short informal19;

	private final short informal20;

	private final short informal21;

	private final short informal22;

	private final short informal23;

	private final short informal24;

	private final short informal25;

	private final short informal26;

	private final short informal27;

	private final short informal28;

	private final short informal29;

	private final short informal30;

	private final short informal31;

	private final short informal32;

	private final short informal33;

	private final short informal34;

	private final short informal35;

	private final short informal36;

	private final BroadcastChannel port_from_dispatch;

	private final BroadcastChannel fromAnalogSwitch;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final WaitChannel wait2;

	private final WaitChannel wait3;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public AnalogSwitchBehavior(SymbolsTable symbols, BroadcastChannel port_from_dispatch, BroadcastChannel fromAnalogSwitch) {
		super("AnalogSwitch", idSeed++, symbols);
		this.port_from_dispatch = port_from_dispatch;
		this.fromAnalogSwitch = fromAnalogSwitch;
		inputChannels = new Channel[]{this.port_from_dispatch};
		outputChannels = new Channel[]{this.fromAnalogSwitch};
		informal19 = symbols.getInformalId("AnalogSwitch_open->bl-open");
		informal20 = symbols.getInformalId("AnalogSwitch_open->bl-closed");
		informal21 = symbols.getInformalId("AnalogSwitch_open->interm-open");
		informal22 = symbols.getInformalId("AnalogSwitch_interm-open->bl-open");
		informal23 = symbols.getInformalId("AnalogSwitch_interm-open->bl-closed");
		informal24 = symbols.getInformalId("AnalogSwitch_interm-open->closed1");
		informal25 = symbols.getInformalId("AnalogSwitch_closed1->bl-open");
		informal26 = symbols.getInformalId("AnalogSwitch_closed1->bl-closed");
		informal27 = symbols.getInformalId("AnalogSwitch_closed1->closed2");
		informal28 = symbols.getInformalId("AnalogSwitch_closed1->interm-closed");
		informal29 = symbols.getInformalId("AnalogSwitch_closed2->bl-open");
		informal30 = symbols.getInformalId("AnalogSwitch_closed2->bl-closed");
		informal31 = symbols.getInformalId("AnalogSwitch_closed2->closed1");
		informal32 = symbols.getInformalId("AnalogSwitch_closed2->interm-closed");
		informal33 = symbols.getInformalId("AnalogSwitch_iterm-closed->bl-open");
		informal34 = symbols.getInformalId("AnalogSwitch_iterm-closed->bl-closed");
		informal35 = symbols.getInformalId("AnalogSwitch_iterm-closed->iterm-open");
		informal36 = symbols.getInformalId("AnalogSwitch_interm-closed->open");
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 8, false, 8, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 0, 400, false, 400, false);
		wait2 = new WaitChannel(null, symbols, this.getId(), (short) 0, 400, false, 400, false);
		wait3 = new WaitChannel(null, symbols, this.getId(), (short) 0, 12, false, 12, false);
		channels = new Channel[] { wait0, wait1, wait2, wait3,  };
	}

	private final String[] stateNames = new String[] {"INIT1", "open", "emit1_intermediate_from_open_to_closed", "emit2_intermediate_from_open_to_closed", "intermediate_from_open_to_closed", "emit1_closed1", "emit2_closed1", "closed1", "emit1_closed2", "emit2_closed2", "closed2", "emit1_intermediate_from_closed_to_open", "emit2_intermediate_from_closed_to_open", "intermediate_from_closed_to_open", "emit1_blocked_open", "emit2_blocked_open", "blocked_open", "emit1_blocked_closed", "emit2_blocked_closed", "blocked_closed"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromAnalogSwitch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			fromAnalogSwitch.output(id, actions, LGS_PilotInternalRoot.SWITCH_OFF);
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal19));
				me.state = Emit1_blocked_open;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal20));
				me.state = Emit1_blocked_closed;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.HANDLE) {
				actions.add(new InformalAction(id, informal21));
				me.state = Intermediate_from_open_to_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_open_to_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal22));
				me.state = Emit1_blocked_open;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal23));
				me.state = Emit1_blocked_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_open_to_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_open_to_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal24));
			me.state = Emit1_closed1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromAnalogSwitch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit1_closed1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			fromAnalogSwitch.output(id, actions, LGS_PilotInternalRoot.SWITCH_ON);
			me.state = Closed1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal25));
				me.state = Emit1_blocked_open;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal26));
				me.state = Emit1_blocked_closed;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.HANDLE) {
				actions.add(new InformalAction(id, informal27));
				me.state = Closed2;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Closed1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait1.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal28));
			me.state = Emit1_intermediate_from_closed_to_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal29));
				me.state = Emit1_blocked_open;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal30));
				me.state = Emit1_blocked_closed;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.HANDLE) {
				actions.add(new InformalAction(id, informal31));
				me.state = Closed1;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Closed2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait2.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait2.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal32));
			me.state = Emit1_intermediate_from_closed_to_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromAnalogSwitch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit1_intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			fromAnalogSwitch.output(id, actions, LGS_PilotInternalRoot.SWITCH_OFF);
			me.state = Intermediate_from_closed_to_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal33));
				me.state = Emit1_blocked_open;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal34));
				me.state = Emit1_blocked_closed;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.HANDLE) {
				actions.add(new InformalAction(id, informal35));
				me.state = Intermediate_from_open_to_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_closed_to_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait3.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait3.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal36));
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromAnalogSwitch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit1_blocked_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			fromAnalogSwitch.output(id, actions, LGS_PilotInternalRoot.SWITCH_OFF);
			me.state = Blocked_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromAnalogSwitch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit1_blocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			fromAnalogSwitch.output(id, actions, LGS_PilotInternalRoot.SWITCH_ON);
			me.state = Blocked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			me.state = Blocked_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			me.state = Blocked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		AnalogSwitchConfiguration me = new AnalogSwitchConfiguration();
		int param_from_dispatch;
		//Initial action code.
		me.state = INIT1;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case AnalogSwitchBehavior.INIT1: 
			text.append("@INIT1,");
			break;
		case AnalogSwitchBehavior.Open: 
			text.append("@open,");
			break;
		case AnalogSwitchBehavior.Emit1_intermediate_from_open_to_closed: 
			text.append("@emit1_intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Emit2_intermediate_from_open_to_closed: 
			text.append("@emit2_intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Intermediate_from_open_to_closed: 
			text.append("@intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Emit1_closed1: 
			text.append("@emit1_closed1,");
			break;
		case AnalogSwitchBehavior.Emit2_closed1: 
			text.append("@emit2_closed1,");
			break;
		case AnalogSwitchBehavior.Closed1: 
			text.append("@closed1,");
			break;
		case AnalogSwitchBehavior.Emit1_closed2: 
			text.append("@emit1_closed2,");
			break;
		case AnalogSwitchBehavior.Emit2_closed2: 
			text.append("@emit2_closed2,");
			break;
		case AnalogSwitchBehavior.Closed2: 
			text.append("@closed2,");
			break;
		case AnalogSwitchBehavior.Emit1_intermediate_from_closed_to_open: 
			text.append("@emit1_intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Emit2_intermediate_from_closed_to_open: 
			text.append("@emit2_intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Intermediate_from_closed_to_open: 
			text.append("@intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Emit1_blocked_open: 
			text.append("@emit1_blocked_open,");
			break;
		case AnalogSwitchBehavior.Emit2_blocked_open: 
			text.append("@emit2_blocked_open,");
			break;
		case AnalogSwitchBehavior.Blocked_open: 
			text.append("@blocked_open,");
			break;
		case AnalogSwitchBehavior.Emit1_blocked_closed: 
			text.append("@emit1_blocked_closed,");
			break;
		case AnalogSwitchBehavior.Emit2_blocked_closed: 
			text.append("@emit2_blocked_closed,");
			break;
		case AnalogSwitchBehavior.Blocked_closed: 
			text.append("@blocked_closed,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case AnalogSwitchBehavior.INIT1: 
			text.append("@INIT1,");
			break;
		case AnalogSwitchBehavior.Open: 
			text.append("@open,");
			break;
		case AnalogSwitchBehavior.Emit1_intermediate_from_open_to_closed: 
			text.append("@emit1_intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Emit2_intermediate_from_open_to_closed: 
			text.append("@emit2_intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Intermediate_from_open_to_closed: 
			text.append("@intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Emit1_closed1: 
			text.append("@emit1_closed1,");
			break;
		case AnalogSwitchBehavior.Emit2_closed1: 
			text.append("@emit2_closed1,");
			break;
		case AnalogSwitchBehavior.Closed1: 
			text.append("@closed1,");
			break;
		case AnalogSwitchBehavior.Emit1_closed2: 
			text.append("@emit1_closed2,");
			break;
		case AnalogSwitchBehavior.Emit2_closed2: 
			text.append("@emit2_closed2,");
			break;
		case AnalogSwitchBehavior.Closed2: 
			text.append("@closed2,");
			break;
		case AnalogSwitchBehavior.Emit1_intermediate_from_closed_to_open: 
			text.append("@emit1_intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Emit2_intermediate_from_closed_to_open: 
			text.append("@emit2_intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Intermediate_from_closed_to_open: 
			text.append("@intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Emit1_blocked_open: 
			text.append("@emit1_blocked_open,");
			break;
		case AnalogSwitchBehavior.Emit2_blocked_open: 
			text.append("@emit2_blocked_open,");
			break;
		case AnalogSwitchBehavior.Blocked_open: 
			text.append("@blocked_open,");
			break;
		case AnalogSwitchBehavior.Emit1_blocked_closed: 
			text.append("@emit1_blocked_closed,");
			break;
		case AnalogSwitchBehavior.Emit2_blocked_closed: 
			text.append("@emit2_blocked_closed,");
			break;
		case AnalogSwitchBehavior.Blocked_closed: 
			text.append("@blocked_closed,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		AnalogSwitchConfiguration me = new AnalogSwitchConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

