package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class DispatcherBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INIT = 1;

	public static final short WaitCmdEnv = 2;

	public static final short NotifySoftware = 3;

	private final short informal0;

	private final short informal1;

	private final short informal2;

	private final short informal3;

	private final short informal4;

	private final short informal5;

	private final short informal6;

	private final short informal7;

	private final short informal8;

	private final short informal9;

	private final short informal10;

	private final short informal11;

	private final short informal12;

	private final short informal13;

	private final short informal14;

	private final short informal15;

	private final short informal16;

	private final short informal17;

	private final short informal18;

	private final BroadcastChannel to_analogswitch;

	private final BroadcastChannel to_software_part;

	private final BroadcastChannel to_general_EV;

	private final BroadcastChannel to_retract_EV;

	private final BroadcastChannel to_extend_EV;

	private final BroadcastChannel to_close_EV;

	private final BroadcastChannel to_open_EV;

	private final BroadcastChannel to_front_gear;

	private final BroadcastChannel to_front_door;

	private final BroadcastChannel to_left_gear;

	private final BroadcastChannel to_left_door;

	private final BroadcastChannel to_right_gear;

	private final BroadcastChannel to_right_door;

	private final ReferencedArgument<int[]> fromEnvRef;

	public DispatcherBehavior(SymbolsTable symbols, BroadcastChannel to_analogswitch, BroadcastChannel to_software_part, BroadcastChannel to_general_EV, BroadcastChannel to_retract_EV, BroadcastChannel to_extend_EV, BroadcastChannel to_close_EV, BroadcastChannel to_open_EV, BroadcastChannel to_front_gear, BroadcastChannel to_front_door, BroadcastChannel to_left_gear, BroadcastChannel to_left_door, BroadcastChannel to_right_gear, BroadcastChannel to_right_door, ReferencedArgument<int[]> fromEnv) {
		super("Dispatcher", idSeed++, symbols);
		this.to_analogswitch = to_analogswitch;
		this.to_software_part = to_software_part;
		this.to_general_EV = to_general_EV;
		this.to_retract_EV = to_retract_EV;
		this.to_extend_EV = to_extend_EV;
		this.to_close_EV = to_close_EV;
		this.to_open_EV = to_open_EV;
		this.to_front_gear = to_front_gear;
		this.to_front_door = to_front_door;
		this.to_left_gear = to_left_gear;
		this.to_left_door = to_left_door;
		this.to_right_gear = to_right_gear;
		this.to_right_door = to_right_door;
		outputChannels = new Channel[]{this.to_analogswitch, this.to_software_part, this.to_general_EV, this.to_retract_EV, this.to_extend_EV, this.to_close_EV, this.to_open_EV, this.to_front_gear, this.to_front_door, this.to_left_gear, this.to_left_door, this.to_right_gear, this.to_right_door};
		this.fromEnvRef = fromEnv;
		informal0 = symbols.getInformalId("HANDLE recu");
		informal1 = symbols.getInformalId("ANALOG_SWITCH_OPEN_FAILURE recu");
		informal2 = symbols.getInformalId("ANALOG_SWITCH_CLOSE_FAILURE recu");
		informal3 = symbols.getInformalId("GENERAL_EV_OPEN_FAILURE recu");
		informal4 = symbols.getInformalId("GENERAL_EV_CLOSED_ERR recu");
		informal5 = symbols.getInformalId("RETRACT_EV_OPEN_FAILURE recu");
		informal6 = symbols.getInformalId("RETRACT_EV_CLOSED_FAILURE recu");
		informal7 = symbols.getInformalId("EXTEND_EV_OPEN_FAILURE recu");
		informal8 = symbols.getInformalId("EXTEND_EV_CLOSED_FAILURE recu");
		informal9 = symbols.getInformalId("CLOSE_EV_OPEN_FAILURE recu");
		informal10 = symbols.getInformalId("CLOSE_EV_CLOSED_FAILURE recu");
		informal11 = symbols.getInformalId("OPEN_EV_OPEN_FAILURE recu");
		informal12 = symbols.getInformalId("OPEN_EV_CLOSED_FAILURE recu");
		informal13 = symbols.getInformalId("FRONT_GEAR_FAILURE recu");
		informal14 = symbols.getInformalId("FRONT_DOOR_FAILURE recu");
		informal15 = symbols.getInformalId("LEFT_GEAR_FAILURE recu");
		informal16 = symbols.getInformalId("LEFT_DOOR_FAILURE recu");
		informal17 = symbols.getInformalId("RIGHT_GEAR_FAILURE recu");
		informal18 = symbols.getInformalId("RIGHT_DOOR_FAILURE recu");
	}

	private final String[] stateNames = new String[] {"INIT", "waitCmdEnv", "notifySoftware"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_software_part.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			to_software_part.output(id, actions, me.handleState);
			me.state = WaitCmdEnv;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( (fromEnv.length == 0)) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			me.state = WaitCmdEnv;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_analogswitch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.HANDLE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			actions.add(new InformalAction(id, informal0));
			me.handleState =  !(me.handleState);
			to_analogswitch.output(id, actions, LGS_PilotInternalRoot.HANDLE);
			me.state = NotifySoftware;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_analogswitch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			actions.add(new InformalAction(id, informal1));
			to_analogswitch.output(id, actions, LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_OPEN_FAILURE);
			me.state = NotifySoftware;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_analogswitch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			actions.add(new InformalAction(id, informal2));
			to_analogswitch.output(id, actions, LGS_PilotInternalRoot.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE);
			me.state = NotifySoftware;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_general_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.GENERAL_EV_BLOCK_OPEN_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal3));
				to_general_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_general_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.GENERAL_EV_BLOCK_CLOSED_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal4));
				to_general_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_retract_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.RETRACT_EV_BLOCK_OPEN_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal5));
				to_retract_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_retract_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.RETRACT_EV_BLOCK_CLOSED_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal6));
				to_retract_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_extend_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.EXTEND_EV_BLOCK_OPEN_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal7));
				to_extend_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_extend_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.EXTEND_EV_BLOCK_CLOSED_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal8));
				to_extend_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_close_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.CLOSE_EV_BLOCK_OPEN_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal9));
				to_close_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_close_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.CLOSE_EV_BLOCK_CLOSED_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal10));
				to_close_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_open_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.OPEN_EV_BLOCK_OPEN_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal11));
				to_open_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_open_EV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.OPEN_EV_BLOCK_CLOSED_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal12));
				to_open_EV.output(id, actions, LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_front_gear.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.FRONT_GEAR_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal13));
				to_front_gear.output(id, actions, LGS_PilotInternalRoot.FRONT_GEAR_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition16 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_front_door.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.FRONT_DOOR_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal14));
				to_front_door.output(id, actions, LGS_PilotInternalRoot.FRONT_DOOR_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition17 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_left_gear.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.LEFT_GEAR_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal15));
				to_left_gear.output(id, actions, LGS_PilotInternalRoot.LEFT_GEAR_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition18 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_left_door.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.LEFT_DOOR_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal16));
				to_left_door.output(id, actions, LGS_PilotInternalRoot.LEFT_DOOR_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition19 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_right_gear.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.RIGHT_GEAR_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal17));
				to_right_gear.output(id, actions, LGS_PilotInternalRoot.RIGHT_GEAR_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition20 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_right_door.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			if (me.state != WaitCmdEnv) return false;
			if ( ( !( (fromEnv.length == 0))) == false) return false;
			if ( (true) == false) return false;
			if ( (( FiacreQueueUtil.first(fromEnv)) == LGS_PilotInternalRoot.RIGHT_DOOR_FAILURE) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				actions.add(new InformalAction(id, informal18));
				to_right_door.output(id, actions, LGS_PilotInternalRoot.RIGHT_DOOR_FAILURE);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition21 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_software_part.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			modifiedBehaviors[fromEnvRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != NotifySoftware) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DispatcherConfiguration me = (DispatcherConfiguration) configuration.behaviorConfigurations[id];
			int[] fromEnv = fromEnvRef.get(configuration);
			try {
				to_software_part.output(id, actions, me.handleState);
				fromEnv =  FiacreQueueUtil.dequeue(id, fromEnv, actions);
				me.state = WaitCmdEnv;
				if (true) return true;
			} finally {
				fromEnvRef.set(configuration, fromEnv);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
		transition16,
		transition17,
		transition18,
		transition19,
		transition20,
		transition21,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		DispatcherConfiguration me = new DispatcherConfiguration();
		//Initial action code.
		me.handleState = LGS_PilotInternalRoot.HANDLE_DOWN;
		me.state = INIT;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		DispatcherConfiguration me = (DispatcherConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case DispatcherBehavior.INIT: 
			text.append("@INIT,");
			break;
		case DispatcherBehavior.WaitCmdEnv: 
			text.append("@waitCmdEnv,");
			break;
		case DispatcherBehavior.NotifySoftware: 
			text.append("@notifySoftware,");
			break;
		}
		text.append("\n\t- handleState=");
		text.append(Boolean.toString(me.handleState));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		DispatcherConfiguration me = (DispatcherConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case DispatcherBehavior.INIT: 
			text.append("@INIT,");
			break;
		case DispatcherBehavior.WaitCmdEnv: 
			text.append("@waitCmdEnv,");
			break;
		case DispatcherBehavior.NotifySoftware: 
			text.append("@notifySoftware,");
			break;
		}
		text.append(" handleState=");
		text.append(Boolean.toString(me.handleState));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		DispatcherConfiguration me = new DispatcherConfiguration();
		me.state = boost.readShort();
		me.handleState = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		DispatcherConfiguration me = (DispatcherConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.handleState);
	}

}

