package lgs_pilotinternal;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class DispatcherConfiguration extends BehaviorConfiguration {

	public short state;

	public boolean handleState;

	//Create initial configuration
	public DispatcherConfiguration() {
		this.handleState = false;
	}

	//Create configuration as a copy
	public DispatcherConfiguration(DispatcherConfiguration other) {
		this.state = other.state;
		this.handleState = other.handleState;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new DispatcherConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof DispatcherConfiguration) {
			DispatcherConfiguration other = (DispatcherConfiguration) object;
			if (state != other.state) return false;
			if (handleState != other.handleState) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + (handleState? 1 : 0);
		return total;
	}

}

