package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Door_sensor_synthesisBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INIT_door1 = 1;

	public static final short INIT_door2 = 2;

	public static final short S = 3;

	public static final short EMIT = 4;

	public static final short ANOMALY = 5;

	public static final short DEAD = 6;

	private final BroadcastChannel sensor_door_open;

	private final BroadcastChannel sensor_door_locked_closed;

	private final BroadcastChannel door_position;

	private final ReferencedArgumentBoolean red_lightRef;

	public Door_sensor_synthesisBehavior(SymbolsTable symbols, BroadcastChannel sensor_door_open, BroadcastChannel sensor_door_locked_closed, BroadcastChannel door_position, ReferencedArgumentBoolean red_light) {
		super("door_sensor_synthesis", idSeed++, symbols);
		this.sensor_door_open = sensor_door_open;
		this.sensor_door_locked_closed = sensor_door_locked_closed;
		this.door_position = door_position;
		inputChannels = new Channel[]{this.sensor_door_open, this.sensor_door_locked_closed};
		outputChannels = new Channel[]{this.door_position};
		this.red_lightRef = red_light;
	}

	private final String[] stateNames = new String[] {"INIT_door1", "INIT_door2", "S", "EMIT", "ANOMALY", "DEAD"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_door_open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_door1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			sensor_door_open.input(id, actions);
			me.param_door_open = sensor_door_open.value(boolean.class,0);
			if ( sensor_door_open.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_door_open.clockId, 0);
			}
			me.state = INIT_door2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_door_locked_closed.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_door2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			sensor_door_locked_closed.input(id, actions);
			me.param_door_locked_closed = sensor_door_locked_closed.value(boolean.class,0);
			if ( sensor_door_locked_closed.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_door_locked_closed.clockId, 0);
			}
			if ((me.param_door_open == LGS_PilotInternalRoot.DOOR_OPEN) && (me.param_door_locked_closed == LGS_PilotInternalRoot.DOOR_CLOSED)) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				if (me.param_door_open == LGS_PilotInternalRoot.DOOR_OPEN) {
					me.doorPosition = LGS_PilotInternalRoot.OPEN;
				}
				if ((me.param_door_open == LGS_PilotInternalRoot.DOOR_NOT_OPEN) && (me.param_door_locked_closed == LGS_PilotInternalRoot.DOOR_NOT_CLOSED)) {
					me.doorPosition = LGS_PilotInternalRoot.INTERMEDIATE;
				}
				if (me.param_door_locked_closed == LGS_PilotInternalRoot.DOOR_CLOSED) {
					me.doorPosition = LGS_PilotInternalRoot.LOCKED_CLOSED;
				}
				me.state = EMIT;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_door_open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			boolean param_door_open1 = false;
			sensor_door_open.input(id, actions);
			param_door_open1 = sensor_door_open.value(boolean.class,0);
			if ( sensor_door_open.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_door_open.clockId, 0);
			}
			if (me.doorPosition == LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				if (param_door_open1 == LGS_PilotInternalRoot.DOOR_OPEN) {
					me.doorPosition = LGS_PilotInternalRoot.OPEN;
				}
				if (param_door_open1 == LGS_PilotInternalRoot.DOOR_NOT_OPEN) {
					me.doorPosition = LGS_PilotInternalRoot.INTERMEDIATE;
				}
				me.state = EMIT;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_door_locked_closed.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			boolean param_door_locked_closed1 = false;
			sensor_door_locked_closed.input(id, actions);
			param_door_locked_closed1 = sensor_door_locked_closed.value(boolean.class,0);
			if ( sensor_door_locked_closed.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_door_locked_closed.clockId, 0);
			}
			if (me.doorPosition == LGS_PilotInternalRoot.OPEN) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				if (param_door_locked_closed1 == LGS_PilotInternalRoot.DOOR_CLOSED) {
					me.doorPosition = LGS_PilotInternalRoot.LOCKED_CLOSED;
				}
				if (param_door_locked_closed1 == LGS_PilotInternalRoot.DOOR_NOT_CLOSED) {
					me.doorPosition = LGS_PilotInternalRoot.INTERMEDIATE;
				}
				me.state = EMIT;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EMIT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			door_position.output(id, actions, me.doorPosition);
			me.state = S;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			boolean red_light = red_lightRef.get(configuration);
			modifiedBehaviors[red_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != ANOMALY) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			boolean red_light = red_lightRef.get(configuration);
			try {
				red_light = LGS_PilotInternalRoot.LIGHT_ON;
				me.state = DEAD;
				if (true) return true;
			} finally {
				red_lightRef.set(configuration, red_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_door_open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			sensor_door_open.input(id, actions);
			me.param_door_open = sensor_door_open.value(boolean.class,0);
			if ( sensor_door_open.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_door_open.clockId, 0);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_door_locked_closed.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			sensor_door_locked_closed.input(id, actions);
			me.param_door_locked_closed = sensor_door_locked_closed.value(boolean.class,0);
			if ( sensor_door_locked_closed.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_door_locked_closed.clockId, 0);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Door_sensor_synthesisConfiguration me = new Door_sensor_synthesisConfiguration();
		boolean param_door_open1;
		boolean param_door_locked_closed1;
		//Initial action code.
		me.state = INIT_door1;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Door_sensor_synthesisBehavior.INIT_door1: 
			text.append("@INIT_door1,");
			break;
		case Door_sensor_synthesisBehavior.INIT_door2: 
			text.append("@INIT_door2,");
			break;
		case Door_sensor_synthesisBehavior.S: 
			text.append("@S,");
			break;
		case Door_sensor_synthesisBehavior.EMIT: 
			text.append("@EMIT,");
			break;
		case Door_sensor_synthesisBehavior.ANOMALY: 
			text.append("@ANOMALY,");
			break;
		case Door_sensor_synthesisBehavior.DEAD: 
			text.append("@DEAD,");
			break;
		}
		text.append("\n\t- param_door_open=");
		text.append(Boolean.toString(me.param_door_open));
		text.append("\n\t- param_door_locked_closed=");
		text.append(Boolean.toString(me.param_door_locked_closed));
		text.append("\n\t- DoorPosition=");
		text.append(Integer.toString(me.doorPosition));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Door_sensor_synthesisBehavior.INIT_door1: 
			text.append("@INIT_door1,");
			break;
		case Door_sensor_synthesisBehavior.INIT_door2: 
			text.append("@INIT_door2,");
			break;
		case Door_sensor_synthesisBehavior.S: 
			text.append("@S,");
			break;
		case Door_sensor_synthesisBehavior.EMIT: 
			text.append("@EMIT,");
			break;
		case Door_sensor_synthesisBehavior.ANOMALY: 
			text.append("@ANOMALY,");
			break;
		case Door_sensor_synthesisBehavior.DEAD: 
			text.append("@DEAD,");
			break;
		}
		text.append(" param_door_open=");
		text.append(Boolean.toString(me.param_door_open));
		text.append(" param_door_locked_closed=");
		text.append(Boolean.toString(me.param_door_locked_closed));
		text.append(" DoorPosition=");
		text.append(Integer.toString(me.doorPosition));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Door_sensor_synthesisConfiguration me = new Door_sensor_synthesisConfiguration();
		me.state = boost.readShort();
		me.param_door_open = boost.readBoolean();
		me.param_door_locked_closed = boost.readBoolean();
		me.doorPosition = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Door_sensor_synthesisConfiguration me = (Door_sensor_synthesisConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.param_door_open);
		boost.writeBoolean(me.param_door_locked_closed);
		boost.writeInt(me.doorPosition);
	}

}

