package lgs_pilotinternal;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class EV_managementConfiguration extends BehaviorConfiguration {

	public short state;

	public boolean param_handle;

	public boolean param_switch;

	public boolean param_pressure;

	public int param_front_door_position;

	public int param_left_door_position;

	public int param_right_door_position;

	public int param_front_gear_position;

	public int param_left_gear_position;

	public int param_right_gear_position;

	//Create initial configuration
	public EV_managementConfiguration() {
		this.param_handle = false;
		this.param_switch = false;
		this.param_pressure = false;
		this.param_front_door_position = 0;
		this.param_left_door_position = 0;
		this.param_right_door_position = 0;
		this.param_front_gear_position = 0;
		this.param_left_gear_position = 0;
		this.param_right_gear_position = 0;
	}

	//Create configuration as a copy
	public EV_managementConfiguration(EV_managementConfiguration other) {
		this.state = other.state;
		this.param_handle = other.param_handle;
		this.param_switch = other.param_switch;
		this.param_pressure = other.param_pressure;
		this.param_front_door_position = other.param_front_door_position;
		this.param_left_door_position = other.param_left_door_position;
		this.param_right_door_position = other.param_right_door_position;
		this.param_front_gear_position = other.param_front_gear_position;
		this.param_left_gear_position = other.param_left_gear_position;
		this.param_right_gear_position = other.param_right_gear_position;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new EV_managementConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof EV_managementConfiguration) {
			EV_managementConfiguration other = (EV_managementConfiguration) object;
			if (state != other.state) return false;
			if (param_handle != other.param_handle) return false;
			if (param_switch != other.param_switch) return false;
			if (param_pressure != other.param_pressure) return false;
			if (param_front_door_position != other.param_front_door_position) return false;
			if (param_left_door_position != other.param_left_door_position) return false;
			if (param_right_door_position != other.param_right_door_position) return false;
			if (param_front_gear_position != other.param_front_gear_position) return false;
			if (param_left_gear_position != other.param_left_gear_position) return false;
			if (param_right_gear_position != other.param_right_gear_position) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + (param_handle? 1 : 0);
		total = total * 37 + (param_switch? 1 : 0);
		total = total * 37 + (param_pressure? 1 : 0);
		total = total * 37 + param_front_door_position;
		total = total * 37 + param_left_door_position;
		total = total * 37 + param_right_door_position;
		total = total * 37 + param_front_gear_position;
		total = total * 37 + param_left_gear_position;
		total = total * 37 + param_right_gear_position;
		return total;
	}

}

