package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class GearBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INIT1 = 1;

	public static final short INIT2 = 2;

	public static final short INITfromRetractEV = 3;

	public static final short INITfromExtendEV = 4;

	public static final short Final_locked_extended = 5;

	public static final short Locked_extended = 6;

	public static final short Temp_Locked_extended = 7;

	public static final short Unlocked_extended = 8;

	public static final short Suspended_Unlocked_extended = 9;

	public static final short Intermediate_from_extended_to_retracted = 10;

	public static final short Intermediate_from_retracted_to_extended = 11;

	public static final short Suspended_Intermediate = 12;

	public static final short Final_locked_retracted = 13;

	public static final short Locked_retracted = 14;

	public static final short Temp_Locked_retracted = 15;

	public static final short Unlocked_retracted = 16;

	public static final short Suspended_Unlocked_retracted = 17;

	public static final short Blocked_after_failure = 18;

	public static final short Broken_after_contrary_orders = 19;

	public static final short Emit_sensor_unlocked_extended = 20;

	public static final short Emit_sensor_locked_extended = 21;

	public static final short Emit_sensor_unlocked_retracted = 22;

	public static final short Emit_sensor_locked_retracted = 23;

	private final short informal59;

	private final short informal60;

	private final short informal61;

	private final short informal62;

	private final short informal63;

	private final short informal64;

	private final short informal65;

	private final short informal66;

	private final short informal67;

	private final short informal68;

	private final short informal69;

	private final short informal70;

	private final short informal71;

	private final short informal72;

	private final short informal73;

	private final short informal74;

	private final short informal75;

	private final short informal76;

	private final short informal77;

	private final short informal78;

	private final short informal79;

	private final short informal80;

	private final short informal81;

	private final short informal82;

	private final short informal83;

	private final short informal84;

	private final short informal85;

	private final short informal86;

	private final short informal87;

	private final short informal88;

	private final short informal89;

	private final short informal90;

	private final short informal91;

	private final short informal92;

	private final short informal93;

	private final short informal94;

	private final short informal95;

	private final short informal96;

	private final short informal97;

	private final short informal98;

	private final short informal99;

	private final short informal100;

	private final short informal101;

	private final short informal102;

	private final short informal103;

	private final short informal104;

	private final short informal105;

	private final short informal106;

	private final short informal107;

	private final short informal108;

	private final short informal109;

	private final short informal110;

	private final BroadcastChannel retract_pressure;

	private final BroadcastChannel extend_pressure;

	private final BroadcastChannel port_from_dispatch;

	private final BroadcastChannel sensor_locked_extended;

	private final BroadcastChannel sensor_locked_retracted;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final WaitChannel wait2;

	private final WaitChannel wait3;

	private final WaitChannel wait4;

	private final WaitChannel wait5;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public GearBehavior(SymbolsTable symbols, BroadcastChannel retract_pressure, BroadcastChannel extend_pressure, BroadcastChannel port_from_dispatch, BroadcastChannel sensor_locked_extended, BroadcastChannel sensor_locked_retracted) {
		super("Gear", idSeed++, symbols);
		this.retract_pressure = retract_pressure;
		this.extend_pressure = extend_pressure;
		this.port_from_dispatch = port_from_dispatch;
		this.sensor_locked_extended = sensor_locked_extended;
		this.sensor_locked_retracted = sensor_locked_retracted;
		inputChannels = new Channel[]{this.retract_pressure, this.extend_pressure, this.port_from_dispatch};
		outputChannels = new Channel[]{this.sensor_locked_extended, this.sensor_locked_retracted};
		informal59 = symbols.getInformalId("Gear Final_locked_extended -> Blocked_after_failure");
		informal60 = symbols.getInformalId("Gear Final_locked_extended -> temp_Locked_extended");
		informal61 = symbols.getInformalId("Gear Final_locked_extended : unexpected order");
		informal62 = symbols.getInformalId("Gear temp_Locked_extended -> Blocked_after_failure");
		informal63 = symbols.getInformalId("Gear temp_Locked_extended : unexpected order");
		informal64 = symbols.getInformalId("Gear temp_Locked_extended  -> Final_locked_extended");
		informal65 = symbols.getInformalId("Gear temp_Locked_extended -> Broken_after_contrary_orders");
		informal66 = symbols.getInformalId("Gear temp_Locked_extended -> Intermediate_e2r");
		informal67 = symbols.getInformalId("Gear Locked_extended -> Blocked_after_failure");
		informal68 = symbols.getInformalId("Gear Locked_extended -> Broken_after_contrary_orders");
		informal69 = symbols.getInformalId("Gear Locked_extended : unexpected order");
		informal70 = symbols.getInformalId("Gear Locked_extended -> Final_locked_extended");
		informal71 = symbols.getInformalId("Gear Unlocked_extended -> Blocked_after_failure");
		informal72 = symbols.getInformalId("Gear Unlocked_extended -> Broken_after_contrary_orders");
		informal73 = symbols.getInformalId("Gear Unlocked_extended -> suspended_Unlocked_extended");
		informal74 = symbols.getInformalId("Gear Unlocked_extended : unexpected order");
		informal75 = symbols.getInformalId("Gear suspended_Unlocked_extended -> Blocked_after_failure");
		informal76 = symbols.getInformalId("Gear suspended_Unlocked_extended -> Intermediate_e2r");
		informal77 = symbols.getInformalId("Gear suspended_Unlocked_extended : unexpected order");
		informal78 = symbols.getInformalId("Gear suspended_Unlocked_extended -> Unlocked_extended");
		informal79 = symbols.getInformalId("Gear Intermediate_from_extended_to_retracted -> Blocked_after_failure");
		informal80 = symbols.getInformalId("Gear Intermediate_from_extended_to_retracted : unexpected order");
		informal81 = symbols.getInformalId("Gear Intermediate_from_extended_to_retracted  -> suspended_Intermediate");
		informal82 = symbols.getInformalId("Gear Intermediate_from_extended_to_retracted -> Broken_after_contrary_orders");
		informal83 = symbols.getInformalId("Gear suspended_Intermediate -> Blocked_after_failure");
		informal84 = symbols.getInformalId("Gear suspended_Intermediate -> Intermediate_from_extended_to_retracted");
		informal85 = symbols.getInformalId("Gear suspended_Intermediate : unexpected orders");
		informal86 = symbols.getInformalId("Gear suspended_Intermediate -> Intermediate_from_retracted_to_extended");
		informal87 = symbols.getInformalId("Gear Intermediate_from_retracted_to_extended -> Blocked_after_failure");
		informal88 = symbols.getInformalId("Gear Intermediate_from_retracted_to_extended -> Broken_after_contrary_orders");
		informal89 = symbols.getInformalId("Gear Intermediate_from_retracted_to_extended -> suspended_Intermediate");
		informal90 = symbols.getInformalId("Gear Intermediate_from_retracted_to_extended -> Unlocked_extended");
		informal91 = symbols.getInformalId("Gear Final_locked_retracted -> Blocked_after_failure");
		informal92 = symbols.getInformalId("Gear Final_locked_retracted -> temp_Locked_retracted");
		informal93 = symbols.getInformalId("Gear Final_locked_retracted : unexpected order");
		informal94 = symbols.getInformalId("Gear temp_Locked_retracted -> Blocked_after_failure");
		informal95 = symbols.getInformalId("Gear temp_Locked_retracted : unexpected order");
		informal96 = symbols.getInformalId("Gear temp_Locked_retracted  -> Final_locked_retracted");
		informal97 = symbols.getInformalId("Gear temp_Locked_retracted -> Broken_after_contrary_orders");
		informal98 = symbols.getInformalId("Gear temp_Locked_retracted -> Intermediate_r2e");
		informal99 = symbols.getInformalId("Gear Locked_retracted -> Blocked_after_failure");
		informal100 = symbols.getInformalId("Gear Locked_retracted -> Broken_after_contrary_orders");
		informal101 = symbols.getInformalId("Gear Locked_retracted : unexpected order");
		informal102 = symbols.getInformalId("Gear Locked_retracted -> Final_locked_retracted");
		informal103 = symbols.getInformalId("Gear Unlocked_retracted -> Blocked_after_failure");
		informal104 = symbols.getInformalId("Gear Unlocked_retracted -> Broken_after_contrary_orders");
		informal105 = symbols.getInformalId("Gear Unlocked_retracted : unexpected order");
		informal106 = symbols.getInformalId("Gear Unlocked_retracted -> suspended_Unlocked_retracted");
		informal107 = symbols.getInformalId("Gear suspended_Unlocked_retracted -> Blocked_after_failure");
		informal108 = symbols.getInformalId("Gear suspended_Unlocked_retracted -> Intermediate_r2e");
		informal109 = symbols.getInformalId("Gear suspended_Unlocked_retracted : unexpected order");
		informal110 = symbols.getInformalId("Gear suspended_Unlocked_retracted -> Unlocked_retracted");
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 9, false, 9, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 0, 5, false, 5, false);
		wait2 = new WaitChannel(null, symbols, this.getId(), (short) 0, 19, false, 19, false);
		wait3 = new WaitChannel(null, symbols, this.getId(), (short) 0, 14, false, 14, false);
		wait4 = new WaitChannel(null, symbols, this.getId(), (short) 0, 9, false, 9, false);
		wait5 = new WaitChannel(null, symbols, this.getId(), (short) 0, 5, false, 5, false);
		channels = new Channel[] { wait0, wait1, wait2, wait3, wait4, wait5,  };
	}

	private final String[] stateNames = new String[] {"INIT1", "INIT2", "INITfromRetractEV", "INITfromExtendEV", "Final_locked_extended", "Locked_extended", "temp_Locked_extended", "Unlocked_extended", "suspended_Unlocked_extended", "Intermediate_from_extended_to_retracted", "Intermediate_from_retracted_to_extended", "suspended_Intermediate", "Final_locked_retracted", "Locked_retracted", "temp_Locked_retracted", "Unlocked_retracted", "suspended_Unlocked_retracted", "Blocked_after_failure", "Broken_after_contrary_orders", "emit_sensor_unlocked_extended", "emit_sensor_locked_extended", "emit_sensor_unlocked_retracted", "emit_sensor_locked_retracted"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INITfromRetractEV) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			me.state = INITfromExtendEV;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INITfromExtendEV) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			me.state = INIT1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_locked_extended.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			sensor_locked_extended.output(id, actions, LGS_PilotInternalRoot.GEAR_EXTENDED);
			me.state = INIT2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_locked_retracted.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			sensor_locked_retracted.output(id, actions, LGS_PilotInternalRoot.GEAR_NOT_RETRACTED);
			me.state = Final_locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal59));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal60));
				me.state = Temp_Locked_extended;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal61));
				me.state = Final_locked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Final_locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			actions.add(new InformalAction(id, informal61));
			me.state = Final_locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal62));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal63));
				me.state = Temp_Locked_extended;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal64));
				me.state = Final_locked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Temp_Locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal65));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal63));
				me.state = Temp_Locked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Temp_Locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal66));
			me.state = Emit_sensor_unlocked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_locked_extended.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit_sensor_unlocked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			sensor_locked_extended.output(id, actions, LGS_PilotInternalRoot.GEAR_NOT_EXTENDED);
			me.state = Intermediate_from_extended_to_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal67));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal68));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal69));
				me.state = Locked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal70));
				me.state = Final_locked_extended;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal69));
				me.state = Locked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal71));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition16 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal72));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal69));
				me.state = Unlocked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Unlocked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition17 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal73));
				me.state = Suspended_Unlocked_extended;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal74));
				me.state = Unlocked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Unlocked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition18 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait1.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = Emit_sensor_locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition19 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_locked_extended.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit_sensor_locked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			sensor_locked_extended.output(id, actions, LGS_PilotInternalRoot.GEAR_EXTENDED);
			me.state = Locked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition20 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal75));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition21 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal76));
				me.state = Intermediate_from_extended_to_retracted;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal77));
				me.state = Suspended_Unlocked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Unlocked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition22 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal78));
				me.state = Unlocked_extended;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal77));
				me.state = Suspended_Unlocked_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Unlocked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition23 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_extended_to_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal79));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition24 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_extended_to_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal80));
				me.state = Intermediate_from_extended_to_retracted;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal81));
				me.state = Suspended_Intermediate;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_extended_to_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition25 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_extended_to_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal82));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal63));
				me.state = Intermediate_from_extended_to_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_extended_to_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition26 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait2.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_extended_to_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait2.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = Unlocked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition27 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Intermediate) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal83));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition28 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Intermediate) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal84));
				me.state = Intermediate_from_extended_to_retracted;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal85));
				me.state = Suspended_Intermediate;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Intermediate;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition29 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Intermediate) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal86));
				me.state = Intermediate_from_retracted_to_extended;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal85));
				me.state = Suspended_Intermediate;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Intermediate;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition30 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_retracted_to_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal87));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition31 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_retracted_to_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal88));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal85));
				me.state = Intermediate_from_retracted_to_extended;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_retracted_to_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition32 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_retracted_to_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal85));
				me.state = Intermediate_from_retracted_to_extended;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal89));
				me.state = Suspended_Intermediate;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_retracted_to_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition33 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait3.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_retracted_to_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait3.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal90));
			me.state = Unlocked_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition34 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal91));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition35 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal92));
				me.state = Temp_Locked_retracted;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal93));
				me.state = Final_locked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Final_locked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition36 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			actions.add(new InformalAction(id, informal93));
			me.state = Final_locked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition37 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal94));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition38 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal95));
				me.state = Temp_Locked_retracted;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal96));
				me.state = Final_locked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Temp_Locked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition39 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal97));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal95));
				me.state = Temp_Locked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Temp_Locked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition40 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait4.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait4.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal98));
			me.state = Emit_sensor_unlocked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition41 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_locked_retracted.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit_sensor_unlocked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			sensor_locked_retracted.output(id, actions, LGS_PilotInternalRoot.GEAR_NOT_RETRACTED);
			me.state = Intermediate_from_retracted_to_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition42 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal99));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition43 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal100));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal101));
				me.state = Locked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Locked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition44 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal102));
				me.state = Final_locked_retracted;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal101));
				me.state = Locked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Locked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition45 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal103));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition46 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal104));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal105));
				me.state = Unlocked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Unlocked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition47 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal106));
				me.state = Suspended_Unlocked_retracted;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal105));
				me.state = Unlocked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Unlocked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition48 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait5.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait5.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = Emit_sensor_locked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition49 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_locked_retracted.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit_sensor_locked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			sensor_locked_retracted.output(id, actions, LGS_PilotInternalRoot.GEAR_RETRACTED);
			me.state = Locked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition50 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal107));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition51 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal108));
				me.state = Intermediate_from_retracted_to_extended;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal109));
				me.state = Suspended_Unlocked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Unlocked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition52 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal110));
				me.state = Unlocked_retracted;
				if (true) return true;
			} else if ((param_pressure) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal109));
				me.state = Suspended_Unlocked_retracted;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Unlocked_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition53 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_after_failure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition54 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_after_failure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition55 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_after_failure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition56 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Broken_after_contrary_orders) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			retract_pressure.input(id, actions);
			param_pressure = retract_pressure.value(boolean.class,0);
			if ( retract_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, retract_pressure.clockId, 0);
			}
			me.state = Broken_after_contrary_orders;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition57 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Broken_after_contrary_orders) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			boolean param_pressure = false;
			extend_pressure.input(id, actions);
			param_pressure = extend_pressure.value(boolean.class,0);
			if ( extend_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, extend_pressure.clockId, 0);
			}
			me.state = Broken_after_contrary_orders;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition58 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Broken_after_contrary_orders) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final GearConfiguration me = (GearConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			port_from_dispatch.input(id, actions);
			param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			me.state = Broken_after_contrary_orders;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
		transition16,
		transition17,
		transition18,
		transition19,
		transition20,
		transition21,
		transition22,
		transition23,
		transition24,
		transition25,
		transition26,
		transition27,
		transition28,
		transition29,
		transition30,
		transition31,
		transition32,
		transition33,
		transition34,
		transition35,
		transition36,
		transition37,
		transition38,
		transition39,
		transition40,
		transition41,
		transition42,
		transition43,
		transition44,
		transition45,
		transition46,
		transition47,
		transition48,
		transition49,
		transition50,
		transition51,
		transition52,
		transition53,
		transition54,
		transition55,
		transition56,
		transition57,
		transition58,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		GearConfiguration me = new GearConfiguration();
		int param_from_dispatch;
		boolean param_pressure;
		//Initial action code.
		me.state = INITfromRetractEV;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		GearConfiguration me = (GearConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case GearBehavior.INIT1: 
			text.append("@INIT1,");
			break;
		case GearBehavior.INIT2: 
			text.append("@INIT2,");
			break;
		case GearBehavior.INITfromRetractEV: 
			text.append("@INITfromRetractEV,");
			break;
		case GearBehavior.INITfromExtendEV: 
			text.append("@INITfromExtendEV,");
			break;
		case GearBehavior.Final_locked_extended: 
			text.append("@Final_locked_extended,");
			break;
		case GearBehavior.Locked_extended: 
			text.append("@Locked_extended,");
			break;
		case GearBehavior.Temp_Locked_extended: 
			text.append("@temp_Locked_extended,");
			break;
		case GearBehavior.Unlocked_extended: 
			text.append("@Unlocked_extended,");
			break;
		case GearBehavior.Suspended_Unlocked_extended: 
			text.append("@suspended_Unlocked_extended,");
			break;
		case GearBehavior.Intermediate_from_extended_to_retracted: 
			text.append("@Intermediate_from_extended_to_retracted,");
			break;
		case GearBehavior.Intermediate_from_retracted_to_extended: 
			text.append("@Intermediate_from_retracted_to_extended,");
			break;
		case GearBehavior.Suspended_Intermediate: 
			text.append("@suspended_Intermediate,");
			break;
		case GearBehavior.Final_locked_retracted: 
			text.append("@Final_locked_retracted,");
			break;
		case GearBehavior.Locked_retracted: 
			text.append("@Locked_retracted,");
			break;
		case GearBehavior.Temp_Locked_retracted: 
			text.append("@temp_Locked_retracted,");
			break;
		case GearBehavior.Unlocked_retracted: 
			text.append("@Unlocked_retracted,");
			break;
		case GearBehavior.Suspended_Unlocked_retracted: 
			text.append("@suspended_Unlocked_retracted,");
			break;
		case GearBehavior.Blocked_after_failure: 
			text.append("@Blocked_after_failure,");
			break;
		case GearBehavior.Broken_after_contrary_orders: 
			text.append("@Broken_after_contrary_orders,");
			break;
		case GearBehavior.Emit_sensor_unlocked_extended: 
			text.append("@emit_sensor_unlocked_extended,");
			break;
		case GearBehavior.Emit_sensor_locked_extended: 
			text.append("@emit_sensor_locked_extended,");
			break;
		case GearBehavior.Emit_sensor_unlocked_retracted: 
			text.append("@emit_sensor_unlocked_retracted,");
			break;
		case GearBehavior.Emit_sensor_locked_retracted: 
			text.append("@emit_sensor_locked_retracted,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		GearConfiguration me = (GearConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case GearBehavior.INIT1: 
			text.append("@INIT1,");
			break;
		case GearBehavior.INIT2: 
			text.append("@INIT2,");
			break;
		case GearBehavior.INITfromRetractEV: 
			text.append("@INITfromRetractEV,");
			break;
		case GearBehavior.INITfromExtendEV: 
			text.append("@INITfromExtendEV,");
			break;
		case GearBehavior.Final_locked_extended: 
			text.append("@Final_locked_extended,");
			break;
		case GearBehavior.Locked_extended: 
			text.append("@Locked_extended,");
			break;
		case GearBehavior.Temp_Locked_extended: 
			text.append("@temp_Locked_extended,");
			break;
		case GearBehavior.Unlocked_extended: 
			text.append("@Unlocked_extended,");
			break;
		case GearBehavior.Suspended_Unlocked_extended: 
			text.append("@suspended_Unlocked_extended,");
			break;
		case GearBehavior.Intermediate_from_extended_to_retracted: 
			text.append("@Intermediate_from_extended_to_retracted,");
			break;
		case GearBehavior.Intermediate_from_retracted_to_extended: 
			text.append("@Intermediate_from_retracted_to_extended,");
			break;
		case GearBehavior.Suspended_Intermediate: 
			text.append("@suspended_Intermediate,");
			break;
		case GearBehavior.Final_locked_retracted: 
			text.append("@Final_locked_retracted,");
			break;
		case GearBehavior.Locked_retracted: 
			text.append("@Locked_retracted,");
			break;
		case GearBehavior.Temp_Locked_retracted: 
			text.append("@temp_Locked_retracted,");
			break;
		case GearBehavior.Unlocked_retracted: 
			text.append("@Unlocked_retracted,");
			break;
		case GearBehavior.Suspended_Unlocked_retracted: 
			text.append("@suspended_Unlocked_retracted,");
			break;
		case GearBehavior.Blocked_after_failure: 
			text.append("@Blocked_after_failure,");
			break;
		case GearBehavior.Broken_after_contrary_orders: 
			text.append("@Broken_after_contrary_orders,");
			break;
		case GearBehavior.Emit_sensor_unlocked_extended: 
			text.append("@emit_sensor_unlocked_extended,");
			break;
		case GearBehavior.Emit_sensor_locked_extended: 
			text.append("@emit_sensor_locked_extended,");
			break;
		case GearBehavior.Emit_sensor_unlocked_retracted: 
			text.append("@emit_sensor_unlocked_retracted,");
			break;
		case GearBehavior.Emit_sensor_locked_retracted: 
			text.append("@emit_sensor_locked_retracted,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		GearConfiguration me = new GearConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		GearConfiguration me = (GearConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

