package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Gear_sensor_synthesisBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INIT_gear1 = 1;

	public static final short INIT_gear2 = 2;

	public static final short S = 3;

	public static final short EMIT = 4;

	public static final short ANOMALY = 5;

	public static final short DEAD = 6;

	private final BroadcastChannel sensor_gear_locked_extended;

	private final BroadcastChannel sensor_gear_locked_retracted;

	private final BroadcastChannel gear_position;

	private final ReferencedArgumentBoolean red_lightRef;

	public Gear_sensor_synthesisBehavior(SymbolsTable symbols, BroadcastChannel sensor_gear_locked_extended, BroadcastChannel sensor_gear_locked_retracted, BroadcastChannel gear_position, ReferencedArgumentBoolean red_light) {
		super("gear_sensor_synthesis", idSeed++, symbols);
		this.sensor_gear_locked_extended = sensor_gear_locked_extended;
		this.sensor_gear_locked_retracted = sensor_gear_locked_retracted;
		this.gear_position = gear_position;
		inputChannels = new Channel[]{this.sensor_gear_locked_extended, this.sensor_gear_locked_retracted};
		outputChannels = new Channel[]{this.gear_position};
		this.red_lightRef = red_light;
	}

	private final String[] stateNames = new String[] {"INIT_gear1", "INIT_gear2", "S", "EMIT", "ANOMALY", "DEAD"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_gear_locked_extended.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_gear1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			sensor_gear_locked_extended.input(id, actions);
			me.param_gear_locked_extended = sensor_gear_locked_extended.value(boolean.class,0);
			if ( sensor_gear_locked_extended.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_gear_locked_extended.clockId, 0);
			}
			me.state = INIT_gear2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_gear_locked_retracted.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_gear2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			sensor_gear_locked_retracted.input(id, actions);
			me.param_gear_locked_retracted = sensor_gear_locked_retracted.value(boolean.class,0);
			if ( sensor_gear_locked_retracted.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_gear_locked_retracted.clockId, 0);
			}
			if ((me.param_gear_locked_extended == LGS_PilotInternalRoot.GEAR_EXTENDED) && (me.param_gear_locked_retracted == LGS_PilotInternalRoot.GEAR_RETRACTED)) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				if (me.param_gear_locked_extended == LGS_PilotInternalRoot.GEAR_EXTENDED) {
					me.gearPosition = LGS_PilotInternalRoot.LOCKED_EXTENDED;
				}
				if ((me.param_gear_locked_extended == LGS_PilotInternalRoot.GEAR_NOT_EXTENDED) && (me.param_gear_locked_retracted == LGS_PilotInternalRoot.GEAR_NOT_RETRACTED)) {
					me.gearPosition = LGS_PilotInternalRoot.INTERMEDIATE;
				}
				if (me.param_gear_locked_retracted == LGS_PilotInternalRoot.GEAR_RETRACTED) {
					me.gearPosition = LGS_PilotInternalRoot.LOCKED_RETRACTED;
				}
				me.state = EMIT;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_gear_locked_extended.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			boolean param_gear_locked_extended1 = false;
			sensor_gear_locked_extended.input(id, actions);
			param_gear_locked_extended1 = sensor_gear_locked_extended.value(boolean.class,0);
			if ( sensor_gear_locked_extended.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_gear_locked_extended.clockId, 0);
			}
			if (me.gearPosition == LGS_PilotInternalRoot.LOCKED_RETRACTED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				if (param_gear_locked_extended1 == LGS_PilotInternalRoot.GEAR_EXTENDED) {
					me.gearPosition = LGS_PilotInternalRoot.LOCKED_EXTENDED;
				}
				if (param_gear_locked_extended1 == LGS_PilotInternalRoot.GEAR_NOT_EXTENDED) {
					me.gearPosition = LGS_PilotInternalRoot.INTERMEDIATE;
				}
				me.state = EMIT;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_gear_locked_retracted.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			boolean param_gear_locked_retracted1 = false;
			sensor_gear_locked_retracted.input(id, actions);
			param_gear_locked_retracted1 = sensor_gear_locked_retracted.value(boolean.class,0);
			if ( sensor_gear_locked_retracted.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_gear_locked_retracted.clockId, 0);
			}
			if (me.gearPosition == LGS_PilotInternalRoot.LOCKED_EXTENDED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				if (param_gear_locked_retracted1 == LGS_PilotInternalRoot.GEAR_RETRACTED) {
					me.gearPosition = LGS_PilotInternalRoot.LOCKED_RETRACTED;
				}
				if (param_gear_locked_retracted1 == LGS_PilotInternalRoot.GEAR_NOT_RETRACTED) {
					me.gearPosition = LGS_PilotInternalRoot.INTERMEDIATE;
				}
				me.state = EMIT;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EMIT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			gear_position.output(id, actions, me.gearPosition);
			me.state = S;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			boolean red_light = red_lightRef.get(configuration);
			modifiedBehaviors[red_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != ANOMALY) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			boolean red_light = red_lightRef.get(configuration);
			try {
				red_light = LGS_PilotInternalRoot.LIGHT_ON;
				me.state = DEAD;
				if (true) return true;
			} finally {
				red_lightRef.set(configuration, red_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_gear_locked_extended.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			sensor_gear_locked_extended.input(id, actions);
			me.param_gear_locked_extended = sensor_gear_locked_extended.value(boolean.class,0);
			if ( sensor_gear_locked_extended.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_gear_locked_extended.clockId, 0);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_gear_locked_retracted.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) configuration.behaviorConfigurations[id];
			sensor_gear_locked_retracted.input(id, actions);
			me.param_gear_locked_retracted = sensor_gear_locked_retracted.value(boolean.class,0);
			if ( sensor_gear_locked_retracted.clockId != -1 ) {
				DBM.set(configuration.dbm, sensor_gear_locked_retracted.clockId, 0);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Gear_sensor_synthesisConfiguration me = new Gear_sensor_synthesisConfiguration();
		boolean param_gear_locked_extended1;
		boolean param_gear_locked_retracted1;
		//Initial action code.
		me.state = INIT_gear1;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Gear_sensor_synthesisBehavior.INIT_gear1: 
			text.append("@INIT_gear1,");
			break;
		case Gear_sensor_synthesisBehavior.INIT_gear2: 
			text.append("@INIT_gear2,");
			break;
		case Gear_sensor_synthesisBehavior.S: 
			text.append("@S,");
			break;
		case Gear_sensor_synthesisBehavior.EMIT: 
			text.append("@EMIT,");
			break;
		case Gear_sensor_synthesisBehavior.ANOMALY: 
			text.append("@ANOMALY,");
			break;
		case Gear_sensor_synthesisBehavior.DEAD: 
			text.append("@DEAD,");
			break;
		}
		text.append("\n\t- param_gear_locked_extended=");
		text.append(Boolean.toString(me.param_gear_locked_extended));
		text.append("\n\t- param_gear_locked_retracted=");
		text.append(Boolean.toString(me.param_gear_locked_retracted));
		text.append("\n\t- GearPosition=");
		text.append(Integer.toString(me.gearPosition));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Gear_sensor_synthesisBehavior.INIT_gear1: 
			text.append("@INIT_gear1,");
			break;
		case Gear_sensor_synthesisBehavior.INIT_gear2: 
			text.append("@INIT_gear2,");
			break;
		case Gear_sensor_synthesisBehavior.S: 
			text.append("@S,");
			break;
		case Gear_sensor_synthesisBehavior.EMIT: 
			text.append("@EMIT,");
			break;
		case Gear_sensor_synthesisBehavior.ANOMALY: 
			text.append("@ANOMALY,");
			break;
		case Gear_sensor_synthesisBehavior.DEAD: 
			text.append("@DEAD,");
			break;
		}
		text.append(" param_gear_locked_extended=");
		text.append(Boolean.toString(me.param_gear_locked_extended));
		text.append(" param_gear_locked_retracted=");
		text.append(Boolean.toString(me.param_gear_locked_retracted));
		text.append(" GearPosition=");
		text.append(Integer.toString(me.gearPosition));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Gear_sensor_synthesisConfiguration me = new Gear_sensor_synthesisConfiguration();
		me.state = boost.readShort();
		me.param_gear_locked_extended = boost.readBoolean();
		me.param_gear_locked_retracted = boost.readBoolean();
		me.gearPosition = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Gear_sensor_synthesisConfiguration me = (Gear_sensor_synthesisConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.param_gear_locked_extended);
		boost.writeBoolean(me.param_gear_locked_retracted);
		boost.writeInt(me.gearPosition);
	}

}

