package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class General_EVBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INIT2soft = 1;

	public static final short INIT2EV = 2;

	public static final short INITfromSwitch = 3;

	public static final short INITfromSoft = 4;

	public static final short Open = 5;

	public static final short EmitOpen = 6;

	public static final short Closed = 7;

	public static final short EmitClosed = 8;

	public static final short FromOpenToClosed = 9;

	public static final short FromClosedToOpen = 10;

	public static final short BlockedOpen = 11;

	public static final short EmitBlockedOpen = 12;

	public static final short BlockedClosed = 13;

	public static final short EmitBlockedClosed = 14;

	private final short informal37;

	private final short informal38;

	private final short informal39;

	private final short informal40;

	private final short informal41;

	private final short informal42;

	private final short informal43;

	private final short informal44;

	private final short informal45;

	private final short informal46;

	private final short informal47;

	private final BroadcastChannel from_cmdEV;

	private final BroadcastChannel from_analog_switch;

	private final BroadcastChannel from_dispatch;

	private final BroadcastChannel fromGeneralEV;

	private final ReferencedArgumentBoolean hydraulicPressionInRef;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public General_EVBehavior(SymbolsTable symbols, BroadcastChannel from_cmdEV, BroadcastChannel from_analog_switch, BroadcastChannel from_dispatch, BroadcastChannel fromGeneralEV, ReferencedArgumentBoolean hydraulicPressionIn) {
		super("General_EV", idSeed++, symbols);
		this.from_cmdEV = from_cmdEV;
		this.from_analog_switch = from_analog_switch;
		this.from_dispatch = from_dispatch;
		this.fromGeneralEV = fromGeneralEV;
		inputChannels = new Channel[]{this.from_cmdEV, this.from_analog_switch, this.from_dispatch};
		outputChannels = new Channel[]{this.fromGeneralEV};
		this.hydraulicPressionInRef = hydraulicPressionIn;
		informal37 = symbols.getInformalId("General_EV_open->bl-open");
		informal38 = symbols.getInformalId("General_EV_open->bl-closed");
		informal39 = symbols.getInformalId("General_EV_open->interm-open");
		informal40 = symbols.getInformalId("General_EV_interm-open->bl-open");
		informal41 = symbols.getInformalId("General_EV_interm-open->bl-closed");
		informal42 = symbols.getInformalId("General_EV Closed->bl-open");
		informal43 = symbols.getInformalId("General_EV Closed->bl-closed");
		informal44 = symbols.getInformalId("General_EV Closed->interm-closed");
		informal45 = symbols.getInformalId("General_EV FromClosedToOpen->bl-open");
		informal46 = symbols.getInformalId("General_EV FromClosedToOpen->bl-closed");
		informal47 = symbols.getInformalId("General_EV FromClosedToOpen->Closed");
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 10, false, 10, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 0, 36, false, 36, false);
		channels = new Channel[] { wait0, wait1,  };
	}

	private final String[] stateNames = new String[] {"INIT2soft", "INIT2EV", "INITfromSwitch", "INITfromSoft", "Open", "emitOpen", "Closed", "emitClosed", "FromOpenToClosed", "FromClosedToOpen", "BlockedOpen", "emitBlockedOpen", "BlockedClosed", "emitBlockedClosed"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_analog_switch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INITfromSwitch) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_analog_switch.input(id, actions);
			me.param_from_analog_switch = from_analog_switch.value(boolean.class,0);
			if ( from_analog_switch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_analog_switch.clockId, 0);
			}
			me.state = INIT2soft;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromGeneralEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT2soft) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			fromGeneralEV.output(id, actions, LGS_PilotInternalRoot.PRESSURE_OFF);
			me.state = INITfromSoft;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INITfromSoft) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromGeneralEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EmitOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			fromGeneralEV.output(id, actions, LGS_PilotInternalRoot.PRESSURE_OFF);
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal37));
				me.state = BlockedOpen;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal38));
				me.state = EmitBlockedClosed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_ON) {
				if (me.param_from_analog_switch == LGS_PilotInternalRoot.SWITCH_ON) {
					actions.add(new InformalAction(id, informal39));
					me.state = FromOpenToClosed;
					if (true) return true;
				} else {
					me.state = Open;
					if (true) return true;
				}
			} else if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_OFF) {
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_analog_switch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_analog_switch.input(id, actions);
			me.param_from_analog_switch = from_analog_switch.value(boolean.class,0);
			if ( from_analog_switch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_analog_switch.clockId, 0);
			}
			if ((me.param_from_analog_switch) == LGS_PilotInternalRoot.SWITCH_ON) {
				if (me.param_cmdEV == LGS_PilotInternalRoot.EV_ON) {
					actions.add(new InformalAction(id, informal39));
					me.state = FromOpenToClosed;
					if (true) return true;
				} else {
					me.state = Open;
					if (true) return true;
				}
			} else if ((me.param_from_analog_switch) == LGS_PilotInternalRoot.SWITCH_OFF) {
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromOpenToClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal40));
				me.state = BlockedOpen;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal41));
				me.state = EmitBlockedClosed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromOpenToClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromOpenToClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_ON) {
				me.state = FromOpenToClosed;
				if (true) return true;
			} else if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_OFF) {
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromOpenToClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_analog_switch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromOpenToClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_analog_switch.input(id, actions);
			me.param_from_analog_switch = from_analog_switch.value(boolean.class,0);
			if ( from_analog_switch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_analog_switch.clockId, 0);
			}
			if ((me.param_from_analog_switch) == LGS_PilotInternalRoot.SWITCH_ON) {
				me.state = FromOpenToClosed;
				if (true) return true;
			} else if ((me.param_from_analog_switch) == LGS_PilotInternalRoot.SWITCH_OFF) {
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromOpenToClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromOpenToClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = EmitClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromGeneralEV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			boolean hydraulicPressionIn = hydraulicPressionInRef.get(configuration);
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EmitClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			boolean hydraulicPressionIn = hydraulicPressionInRef.get(configuration);
			try {
				fromGeneralEV.output(id, actions, hydraulicPressionIn);
				me.state = Closed;
				if (true) return true;
			} finally {
				hydraulicPressionInRef.set(configuration, hydraulicPressionIn);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal42));
				me.state = EmitBlockedOpen;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal43));
				me.state = BlockedClosed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_ON) {
				me.state = Closed;
				if (true) return true;
			} else if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_OFF) {
				actions.add(new InformalAction(id, informal44));
				me.state = FromClosedToOpen;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_analog_switch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_analog_switch.input(id, actions);
			me.param_from_analog_switch = from_analog_switch.value(boolean.class,0);
			if ( from_analog_switch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_analog_switch.clockId, 0);
			}
			if ((me.param_from_analog_switch) == LGS_PilotInternalRoot.SWITCH_ON) {
				me.state = Closed;
				if (true) return true;
			} else if ((me.param_from_analog_switch) == LGS_PilotInternalRoot.SWITCH_OFF) {
				actions.add(new InformalAction(id, informal44));
				me.state = FromClosedToOpen;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromClosedToOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal45));
				me.state = EmitBlockedOpen;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal46));
				me.state = BlockedClosed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromClosedToOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition16 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromClosedToOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_ON) {
				if (me.param_from_analog_switch == LGS_PilotInternalRoot.SWITCH_ON) {
					actions.add(new InformalAction(id, informal47));
					me.state = Closed;
					if (true) return true;
				} else {
					me.state = FromClosedToOpen;
					if (true) return true;
				}
			} else if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_OFF) {
				me.state = FromClosedToOpen;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromClosedToOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition17 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_analog_switch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromClosedToOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_analog_switch.input(id, actions);
			me.param_from_analog_switch = from_analog_switch.value(boolean.class,0);
			if ( from_analog_switch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_analog_switch.clockId, 0);
			}
			if ((me.param_from_analog_switch) == LGS_PilotInternalRoot.SWITCH_ON) {
				if (me.param_cmdEV == LGS_PilotInternalRoot.EV_ON) {
					actions.add(new InformalAction(id, informal47));
					me.state = Closed;
					if (true) return true;
				} else {
					me.state = FromClosedToOpen;
					if (true) return true;
				}
			} else if ((me.param_from_analog_switch) == LGS_PilotInternalRoot.SWITCH_OFF) {
				me.state = FromClosedToOpen;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromClosedToOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition18 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromClosedToOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait1.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = EmitOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition19 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromGeneralEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EmitBlockedOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			fromGeneralEV.output(id, actions, LGS_PilotInternalRoot.PRESSURE_OFF);
			me.state = BlockedOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition20 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			me.state = BlockedOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition21 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			me.state = BlockedOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition22 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_analog_switch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_analog_switch.input(id, actions);
			me.param_from_analog_switch = from_analog_switch.value(boolean.class,0);
			if ( from_analog_switch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_analog_switch.clockId, 0);
			}
			me.state = BlockedOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition23 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return fromGeneralEV.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			boolean hydraulicPressionIn = hydraulicPressionInRef.get(configuration);
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EmitBlockedClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			boolean hydraulicPressionIn = hydraulicPressionInRef.get(configuration);
			try {
				fromGeneralEV.output(id, actions, hydraulicPressionIn);
				me.state = BlockedClosed;
				if (true) return true;
			} finally {
				hydraulicPressionInRef.set(configuration, hydraulicPressionIn);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition24 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			me.state = BlockedClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition25 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			me.state = BlockedClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition26 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_analog_switch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final General_EVConfiguration me = (General_EVConfiguration) configuration.behaviorConfigurations[id];
			from_analog_switch.input(id, actions);
			me.param_from_analog_switch = from_analog_switch.value(boolean.class,0);
			if ( from_analog_switch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_analog_switch.clockId, 0);
			}
			me.state = BlockedClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
		transition16,
		transition17,
		transition18,
		transition19,
		transition20,
		transition21,
		transition22,
		transition23,
		transition24,
		transition25,
		transition26,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		General_EVConfiguration me = new General_EVConfiguration();
		int param_from_dispatch;
		//Initial action code.
		me.state = INITfromSwitch;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		General_EVConfiguration me = (General_EVConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case General_EVBehavior.INIT2soft: 
			text.append("@INIT2soft,");
			break;
		case General_EVBehavior.INIT2EV: 
			text.append("@INIT2EV,");
			break;
		case General_EVBehavior.INITfromSwitch: 
			text.append("@INITfromSwitch,");
			break;
		case General_EVBehavior.INITfromSoft: 
			text.append("@INITfromSoft,");
			break;
		case General_EVBehavior.Open: 
			text.append("@Open,");
			break;
		case General_EVBehavior.EmitOpen: 
			text.append("@emitOpen,");
			break;
		case General_EVBehavior.Closed: 
			text.append("@Closed,");
			break;
		case General_EVBehavior.EmitClosed: 
			text.append("@emitClosed,");
			break;
		case General_EVBehavior.FromOpenToClosed: 
			text.append("@FromOpenToClosed,");
			break;
		case General_EVBehavior.FromClosedToOpen: 
			text.append("@FromClosedToOpen,");
			break;
		case General_EVBehavior.BlockedOpen: 
			text.append("@BlockedOpen,");
			break;
		case General_EVBehavior.EmitBlockedOpen: 
			text.append("@emitBlockedOpen,");
			break;
		case General_EVBehavior.BlockedClosed: 
			text.append("@BlockedClosed,");
			break;
		case General_EVBehavior.EmitBlockedClosed: 
			text.append("@emitBlockedClosed,");
			break;
		}
		text.append("\n\t- param_from_analog_switch=");
		text.append(Boolean.toString(me.param_from_analog_switch));
		text.append("\n\t- param_cmdEV=");
		text.append(Boolean.toString(me.param_cmdEV));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		General_EVConfiguration me = (General_EVConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case General_EVBehavior.INIT2soft: 
			text.append("@INIT2soft,");
			break;
		case General_EVBehavior.INIT2EV: 
			text.append("@INIT2EV,");
			break;
		case General_EVBehavior.INITfromSwitch: 
			text.append("@INITfromSwitch,");
			break;
		case General_EVBehavior.INITfromSoft: 
			text.append("@INITfromSoft,");
			break;
		case General_EVBehavior.Open: 
			text.append("@Open,");
			break;
		case General_EVBehavior.EmitOpen: 
			text.append("@emitOpen,");
			break;
		case General_EVBehavior.Closed: 
			text.append("@Closed,");
			break;
		case General_EVBehavior.EmitClosed: 
			text.append("@emitClosed,");
			break;
		case General_EVBehavior.FromOpenToClosed: 
			text.append("@FromOpenToClosed,");
			break;
		case General_EVBehavior.FromClosedToOpen: 
			text.append("@FromClosedToOpen,");
			break;
		case General_EVBehavior.BlockedOpen: 
			text.append("@BlockedOpen,");
			break;
		case General_EVBehavior.EmitBlockedOpen: 
			text.append("@emitBlockedOpen,");
			break;
		case General_EVBehavior.BlockedClosed: 
			text.append("@BlockedClosed,");
			break;
		case General_EVBehavior.EmitBlockedClosed: 
			text.append("@emitBlockedClosed,");
			break;
		}
		text.append(" param_from_analog_switch=");
		text.append(Boolean.toString(me.param_from_analog_switch));
		text.append(" param_cmdEV=");
		text.append(Boolean.toString(me.param_cmdEV));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		General_EVConfiguration me = new General_EVConfiguration();
		me.state = boost.readShort();
		me.param_from_analog_switch = boost.readBoolean();
		me.param_cmdEV = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		General_EVConfiguration me = (General_EVConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.param_from_analog_switch);
		boost.writeBoolean(me.param_cmdEV);
	}

}

