package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Generic_EVBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INITfromSoft = 1;

	public static final short INITfromGeneral = 2;

	public static final short INIT2devices = 3;

	public static final short Open = 4;

	public static final short EmitOpen = 5;

	public static final short Closed = 6;

	public static final short EmitClosed = 7;

	public static final short FromOpenToClosed = 8;

	public static final short FromClosedToOpen = 9;

	public static final short BlockedOpen = 10;

	public static final short EmitBlockedOpen = 11;

	public static final short BlockedClosed = 12;

	public static final short EmitBlockedClosed = 13;

	private final short informal48;

	private final short informal49;

	private final short informal50;

	private final short informal51;

	private final short informal52;

	private final short informal53;

	private final short informal54;

	private final short informal55;

	private final short informal56;

	private final short informal57;

	private final short informal58;

	private final BroadcastChannel from_cmdEV;

	private final BroadcastChannel from_generalEV;

	private final BroadcastChannel from_dispatch;

	private final BroadcastChannel to_devices;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public Generic_EVBehavior(SymbolsTable symbols, BroadcastChannel from_cmdEV, BroadcastChannel from_generalEV, BroadcastChannel from_dispatch, BroadcastChannel to_devices) {
		super("Generic_EV", idSeed++, symbols);
		this.from_cmdEV = from_cmdEV;
		this.from_generalEV = from_generalEV;
		this.from_dispatch = from_dispatch;
		this.to_devices = to_devices;
		inputChannels = new Channel[]{this.from_cmdEV, this.from_generalEV, this.from_dispatch};
		outputChannels = new Channel[]{this.to_devices};
		informal48 = symbols.getInformalId("Generic_EV_open->bl-open");
		informal49 = symbols.getInformalId("Generic_EV_open->bl-closed");
		informal50 = symbols.getInformalId("Generic_EV_open->interm-open");
		informal51 = symbols.getInformalId("Generic_EV_interm-open->bl-open");
		informal52 = symbols.getInformalId("Generic_EV_interm-open->bl-closed");
		informal53 = symbols.getInformalId("Generic_EV_closed->bl-open");
		informal54 = symbols.getInformalId("Generic_EV_closed->bl-closed");
		informal55 = symbols.getInformalId("Generic_EV_closed->interm-closed");
		informal56 = symbols.getInformalId("Generic_EV_interm-closed->bl-open");
		informal57 = symbols.getInformalId("Generic_EV_interm-closed->bl-closed");
		informal58 = symbols.getInformalId("Generic_EV FromClosedToOpen->Closed");
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 10, false, 10, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 0, 36, false, 36, false);
		channels = new Channel[] { wait0, wait1,  };
	}

	private final String[] stateNames = new String[] {"INITfromSoft", "INITfromGeneral", "INIT2devices", "Open", "emitOpen", "Closed", "emitClosed", "FromOpenToClosed", "FromClosedToOpen", "BlockedOpen", "emitBlockedOpen", "BlockedClosed", "emitBlockedClosed"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_generalEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INITfromGeneral) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_generalEV.input(id, actions);
			me.param_generalEV = from_generalEV.value(boolean.class,0);
			if ( from_generalEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_generalEV.clockId, 0);
			}
			me.state = INITfromSoft;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INITfromSoft) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			me.state = INIT2devices;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_devices.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT2devices) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			to_devices.output(id, actions, LGS_PilotInternalRoot.PRESSURE_OFF);
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_devices.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EmitOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			to_devices.output(id, actions, LGS_PilotInternalRoot.PRESSURE_OFF);
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal48));
				me.state = BlockedOpen;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal49));
				me.state = EmitBlockedClosed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_ON) {
				if (me.param_generalEV == LGS_PilotInternalRoot.PRESSURE_ON) {
					actions.add(new InformalAction(id, informal50));
					me.state = FromOpenToClosed;
					if (true) return true;
				} else {
					me.state = Open;
					if (true) return true;
				}
			} else if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_OFF) {
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_generalEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_generalEV.input(id, actions);
			me.param_generalEV = from_generalEV.value(boolean.class,0);
			if ( from_generalEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_generalEV.clockId, 0);
			}
			if ((me.param_generalEV) == LGS_PilotInternalRoot.PRESSURE_ON) {
				if (me.param_cmdEV == LGS_PilotInternalRoot.EV_ON) {
					actions.add(new InformalAction(id, informal50));
					me.state = FromOpenToClosed;
					if (true) return true;
				} else {
					me.state = Open;
					if (true) return true;
				}
			} else if ((me.param_generalEV) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromOpenToClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal51));
				me.state = BlockedOpen;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal52));
				me.state = EmitBlockedClosed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromOpenToClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromOpenToClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_ON) {
				me.state = FromOpenToClosed;
				if (true) return true;
			} else if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_OFF) {
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromOpenToClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_generalEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromOpenToClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_generalEV.input(id, actions);
			me.param_generalEV = from_generalEV.value(boolean.class,0);
			if ( from_generalEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_generalEV.clockId, 0);
			}
			if ((me.param_generalEV) == LGS_PilotInternalRoot.PRESSURE_ON) {
				me.state = FromOpenToClosed;
				if (true) return true;
			} else if ((me.param_generalEV) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromOpenToClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromOpenToClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = EmitClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_devices.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EmitClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			to_devices.output(id, actions, me.param_generalEV);
			me.state = Closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal53));
				me.state = EmitBlockedOpen;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal54));
				me.state = BlockedClosed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_ON) {
				me.state = Closed;
				if (true) return true;
			} else if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_OFF) {
				actions.add(new InformalAction(id, informal55));
				me.state = FromClosedToOpen;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_generalEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_generalEV.input(id, actions);
			me.param_generalEV = from_generalEV.value(boolean.class,0);
			if ( from_generalEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_generalEV.clockId, 0);
			}
			if ((me.param_generalEV) == LGS_PilotInternalRoot.PRESSURE_ON) {
				me.state = Closed;
				if (true) return true;
			} else if ((me.param_generalEV) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				me.state = FromClosedToOpen;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromClosedToOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_OPEN_FAILURE) {
				actions.add(new InformalAction(id, informal56));
				me.state = EmitBlockedOpen;
				if (true) return true;
			} else if ((param_from_dispatch) == LGS_PilotInternalRoot.EV_BLOCK_CLOSED_FAILURE) {
				actions.add(new InformalAction(id, informal57));
				me.state = BlockedClosed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromClosedToOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition16 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromClosedToOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_ON) {
				me.state = Closed;
				if (true) return true;
			} else if ((me.param_cmdEV) == LGS_PilotInternalRoot.EV_OFF) {
				me.state = FromClosedToOpen;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromClosedToOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition17 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_generalEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromClosedToOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_generalEV.input(id, actions);
			me.param_generalEV = from_generalEV.value(boolean.class,0);
			if ( from_generalEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_generalEV.clockId, 0);
			}
			if ((me.param_generalEV) == LGS_PilotInternalRoot.PRESSURE_ON) {
				if (me.param_cmdEV == LGS_PilotInternalRoot.EV_ON) {
					actions.add(new InformalAction(id, informal58));
					me.state = Closed;
					if (true) return true;
				} else {
					me.state = FromClosedToOpen;
					if (true) return true;
				}
			} else if ((me.param_generalEV) == LGS_PilotInternalRoot.PRESSURE_OFF) {
				me.state = FromClosedToOpen;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = FromClosedToOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition18 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != FromClosedToOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait1.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = EmitOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition19 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_devices.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EmitBlockedOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			to_devices.output(id, actions, LGS_PilotInternalRoot.PRESSURE_OFF);
			me.state = BlockedOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition20 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			me.state = BlockedOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition21 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			me.state = BlockedOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition22 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_generalEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedOpen) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_generalEV.input(id, actions);
			me.param_generalEV = from_generalEV.value(boolean.class,0);
			if ( from_generalEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_generalEV.clockId, 0);
			}
			me.state = BlockedOpen;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition23 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return to_devices.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != EmitBlockedClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			to_devices.output(id, actions, me.param_generalEV);
			me.state = BlockedClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition24 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			int param_from_dispatch = 0;
			from_dispatch.input(id, actions);
			param_from_dispatch = from_dispatch.value(int.class,0);
			if ( from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, from_dispatch.clockId, 0);
			}
			me.state = BlockedClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition25 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_cmdEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_cmdEV.input(id, actions);
			me.param_cmdEV = from_cmdEV.value(boolean.class,0);
			if ( from_cmdEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_cmdEV.clockId, 0);
			}
			me.state = BlockedClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition26 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return from_generalEV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != BlockedClosed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Generic_EVConfiguration me = (Generic_EVConfiguration) configuration.behaviorConfigurations[id];
			from_generalEV.input(id, actions);
			me.param_generalEV = from_generalEV.value(boolean.class,0);
			if ( from_generalEV.clockId != -1 ) {
				DBM.set(configuration.dbm, from_generalEV.clockId, 0);
			}
			me.state = BlockedClosed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
		transition16,
		transition17,
		transition18,
		transition19,
		transition20,
		transition21,
		transition22,
		transition23,
		transition24,
		transition25,
		transition26,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Generic_EVConfiguration me = new Generic_EVConfiguration();
		int param_from_dispatch;
		//Initial action code.
		me.state = INITfromGeneral;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Generic_EVConfiguration me = (Generic_EVConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Generic_EVBehavior.INITfromSoft: 
			text.append("@INITfromSoft,");
			break;
		case Generic_EVBehavior.INITfromGeneral: 
			text.append("@INITfromGeneral,");
			break;
		case Generic_EVBehavior.INIT2devices: 
			text.append("@INIT2devices,");
			break;
		case Generic_EVBehavior.Open: 
			text.append("@Open,");
			break;
		case Generic_EVBehavior.EmitOpen: 
			text.append("@emitOpen,");
			break;
		case Generic_EVBehavior.Closed: 
			text.append("@Closed,");
			break;
		case Generic_EVBehavior.EmitClosed: 
			text.append("@emitClosed,");
			break;
		case Generic_EVBehavior.FromOpenToClosed: 
			text.append("@FromOpenToClosed,");
			break;
		case Generic_EVBehavior.FromClosedToOpen: 
			text.append("@FromClosedToOpen,");
			break;
		case Generic_EVBehavior.BlockedOpen: 
			text.append("@BlockedOpen,");
			break;
		case Generic_EVBehavior.EmitBlockedOpen: 
			text.append("@emitBlockedOpen,");
			break;
		case Generic_EVBehavior.BlockedClosed: 
			text.append("@BlockedClosed,");
			break;
		case Generic_EVBehavior.EmitBlockedClosed: 
			text.append("@emitBlockedClosed,");
			break;
		}
		text.append("\n\t- param_cmdEV=");
		text.append(Boolean.toString(me.param_cmdEV));
		text.append("\n\t- param_generalEV=");
		text.append(Boolean.toString(me.param_generalEV));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Generic_EVConfiguration me = (Generic_EVConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Generic_EVBehavior.INITfromSoft: 
			text.append("@INITfromSoft,");
			break;
		case Generic_EVBehavior.INITfromGeneral: 
			text.append("@INITfromGeneral,");
			break;
		case Generic_EVBehavior.INIT2devices: 
			text.append("@INIT2devices,");
			break;
		case Generic_EVBehavior.Open: 
			text.append("@Open,");
			break;
		case Generic_EVBehavior.EmitOpen: 
			text.append("@emitOpen,");
			break;
		case Generic_EVBehavior.Closed: 
			text.append("@Closed,");
			break;
		case Generic_EVBehavior.EmitClosed: 
			text.append("@emitClosed,");
			break;
		case Generic_EVBehavior.FromOpenToClosed: 
			text.append("@FromOpenToClosed,");
			break;
		case Generic_EVBehavior.FromClosedToOpen: 
			text.append("@FromClosedToOpen,");
			break;
		case Generic_EVBehavior.BlockedOpen: 
			text.append("@BlockedOpen,");
			break;
		case Generic_EVBehavior.EmitBlockedOpen: 
			text.append("@emitBlockedOpen,");
			break;
		case Generic_EVBehavior.BlockedClosed: 
			text.append("@BlockedClosed,");
			break;
		case Generic_EVBehavior.EmitBlockedClosed: 
			text.append("@emitBlockedClosed,");
			break;
		}
		text.append(" param_cmdEV=");
		text.append(Boolean.toString(me.param_cmdEV));
		text.append(" param_generalEV=");
		text.append(Boolean.toString(me.param_generalEV));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Generic_EVConfiguration me = new Generic_EVConfiguration();
		me.state = boost.readShort();
		me.param_cmdEV = boost.readBoolean();
		me.param_generalEV = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Generic_EVConfiguration me = (Generic_EVConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.param_cmdEV);
		boost.writeBoolean(me.param_generalEV);
	}

}

