package lgs_pilotinternal;

import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Program;
import obp.explorer.runtime.Component;
import java.util.Map;
import java.util.HashMap;
import java.util.Collections;

public class LGS_PilotInternalRoot implements Program {

	public Map<String, String> getMetaInformations() {
		return Collections.emptyMap();
	}

	private Map<String, Integer> ioQueueSizeMap;

	public int getIoQueueSize(String name) {
		if ( ioQueueSizeMap == null ) {
			ioQueueSizeMap = new HashMap<String, Integer>();
			ioQueueSizeMap.put("Dispatcher_1", 1 );
			ioQueueSizeMap.put("toContext", 1 );
		}
		Integer size = ioQueueSizeMap.get(name);
		if ( size == null ) {
			throw new IllegalArgumentException("Queue named '"+ name +"' doesn't exists.");
		}
		return size.intValue();
	}

	public static final int OK = 0;

	public static final int HANDLE = 1;

	public static final int ANALOG_SWITCH_BLOCK_OPEN_FAILURE = 2;

	public static final int ANALOG_SWITCH_BLOCK_CLOSED_FAILURE = 3;

	public static final int GENERAL_EV_BLOCK_OPEN_FAILURE = 4;

	public static final int GENERAL_EV_BLOCK_CLOSED_FAILURE = 5;

	public static final int RETRACT_EV_BLOCK_OPEN_FAILURE = 6;

	public static final int RETRACT_EV_BLOCK_CLOSED_FAILURE = 7;

	public static final int EXTEND_EV_BLOCK_OPEN_FAILURE = 8;

	public static final int EXTEND_EV_BLOCK_CLOSED_FAILURE = 9;

	public static final int CLOSE_EV_BLOCK_OPEN_FAILURE = 10;

	public static final int CLOSE_EV_BLOCK_CLOSED_FAILURE = 11;

	public static final int OPEN_EV_BLOCK_OPEN_FAILURE = 12;

	public static final int OPEN_EV_BLOCK_CLOSED_FAILURE = 13;

	public static final int FRONT_GEAR_FAILURE = 14;

	public static final int LEFT_GEAR_FAILURE = 15;

	public static final int RIGHT_GEAR_FAILURE = 16;

	public static final int FRONT_DOOR_FAILURE = 17;

	public static final int RIGHT_DOOR_FAILURE = 18;

	public static final int LEFT_DOOR_FAILURE = 19;

	public static final int EV_BLOCK_OPEN_FAILURE = 20;

	public static final int EV_BLOCK_CLOSED_FAILURE = 21;

	public static final boolean HANDLE_UP = true;

	public static final boolean HANDLE_DOWN = false;

	public static final boolean EV_ON = true;

	public static final boolean EV_OFF = false;

	public static final boolean SWITCH_ON = true;

	public static final boolean SWITCH_OFF = false;

	public static final boolean PRESSURE_ON = true;

	public static final boolean PRESSURE_OFF = false;

	public static final boolean DOOR_CLOSED = true;

	public static final boolean DOOR_NOT_CLOSED = false;

	public static final boolean DOOR_OPEN = true;

	public static final boolean DOOR_NOT_OPEN = false;

	public static final boolean GEAR_RETRACTED = true;

	public static final boolean GEAR_NOT_RETRACTED = false;

	public static final boolean GEAR_EXTENDED = true;

	public static final boolean GEAR_NOT_EXTENDED = false;

	public static final int LOCKED_EXTENDED = 0;

	public static final int INTERMEDIATE = 1;

	public static final int LOCKED_RETRACTED = 2;

	public static final int OPEN = 3;

	public static final int LOCKED_CLOSED = 4;

	public static final boolean LIGHT_ON = true;

	public static final boolean LIGHT_OFF = false;

	public static final int FIFO_SIZE = 1;

	@Override
	public void unloadExternalLibrary() { }
	private Component root;

	@Override
	public Component getRoot(SymbolsTable symbols) {
		if (root == null) {
			symbols.newInformalId("HANDLE recu");
			symbols.newInformalId("ANALOG_SWITCH_OPEN_FAILURE recu");
			symbols.newInformalId("ANALOG_SWITCH_CLOSE_FAILURE recu");
			symbols.newInformalId("GENERAL_EV_OPEN_FAILURE recu");
			symbols.newInformalId("GENERAL_EV_CLOSED_ERR recu");
			symbols.newInformalId("RETRACT_EV_OPEN_FAILURE recu");
			symbols.newInformalId("RETRACT_EV_CLOSED_FAILURE recu");
			symbols.newInformalId("EXTEND_EV_OPEN_FAILURE recu");
			symbols.newInformalId("EXTEND_EV_CLOSED_FAILURE recu");
			symbols.newInformalId("CLOSE_EV_OPEN_FAILURE recu");
			symbols.newInformalId("CLOSE_EV_CLOSED_FAILURE recu");
			symbols.newInformalId("OPEN_EV_OPEN_FAILURE recu");
			symbols.newInformalId("OPEN_EV_CLOSED_FAILURE recu");
			symbols.newInformalId("FRONT_GEAR_FAILURE recu");
			symbols.newInformalId("FRONT_DOOR_FAILURE recu");
			symbols.newInformalId("LEFT_GEAR_FAILURE recu");
			symbols.newInformalId("LEFT_DOOR_FAILURE recu");
			symbols.newInformalId("RIGHT_GEAR_FAILURE recu");
			symbols.newInformalId("RIGHT_DOOR_FAILURE recu");
			symbols.newInformalId("AnalogSwitch_open->bl-open");
			symbols.newInformalId("AnalogSwitch_open->bl-closed");
			symbols.newInformalId("AnalogSwitch_open->interm-open");
			symbols.newInformalId("AnalogSwitch_interm-open->bl-open");
			symbols.newInformalId("AnalogSwitch_interm-open->bl-closed");
			symbols.newInformalId("AnalogSwitch_interm-open->closed1");
			symbols.newInformalId("AnalogSwitch_closed1->bl-open");
			symbols.newInformalId("AnalogSwitch_closed1->bl-closed");
			symbols.newInformalId("AnalogSwitch_closed1->closed2");
			symbols.newInformalId("AnalogSwitch_closed1->interm-closed");
			symbols.newInformalId("AnalogSwitch_closed2->bl-open");
			symbols.newInformalId("AnalogSwitch_closed2->bl-closed");
			symbols.newInformalId("AnalogSwitch_closed2->closed1");
			symbols.newInformalId("AnalogSwitch_closed2->interm-closed");
			symbols.newInformalId("AnalogSwitch_iterm-closed->bl-open");
			symbols.newInformalId("AnalogSwitch_iterm-closed->bl-closed");
			symbols.newInformalId("AnalogSwitch_iterm-closed->iterm-open");
			symbols.newInformalId("AnalogSwitch_interm-closed->open");
			symbols.newInformalId("General_EV_open->bl-open");
			symbols.newInformalId("General_EV_open->bl-closed");
			symbols.newInformalId("General_EV_open->interm-open");
			symbols.newInformalId("General_EV_interm-open->bl-open");
			symbols.newInformalId("General_EV_interm-open->bl-closed");
			symbols.newInformalId("General_EV Closed->bl-open");
			symbols.newInformalId("General_EV Closed->bl-closed");
			symbols.newInformalId("General_EV Closed->interm-closed");
			symbols.newInformalId("General_EV FromClosedToOpen->bl-open");
			symbols.newInformalId("General_EV FromClosedToOpen->bl-closed");
			symbols.newInformalId("General_EV FromClosedToOpen->Closed");
			symbols.newInformalId("Generic_EV_open->bl-open");
			symbols.newInformalId("Generic_EV_open->bl-closed");
			symbols.newInformalId("Generic_EV_open->interm-open");
			symbols.newInformalId("Generic_EV_interm-open->bl-open");
			symbols.newInformalId("Generic_EV_interm-open->bl-closed");
			symbols.newInformalId("Generic_EV_closed->bl-open");
			symbols.newInformalId("Generic_EV_closed->bl-closed");
			symbols.newInformalId("Generic_EV_closed->interm-closed");
			symbols.newInformalId("Generic_EV_interm-closed->bl-open");
			symbols.newInformalId("Generic_EV_interm-closed->bl-closed");
			symbols.newInformalId("Generic_EV FromClosedToOpen->Closed");
			symbols.newInformalId("Gear Final_locked_extended -> Blocked_after_failure");
			symbols.newInformalId("Gear Final_locked_extended -> temp_Locked_extended");
			symbols.newInformalId("Gear Final_locked_extended : unexpected order");
			symbols.newInformalId("Gear temp_Locked_extended -> Blocked_after_failure");
			symbols.newInformalId("Gear temp_Locked_extended : unexpected order");
			symbols.newInformalId("Gear temp_Locked_extended  -> Final_locked_extended");
			symbols.newInformalId("Gear temp_Locked_extended -> Broken_after_contrary_orders");
			symbols.newInformalId("Gear temp_Locked_extended -> Intermediate_e2r");
			symbols.newInformalId("Gear Locked_extended -> Blocked_after_failure");
			symbols.newInformalId("Gear Locked_extended -> Broken_after_contrary_orders");
			symbols.newInformalId("Gear Locked_extended : unexpected order");
			symbols.newInformalId("Gear Locked_extended -> Final_locked_extended");
			symbols.newInformalId("Gear Unlocked_extended -> Blocked_after_failure");
			symbols.newInformalId("Gear Unlocked_extended -> Broken_after_contrary_orders");
			symbols.newInformalId("Gear Unlocked_extended -> suspended_Unlocked_extended");
			symbols.newInformalId("Gear Unlocked_extended : unexpected order");
			symbols.newInformalId("Gear suspended_Unlocked_extended -> Blocked_after_failure");
			symbols.newInformalId("Gear suspended_Unlocked_extended -> Intermediate_e2r");
			symbols.newInformalId("Gear suspended_Unlocked_extended : unexpected order");
			symbols.newInformalId("Gear suspended_Unlocked_extended -> Unlocked_extended");
			symbols.newInformalId("Gear Intermediate_from_extended_to_retracted -> Blocked_after_failure");
			symbols.newInformalId("Gear Intermediate_from_extended_to_retracted : unexpected order");
			symbols.newInformalId("Gear Intermediate_from_extended_to_retracted  -> suspended_Intermediate");
			symbols.newInformalId("Gear Intermediate_from_extended_to_retracted -> Broken_after_contrary_orders");
			symbols.newInformalId("Gear suspended_Intermediate -> Blocked_after_failure");
			symbols.newInformalId("Gear suspended_Intermediate -> Intermediate_from_extended_to_retracted");
			symbols.newInformalId("Gear suspended_Intermediate : unexpected orders");
			symbols.newInformalId("Gear suspended_Intermediate -> Intermediate_from_retracted_to_extended");
			symbols.newInformalId("Gear Intermediate_from_retracted_to_extended -> Blocked_after_failure");
			symbols.newInformalId("Gear Intermediate_from_retracted_to_extended -> Broken_after_contrary_orders");
			symbols.newInformalId("Gear Intermediate_from_retracted_to_extended -> suspended_Intermediate");
			symbols.newInformalId("Gear Intermediate_from_retracted_to_extended -> Unlocked_extended");
			symbols.newInformalId("Gear Final_locked_retracted -> Blocked_after_failure");
			symbols.newInformalId("Gear Final_locked_retracted -> temp_Locked_retracted");
			symbols.newInformalId("Gear Final_locked_retracted : unexpected order");
			symbols.newInformalId("Gear temp_Locked_retracted -> Blocked_after_failure");
			symbols.newInformalId("Gear temp_Locked_retracted : unexpected order");
			symbols.newInformalId("Gear temp_Locked_retracted  -> Final_locked_retracted");
			symbols.newInformalId("Gear temp_Locked_retracted -> Broken_after_contrary_orders");
			symbols.newInformalId("Gear temp_Locked_retracted -> Intermediate_r2e");
			symbols.newInformalId("Gear Locked_retracted -> Blocked_after_failure");
			symbols.newInformalId("Gear Locked_retracted -> Broken_after_contrary_orders");
			symbols.newInformalId("Gear Locked_retracted : unexpected order");
			symbols.newInformalId("Gear Locked_retracted -> Final_locked_retracted");
			symbols.newInformalId("Gear Unlocked_retracted -> Blocked_after_failure");
			symbols.newInformalId("Gear Unlocked_retracted -> Broken_after_contrary_orders");
			symbols.newInformalId("Gear Unlocked_retracted : unexpected order");
			symbols.newInformalId("Gear Unlocked_retracted -> suspended_Unlocked_retracted");
			symbols.newInformalId("Gear suspended_Unlocked_retracted -> Blocked_after_failure");
			symbols.newInformalId("Gear suspended_Unlocked_retracted -> Intermediate_r2e");
			symbols.newInformalId("Gear suspended_Unlocked_retracted : unexpected order");
			symbols.newInformalId("Gear suspended_Unlocked_retracted -> Unlocked_retracted");
			symbols.newInformalId("Door Open -> Blocked_after_failure");
			symbols.newInformalId("Door Open -> Broken_after_contrary_orders");
			symbols.newInformalId("Door Open : unexpected order");
			symbols.newInformalId("Door Open -> suspended_Unlocked_open");
			symbols.newInformalId("Door suspended_open -> Blocked_after_failure");
			symbols.newInformalId("Door suspended_open -> Intermediate_e2r");
			symbols.newInformalId("Door suspended_open : unexpected order");
			symbols.newInformalId("Door suspended_Unlocked_open -> Open");
			symbols.newInformalId("Door Intermediate_from_open_to_closed -> Blocked_after_failure");
			symbols.newInformalId("Door Intermediate_from_open_to_closed : unexpected order");
			symbols.newInformalId("Door Intermediate_from_open_to_closed  -> suspended_Intermediate");
			symbols.newInformalId("Door Intermediate_from_open_to_closed -> Broken_after_contrary_orders");
			symbols.newInformalId("Door temp_Locked_open : unexpected order");
			symbols.newInformalId("Door suspended_Intermediate -> Blocked_after_failure");
			symbols.newInformalId("Door suspended_Intermediate -> Intermediate_from_open_to_closed");
			symbols.newInformalId("Door suspended_Intermediate : unexpected orders");
			symbols.newInformalId("Door suspended_Intermediate -> Intermediate_from_closed_to_open");
			symbols.newInformalId("Door Intermediate_from_closed_to_open -> Blocked_after_failure");
			symbols.newInformalId("Door Intermediate_from_closed_to_open -> Broken_after_contrary_orders");
			symbols.newInformalId("Door Intermediate_from_closed_to_open -> suspended_Intermediate");
			symbols.newInformalId("Door Intermediate_from_closed_to_open -> Unlocked_open");
			symbols.newInformalId("Door Final_locked_closed -> Blocked_after_failure");
			symbols.newInformalId("Door Final_locked_closed -> temp_Locked_closed");
			symbols.newInformalId("Door Final_locked_closed : unexpected order");
			symbols.newInformalId("Door temp_Locked_closed -> Blocked_after_failure");
			symbols.newInformalId("Door temp_Locked_closed : unexpected order");
			symbols.newInformalId("Door temp_Locked_closed  -> Final_locked_closed");
			symbols.newInformalId("Door temp_Locked_closed -> Broken_after_contrary_orders");
			symbols.newInformalId("Door temp_Locked_closed -> Intermediate_r2e");
			symbols.newInformalId("Door Locked_closed -> Blocked_after_failure");
			symbols.newInformalId("Door Locked_closed -> Broken_after_contrary_orders");
			symbols.newInformalId("Door Locked_closed : unexpected order");
			symbols.newInformalId("Door Locked_closed -> Final_locked_closed");
			symbols.newInformalId("Door Unlocked_closed -> Blocked_after_failure");
			symbols.newInformalId("Door Unlocked_closed -> Broken_after_contrary_orders");
			symbols.newInformalId("Door Unlocked_closed : unexpected order");
			symbols.newInformalId("Door Unlocked_closed -> suspended_Unlocked_closed");
			symbols.newInformalId("Door suspended_Unlocked_closed -> Blocked_after_failure");
			symbols.newInformalId("Door suspended_Unlocked_closed -> Intermediate_r2e");
			symbols.newInformalId("Door suspended_Unlocked_closed : unexpected order");
			symbols.newInformalId("Door suspended_Unlocked_closed -> Unlocked_closed");
			symbols.newInformalId("switch non ouvert à temps");
			symbols.newInformalId("generalEV ON");
			symbols.newInformalId("Pressure non arrivée à temps");
			symbols.newInformalId("open ON");
			symbols.newInformalId("porte non ouverte à temps");
			symbols.newInformalId("retract ON");
			symbols.newInformalId("train non retracté à temps");
			symbols.newInformalId("retract OFF");
			symbols.newInformalId("open OFF");
			symbols.newInformalId("close ON");
			symbols.newInformalId("porte non refermée à temps");
			symbols.newInformalId("close OFF");
			symbols.newInformalId("general OFF");
			symbols.newInformalId("pressure non partie à temps");
			symbols.newInformalId("pressure non arrivée à temps");
			symbols.newInformalId("extend ON");
			symbols.newInformalId("train non étendu à temps");
			symbols.newInformalId("extend OFF");
			symbols.newInformalId("porte non fermée à temps");
			root = new SYSComposition(symbols);
		}
		return root;
	}

}

