package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class SYSBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public SYSBehavior(SymbolsTable symbols) {
		super("SYS", idSeed++, symbols);
	}

	public ReferencedArgumentBoolean getRed_lightRef() {
return 		new ReferencedArgumentBoolean(id) {
			@Override
			public boolean get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.red_light;
			}

			@Override
			public void set(Configuration configuration, boolean value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.red_light = value;
			}

		}

;	}

	public ReferencedArgumentBoolean getOrange_lightRef() {
return 		new ReferencedArgumentBoolean(id) {
			@Override
			public boolean get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.orange_light;
			}

			@Override
			public void set(Configuration configuration, boolean value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.orange_light = value;
			}

		}

;	}

	public ReferencedArgument<int[]> getDispatcher_1Ref() {
return 		new ReferencedArgument<int[]>(id) {
			@Override
			public int[] get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.dispatcher_1;
			}

			@Override
			public void set(Configuration configuration, int[] value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.dispatcher_1 = value;
			}

			@Override
			public  Class<int[]> getArgumentType() {
				return int[].class;
			}

		}

;	}

	public ReferencedArgumentBoolean getHydraulicPressureBeforeGeneralEVRef() {
return 		new ReferencedArgumentBoolean(id) {
			@Override
			public boolean get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.hydraulicPressureBeforeGeneralEV;
			}

			@Override
			public void set(Configuration configuration, boolean value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.hydraulicPressureBeforeGeneralEV = value;
			}

		}

;	}

	public ReferencedArgumentBoolean getGreen_lightRef() {
return 		new ReferencedArgumentBoolean(id) {
			@Override
			public boolean get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.green_light;
			}

			@Override
			public void set(Configuration configuration, boolean value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.green_light = value;
			}

		}

;	}

	public ReferencedArgument<int[]> getToContextRef() {
return 		new ReferencedArgument<int[]>(id) {
			@Override
			public int[] get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.toContext;
			}

			@Override
			public void set(Configuration configuration, int[] value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.toContext = value;
			}

			@Override
			public  Class<int[]> getArgumentType() {
				return int[].class;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		SYSConfiguration me = new SYSConfiguration();
		//Initial action code.
		me.dispatcher_1 = new int[] {};
		me.toContext = new int[] {};
		me.hydraulicPressureBeforeGeneralEV = LGS_PilotInternalRoot.PRESSURE_ON;
		me.green_light = LGS_PilotInternalRoot.LIGHT_ON;
		me.orange_light = LGS_PilotInternalRoot.LIGHT_OFF;
		me.red_light = LGS_PilotInternalRoot.LIGHT_OFF;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SYSConfiguration me = (SYSConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- Dispatcher_1=");
		text.append(Arrays.toString(me.dispatcher_1));
		text.append("\n\t- toContext=");
		text.append(Arrays.toString(me.toContext));
		text.append("\n\t- HydraulicPressureBeforeGeneralEV=");
		text.append(Boolean.toString(me.hydraulicPressureBeforeGeneralEV));
		text.append("\n\t- green_light=");
		text.append(Boolean.toString(me.green_light));
		text.append("\n\t- orange_light=");
		text.append(Boolean.toString(me.orange_light));
		text.append("\n\t- red_light=");
		text.append(Boolean.toString(me.red_light));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SYSConfiguration me = (SYSConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" Dispatcher_1=");
		text.append(Arrays.toString(me.dispatcher_1));
		text.append(" toContext=");
		text.append(Arrays.toString(me.toContext));
		text.append(" HydraulicPressureBeforeGeneralEV=");
		text.append(Boolean.toString(me.hydraulicPressureBeforeGeneralEV));
		text.append(" green_light=");
		text.append(Boolean.toString(me.green_light));
		text.append(" orange_light=");
		text.append(Boolean.toString(me.orange_light));
		text.append(" red_light=");
		text.append(Boolean.toString(me.red_light));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		SYSConfiguration me = new SYSConfiguration();
		me.dispatcher_1 = new int[LGS_PilotInternalRoot.FIFO_SIZE];
		me.dispatcher_1 = new int[boost.readInt()];
		for (int i=0; i<me.dispatcher_1.length; i++) {
			me.dispatcher_1[i] = boost.readInt();
		}
		me.toContext = new int[LGS_PilotInternalRoot.FIFO_SIZE];
		me.toContext = new int[boost.readInt()];
		for (int i=0; i<me.toContext.length; i++) {
			me.toContext[i] = boost.readInt();
		}
		me.hydraulicPressureBeforeGeneralEV = boost.readBoolean();
		me.green_light = boost.readBoolean();
		me.orange_light = boost.readBoolean();
		me.red_light = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		SYSConfiguration me = (SYSConfiguration) processConfiguration;
		boost.writeInt(me.dispatcher_1.length);
		for (int i=0; i<me.dispatcher_1.length; i++) {
			boost.writeInt(me.dispatcher_1[i]);
		}
		boost.writeInt(me.toContext.length);
		for (int i=0; i<me.toContext.length; i++) {
			boost.writeInt(me.toContext[i]);
		}
		boost.writeBoolean(me.hydraulicPressureBeforeGeneralEV);
		boost.writeBoolean(me.green_light);
		boost.writeBoolean(me.orange_light);
		boost.writeBoolean(me.red_light);
	}

}

