package lgs_pilotinternal;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class SYSComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public SYSComposition(SymbolsTable symbols) {
		SYSBehavior me = new SYSBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		BroadcastChannel sync_dispatch_to_analogswitch = new BroadcastChannel(me.name+":sync_dispatch_to_analogswitch", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_software_part = new BroadcastChannel(me.name+":sync_dispatch_to_software_part", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_generalEV = new BroadcastChannel(me.name+":sync_dispatch_to_generalEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_retractEV = new BroadcastChannel(me.name+":sync_dispatch_to_retractEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_extendEV = new BroadcastChannel(me.name+":sync_dispatch_to_extendEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_closeEV = new BroadcastChannel(me.name+":sync_dispatch_to_closeEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_openEV = new BroadcastChannel(me.name+":sync_dispatch_to_openEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_front_gear = new BroadcastChannel(me.name+":sync_dispatch_to_front_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_front_door = new BroadcastChannel(me.name+":sync_dispatch_to_front_door", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_left_gear = new BroadcastChannel(me.name+":sync_dispatch_to_left_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_left_door = new BroadcastChannel(me.name+":sync_dispatch_to_left_door", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_right_gear = new BroadcastChannel(me.name+":sync_dispatch_to_right_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_right_door = new BroadcastChannel(me.name+":sync_dispatch_to_right_door", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_fromAnalogSwitch = new BroadcastChannel(me.name+":sync_fromAnalogSwitch", symbols, 2, 1, 0, false, 0, false);
		BroadcastChannel sync_fromGeneralEV = new BroadcastChannel(me.name+":sync_fromGeneralEV", symbols, 5, 1, 0, false, 0, false);
		BroadcastChannel sync_soft2generalEV = new BroadcastChannel(me.name+":sync_soft2generalEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_soft2retractEV = new BroadcastChannel(me.name+":sync_soft2retractEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_soft2extendEV = new BroadcastChannel(me.name+":sync_soft2extendEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_soft2closeEV = new BroadcastChannel(me.name+":sync_soft2closeEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_soft2openEV = new BroadcastChannel(me.name+":sync_soft2openEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_retractEV = new BroadcastChannel(me.name+":sync_retractEV", symbols, 3, 1, 0, false, 0, false);
		BroadcastChannel sync_extendEV = new BroadcastChannel(me.name+":sync_extendEV", symbols, 3, 1, 0, false, 0, false);
		BroadcastChannel sync_closeEV = new BroadcastChannel(me.name+":sync_closeEV", symbols, 3, 1, 0, false, 0, false);
		BroadcastChannel sync_openEV = new BroadcastChannel(me.name+":sync_openEV", symbols, 3, 1, 0, false, 0, false);
		BroadcastChannel sensor_front_gear_locked_extended = new BroadcastChannel(me.name+":sensor_front_gear_locked_extended", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sensor_front_gear_locked_retracted = new BroadcastChannel(me.name+":sensor_front_gear_locked_retracted", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel front_gear_position = new BroadcastChannel(me.name+":front_gear_position", symbols, 2, 1, 0, false, 0, false);
		BroadcastChannel sensor_left_gear_locked_extended = new BroadcastChannel(me.name+":sensor_left_gear_locked_extended", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sensor_left_gear_locked_retracted = new BroadcastChannel(me.name+":sensor_left_gear_locked_retracted", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel left_gear_position = new BroadcastChannel(me.name+":left_gear_position", symbols, 2, 1, 0, false, 0, false);
		BroadcastChannel sensor_right_gear_locked_extended = new BroadcastChannel(me.name+":sensor_right_gear_locked_extended", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sensor_right_gear_locked_retracted = new BroadcastChannel(me.name+":sensor_right_gear_locked_retracted", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel right_gear_position = new BroadcastChannel(me.name+":right_gear_position", symbols, 2, 1, 0, false, 0, false);
		BroadcastChannel sensor_front_door_open = new BroadcastChannel(me.name+":sensor_front_door_open", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sensor_front_door_locked_closed = new BroadcastChannel(me.name+":sensor_front_door_locked_closed", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel front_door_position = new BroadcastChannel(me.name+":front_door_position", symbols, 2, 1, 0, false, 0, false);
		BroadcastChannel sensor_left_door_open = new BroadcastChannel(me.name+":sensor_left_door_open", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sensor_left_door_locked_closed = new BroadcastChannel(me.name+":sensor_left_door_locked_closed", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel left_door_position = new BroadcastChannel(me.name+":left_door_position", symbols, 2, 1, 0, false, 0, false);
		BroadcastChannel sensor_right_door_open = new BroadcastChannel(me.name+":sensor_right_door_open", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sensor_right_door_locked_closed = new BroadcastChannel(me.name+":sensor_right_door_locked_closed", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel right_door_position = new BroadcastChannel(me.name+":right_door_position", symbols, 2, 1, 0, false, 0, false);
		channels = new Channel[] { sync_dispatch_to_analogswitch, sync_dispatch_to_software_part, sync_dispatch_to_generalEV, sync_dispatch_to_retractEV, sync_dispatch_to_extendEV, sync_dispatch_to_closeEV, sync_dispatch_to_openEV, sync_dispatch_to_front_gear, sync_dispatch_to_front_door, sync_dispatch_to_left_gear, sync_dispatch_to_left_door, sync_dispatch_to_right_gear, sync_dispatch_to_right_door, sync_fromAnalogSwitch, sync_fromGeneralEV, sync_soft2generalEV, sync_soft2retractEV, sync_soft2extendEV, sync_soft2closeEV, sync_soft2openEV, sync_retractEV, sync_extendEV, sync_closeEV, sync_openEV, sensor_front_gear_locked_extended, sensor_front_gear_locked_retracted, front_gear_position, sensor_left_gear_locked_extended, sensor_left_gear_locked_retracted, left_gear_position, sensor_right_gear_locked_extended, sensor_right_gear_locked_retracted, right_gear_position, sensor_front_door_open, sensor_front_door_locked_closed, front_door_position, sensor_left_door_open, sensor_left_door_locked_closed, left_door_position, sensor_right_door_open, sensor_right_door_locked_closed, right_door_position,  };
		
		components = new Component[] {
				me,
				new PilotBehavior(symbols, me.getToContextRef(), me.getDispatcher_1Ref()),
				new DispatcherBehavior(symbols, sync_dispatch_to_analogswitch, sync_dispatch_to_software_part, sync_dispatch_to_generalEV, sync_dispatch_to_retractEV, sync_dispatch_to_extendEV, sync_dispatch_to_closeEV, sync_dispatch_to_openEV, sync_dispatch_to_front_gear, sync_dispatch_to_front_door, sync_dispatch_to_left_gear, sync_dispatch_to_left_door, sync_dispatch_to_right_gear, sync_dispatch_to_right_door, me.getDispatcher_1Ref()),
				new AnalogSwitchBehavior(symbols, sync_dispatch_to_analogswitch, sync_fromAnalogSwitch),
				new General_EVBehavior(symbols, sync_soft2generalEV, sync_fromAnalogSwitch, sync_dispatch_to_generalEV, sync_fromGeneralEV, me.getHydraulicPressureBeforeGeneralEVRef()),
				new Generic_EVBehavior(symbols, sync_soft2retractEV, sync_fromGeneralEV, sync_dispatch_to_retractEV, sync_retractEV),
				new Generic_EVBehavior(symbols, sync_soft2extendEV, sync_fromGeneralEV, sync_dispatch_to_extendEV, sync_extendEV),
				new Generic_EVBehavior(symbols, sync_soft2closeEV, sync_fromGeneralEV, sync_dispatch_to_closeEV, sync_closeEV),
				new Generic_EVBehavior(symbols, sync_soft2openEV, sync_fromGeneralEV, sync_dispatch_to_openEV, sync_openEV),
				new GearBehavior(symbols, sync_retractEV, sync_extendEV, sync_dispatch_to_front_gear, sensor_front_gear_locked_extended, sensor_front_gear_locked_retracted),
				new GearBehavior(symbols, sync_retractEV, sync_extendEV, sync_dispatch_to_left_gear, sensor_left_gear_locked_extended, sensor_left_gear_locked_retracted),
				new GearBehavior(symbols, sync_retractEV, sync_extendEV, sync_dispatch_to_right_gear, sensor_right_gear_locked_extended, sensor_right_gear_locked_retracted),
				new DoorBehavior(symbols, sync_closeEV, sync_openEV, sync_dispatch_to_front_door, sensor_front_door_open, sensor_front_door_locked_closed),
				new DoorBehavior(symbols, sync_closeEV, sync_openEV, sync_dispatch_to_left_door, sensor_left_door_open, sensor_left_door_locked_closed),
				new DoorBehavior(symbols, sync_closeEV, sync_openEV, sync_dispatch_to_right_door, sensor_right_door_open, sensor_right_door_locked_closed),
				new Door_sensor_synthesisBehavior(symbols, sensor_front_door_open, sensor_front_door_locked_closed, front_door_position, me.getRed_lightRef()),
				new Door_sensor_synthesisBehavior(symbols, sensor_left_door_open, sensor_left_door_locked_closed, left_door_position, me.getRed_lightRef()),
				new Door_sensor_synthesisBehavior(symbols, sensor_right_door_open, sensor_right_door_locked_closed, right_door_position, me.getRed_lightRef()),
				new Gear_sensor_synthesisBehavior(symbols, sensor_front_gear_locked_extended, sensor_front_gear_locked_retracted, front_gear_position, me.getRed_lightRef()),
				new Gear_sensor_synthesisBehavior(symbols, sensor_left_gear_locked_extended, sensor_left_gear_locked_retracted, left_gear_position, me.getRed_lightRef()),
				new Gear_sensor_synthesisBehavior(symbols, sensor_right_gear_locked_extended, sensor_right_gear_locked_retracted, right_gear_position, me.getRed_lightRef()),
				new Status_managementBehavior(symbols, front_door_position, left_door_position, right_door_position, front_gear_position, left_gear_position, right_gear_position, me.getGreen_lightRef(), me.getOrange_lightRef(), me.getRed_lightRef()),
				new EV_managementBehavior(symbols, sync_dispatch_to_software_part, sync_fromAnalogSwitch, sync_fromGeneralEV, front_door_position, left_door_position, right_door_position, front_gear_position, left_gear_position, right_gear_position, sync_soft2generalEV, sync_soft2openEV, sync_soft2retractEV, sync_soft2closeEV, sync_soft2extendEV, me.getToContextRef(), me.getRed_lightRef())
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

