package lgs_pilotinternal;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class SYSConfiguration extends BehaviorConfiguration {

	public int[] dispatcher_1;

	public int[] toContext;

	public boolean hydraulicPressureBeforeGeneralEV;

	public boolean green_light;

	public boolean orange_light;

	public boolean red_light;

	//Create initial configuration
	public SYSConfiguration() {
		this.dispatcher_1 = new int[]{};
		this.toContext = new int[]{};
		this.hydraulicPressureBeforeGeneralEV = false;
		this.green_light = false;
		this.orange_light = false;
		this.red_light = false;
	}

	//Create configuration as a copy
	public SYSConfiguration(SYSConfiguration other) {
		this.dispatcher_1 = new int[other.dispatcher_1.length];
		for (int i=0; i<other.dispatcher_1.length; i++) {
			this.dispatcher_1[i] = other.dispatcher_1[i];
		}
		this.toContext = new int[other.toContext.length];
		for (int i=0; i<other.toContext.length; i++) {
			this.toContext[i] = other.toContext[i];
		}
		this.hydraulicPressureBeforeGeneralEV = other.hydraulicPressureBeforeGeneralEV;
		this.green_light = other.green_light;
		this.orange_light = other.orange_light;
		this.red_light = other.red_light;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new SYSConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof SYSConfiguration) {
			SYSConfiguration other = (SYSConfiguration) object;
			if (!Arrays.equals(dispatcher_1, other.dispatcher_1)) return false;
			if (!Arrays.equals(toContext, other.toContext)) return false;
			if (hydraulicPressureBeforeGeneralEV != other.hydraulicPressureBeforeGeneralEV) return false;
			if (green_light != other.green_light) return false;
			if (orange_light != other.orange_light) return false;
			if (red_light != other.red_light) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.hashCode(dispatcher_1);
		total = total * 37 + Arrays.hashCode(toContext);
		total = total * 37 + (hydraulicPressureBeforeGeneralEV? 1 : 0);
		total = total * 37 + (green_light? 1 : 0);
		total = total * 37 + (orange_light? 1 : 0);
		total = total * 37 + (red_light? 1 : 0);
		return total;
	}

}

