package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Status_managementBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INIT_front_door = 1;

	public static final short INIT_left_door = 2;

	public static final short INIT_right_door = 3;

	public static final short INIT_front_gear = 4;

	public static final short INIT_left_gear = 5;

	public static final short INIT_right_gear = 6;

	public static final short Wait_state = 7;

	public static final short ANOMALY = 8;

	public static final short DEAD = 9;

	private final BroadcastChannel front_door_position;

	private final BroadcastChannel left_door_position;

	private final BroadcastChannel right_door_position;

	private final BroadcastChannel front_gear_position;

	private final BroadcastChannel left_gear_position;

	private final BroadcastChannel right_gear_position;

	private final ReferencedArgumentBoolean green_lightRef;

	private final ReferencedArgumentBoolean orange_lightRef;

	private final ReferencedArgumentBoolean red_lightRef;

	public Status_managementBehavior(SymbolsTable symbols, BroadcastChannel front_door_position, BroadcastChannel left_door_position, BroadcastChannel right_door_position, BroadcastChannel front_gear_position, BroadcastChannel left_gear_position, BroadcastChannel right_gear_position, ReferencedArgumentBoolean green_light, ReferencedArgumentBoolean orange_light, ReferencedArgumentBoolean red_light) {
		super("Status_management", idSeed++, symbols);
		this.front_door_position = front_door_position;
		this.left_door_position = left_door_position;
		this.right_door_position = right_door_position;
		this.front_gear_position = front_gear_position;
		this.left_gear_position = left_gear_position;
		this.right_gear_position = right_gear_position;
		inputChannels = new Channel[]{this.front_door_position, this.left_door_position, this.right_door_position, this.front_gear_position, this.left_gear_position, this.right_gear_position};
		this.green_lightRef = green_light;
		this.orange_lightRef = orange_light;
		this.red_lightRef = red_light;
	}

	private final String[] stateNames = new String[] {"INIT_front_door", "INIT_left_door", "INIT_right_door", "INIT_front_gear", "INIT_left_gear", "INIT_right_gear", "Wait_state", "ANOMALY", "DEAD"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_front_door) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = INIT_left_door;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_left_door) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = INIT_right_door;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_right_door) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = INIT_front_gear;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_front_gear) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = INIT_left_gear;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_left_gear) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = INIT_right_gear;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			modifiedBehaviors[orange_lightRef.ownerId] = true;
			modifiedBehaviors[green_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_right_gear) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			try {
				right_gear_position.input(id, actions);
				me.param_right_gear_position = right_gear_position.value(int.class,0);
				if ( right_gear_position.clockId != -1 ) {
					DBM.set(configuration.dbm, right_gear_position.clockId, 0);
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.OPEN) && (me.param_left_door_position == LGS_PilotInternalRoot.OPEN)) && (me.param_right_door_position == LGS_PilotInternalRoot.OPEN)) {
					me.doors_open = true;
				} else {
					me.doors_open = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) && (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) && (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) {
					me.doors_locked_closed = true;
				} else {
					me.doors_locked_closed = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.doors_maneuvering = true;
				} else {
					me.doors_maneuvering = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) {
					me.gears_locked_extended = true;
				} else {
					me.gears_locked_extended = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) {
					me.gears_locked_retracted = true;
				} else {
					me.gears_locked_retracted = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.gears_maneuvering = true;
				} else {
					me.gears_maneuvering = false;
				}
				if ((me.gears_maneuvering == true) && (me.doors_maneuvering == true)) {
					me.state = ANOMALY;
					if (true) return true;
				} else {
					if ((me.gears_maneuvering == true) && (me.doors_open == false)) {
						me.state = ANOMALY;
						if (true) return true;
					} else {
						if ((me.gears_maneuvering == true) && (me.gears_locked_retracted == true)) {
							me.state = ANOMALY;
							if (true) return true;
						} else {
							if ((me.gears_maneuvering == true) && (me.gears_locked_extended == true)) {
								me.state = ANOMALY;
								if (true) return true;
							} else {
								if ((me.gears_locked_extended == true) && (me.gears_locked_retracted == true)) {
									me.state = ANOMALY;
									if (true) return true;
								} else {
									if ((me.doors_maneuvering == true) && (me.doors_locked_closed == true)) {
										me.state = ANOMALY;
										if (true) return true;
									} else {
										if ((me.doors_maneuvering == true) && (me.doors_open == true)) {
											me.state = ANOMALY;
											if (true) return true;
										} else {
											if ((me.doors_open == true) && (me.doors_locked_closed == true)) {
												me.state = ANOMALY;
												if (true) return true;
											} else {
												if ((me.gears_maneuvering == true) || (me.doors_locked_closed == false)) {
													orange_light = true;
												} else {
													orange_light = false;
												}
												if ((me.gears_locked_extended == true) && (me.doors_locked_closed == true)) {
													green_light = true;
												} else {
													green_light = false;
												}
												me.state = Wait_state;
												if (true) return true;
											}
										}
									}
								}
							}
						}
					}
				}
			} finally {
				green_lightRef.set(configuration, green_light);
				orange_lightRef.set(configuration, orange_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			modifiedBehaviors[orange_lightRef.ownerId] = true;
			modifiedBehaviors[green_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Wait_state) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			try {
				front_door_position.input(id, actions);
				me.param_front_door_position = front_door_position.value(int.class,0);
				if ( front_door_position.clockId != -1 ) {
					DBM.set(configuration.dbm, front_door_position.clockId, 0);
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.OPEN) && (me.param_left_door_position == LGS_PilotInternalRoot.OPEN)) && (me.param_right_door_position == LGS_PilotInternalRoot.OPEN)) {
					me.doors_open = true;
				} else {
					me.doors_open = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) && (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) && (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) {
					me.doors_locked_closed = true;
				} else {
					me.doors_locked_closed = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.doors_maneuvering = true;
				} else {
					me.doors_maneuvering = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) {
					me.gears_locked_extended = true;
				} else {
					me.gears_locked_extended = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) {
					me.gears_locked_retracted = true;
				} else {
					me.gears_locked_retracted = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.gears_maneuvering = true;
				} else {
					me.gears_maneuvering = false;
				}
				if ((me.gears_maneuvering == true) && (me.doors_maneuvering == true)) {
					me.state = ANOMALY;
					if (true) return true;
				} else {
					if ((me.gears_maneuvering == true) && (me.doors_open == false)) {
						me.state = ANOMALY;
						if (true) return true;
					} else {
						if ((me.gears_maneuvering == true) && (me.gears_locked_retracted == true)) {
							me.state = ANOMALY;
							if (true) return true;
						} else {
							if ((me.gears_maneuvering == true) && (me.gears_locked_extended == true)) {
								me.state = ANOMALY;
								if (true) return true;
							} else {
								if ((me.gears_locked_extended == true) && (me.gears_locked_retracted == true)) {
									me.state = ANOMALY;
									if (true) return true;
								} else {
									if ((me.doors_maneuvering == true) && (me.doors_locked_closed == true)) {
										me.state = ANOMALY;
										if (true) return true;
									} else {
										if ((me.doors_maneuvering == true) && (me.doors_open == true)) {
											me.state = ANOMALY;
											if (true) return true;
										} else {
											if ((me.doors_open == true) && (me.doors_locked_closed == true)) {
												me.state = ANOMALY;
												if (true) return true;
											} else {
												if ((me.gears_maneuvering == true) || (me.doors_locked_closed == false)) {
													orange_light = true;
												} else {
													orange_light = false;
												}
												if ((me.gears_locked_extended == true) && (me.doors_locked_closed == true)) {
													green_light = true;
												} else {
													green_light = false;
												}
												me.state = Wait_state;
												if (true) return true;
											}
										}
									}
								}
							}
						}
					}
				}
			} finally {
				green_lightRef.set(configuration, green_light);
				orange_lightRef.set(configuration, orange_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			modifiedBehaviors[orange_lightRef.ownerId] = true;
			modifiedBehaviors[green_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Wait_state) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			try {
				left_door_position.input(id, actions);
				me.param_left_door_position = left_door_position.value(int.class,0);
				if ( left_door_position.clockId != -1 ) {
					DBM.set(configuration.dbm, left_door_position.clockId, 0);
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.OPEN) && (me.param_left_door_position == LGS_PilotInternalRoot.OPEN)) && (me.param_right_door_position == LGS_PilotInternalRoot.OPEN)) {
					me.doors_open = true;
				} else {
					me.doors_open = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) && (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) && (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) {
					me.doors_locked_closed = true;
				} else {
					me.doors_locked_closed = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.doors_maneuvering = true;
				} else {
					me.doors_maneuvering = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) {
					me.gears_locked_extended = true;
				} else {
					me.gears_locked_extended = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) {
					me.gears_locked_retracted = true;
				} else {
					me.gears_locked_retracted = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.gears_maneuvering = true;
				} else {
					me.gears_maneuvering = false;
				}
				if ((me.gears_maneuvering == true) && (me.doors_maneuvering == true)) {
					me.state = ANOMALY;
					if (true) return true;
				} else {
					if ((me.gears_maneuvering == true) && (me.doors_open == false)) {
						me.state = ANOMALY;
						if (true) return true;
					} else {
						if ((me.gears_maneuvering == true) && (me.gears_locked_retracted == true)) {
							me.state = ANOMALY;
							if (true) return true;
						} else {
							if ((me.gears_maneuvering == true) && (me.gears_locked_extended == true)) {
								me.state = ANOMALY;
								if (true) return true;
							} else {
								if ((me.gears_locked_extended == true) && (me.gears_locked_retracted == true)) {
									me.state = ANOMALY;
									if (true) return true;
								} else {
									if ((me.doors_maneuvering == true) && (me.doors_locked_closed == true)) {
										me.state = ANOMALY;
										if (true) return true;
									} else {
										if ((me.doors_maneuvering == true) && (me.doors_open == true)) {
											me.state = ANOMALY;
											if (true) return true;
										} else {
											if ((me.doors_open == true) && (me.doors_locked_closed == true)) {
												me.state = ANOMALY;
												if (true) return true;
											} else {
												if ((me.gears_maneuvering == true) || (me.doors_locked_closed == false)) {
													orange_light = true;
												} else {
													orange_light = false;
												}
												if ((me.gears_locked_extended == true) && (me.doors_locked_closed == true)) {
													green_light = true;
												} else {
													green_light = false;
												}
												me.state = Wait_state;
												if (true) return true;
											}
										}
									}
								}
							}
						}
					}
				}
			} finally {
				green_lightRef.set(configuration, green_light);
				orange_lightRef.set(configuration, orange_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			modifiedBehaviors[orange_lightRef.ownerId] = true;
			modifiedBehaviors[green_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Wait_state) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			try {
				right_door_position.input(id, actions);
				me.param_right_door_position = right_door_position.value(int.class,0);
				if ( right_door_position.clockId != -1 ) {
					DBM.set(configuration.dbm, right_door_position.clockId, 0);
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.OPEN) && (me.param_left_door_position == LGS_PilotInternalRoot.OPEN)) && (me.param_right_door_position == LGS_PilotInternalRoot.OPEN)) {
					me.doors_open = true;
				} else {
					me.doors_open = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) && (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) && (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) {
					me.doors_locked_closed = true;
				} else {
					me.doors_locked_closed = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.doors_maneuvering = true;
				} else {
					me.doors_maneuvering = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) {
					me.gears_locked_extended = true;
				} else {
					me.gears_locked_extended = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) {
					me.gears_locked_retracted = true;
				} else {
					me.gears_locked_retracted = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.gears_maneuvering = true;
				} else {
					me.gears_maneuvering = false;
				}
				if ((me.gears_maneuvering == true) && (me.doors_maneuvering == true)) {
					me.state = ANOMALY;
					if (true) return true;
				} else {
					if ((me.gears_maneuvering == true) && (me.doors_open == false)) {
						me.state = ANOMALY;
						if (true) return true;
					} else {
						if ((me.gears_maneuvering == true) && (me.gears_locked_retracted == true)) {
							me.state = ANOMALY;
							if (true) return true;
						} else {
							if ((me.gears_maneuvering == true) && (me.gears_locked_extended == true)) {
								me.state = ANOMALY;
								if (true) return true;
							} else {
								if ((me.gears_locked_extended == true) && (me.gears_locked_retracted == true)) {
									me.state = ANOMALY;
									if (true) return true;
								} else {
									if ((me.doors_maneuvering == true) && (me.doors_locked_closed == true)) {
										me.state = ANOMALY;
										if (true) return true;
									} else {
										if ((me.doors_maneuvering == true) && (me.doors_open == true)) {
											me.state = ANOMALY;
											if (true) return true;
										} else {
											if ((me.doors_open == true) && (me.doors_locked_closed == true)) {
												me.state = ANOMALY;
												if (true) return true;
											} else {
												if ((me.gears_maneuvering == true) || (me.doors_locked_closed == false)) {
													orange_light = true;
												} else {
													orange_light = false;
												}
												if ((me.gears_locked_extended == true) && (me.doors_locked_closed == true)) {
													green_light = true;
												} else {
													green_light = false;
												}
												me.state = Wait_state;
												if (true) return true;
											}
										}
									}
								}
							}
						}
					}
				}
			} finally {
				green_lightRef.set(configuration, green_light);
				orange_lightRef.set(configuration, orange_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			modifiedBehaviors[orange_lightRef.ownerId] = true;
			modifiedBehaviors[green_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Wait_state) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			try {
				front_gear_position.input(id, actions);
				me.param_front_gear_position = front_gear_position.value(int.class,0);
				if ( front_gear_position.clockId != -1 ) {
					DBM.set(configuration.dbm, front_gear_position.clockId, 0);
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.OPEN) && (me.param_left_door_position == LGS_PilotInternalRoot.OPEN)) && (me.param_right_door_position == LGS_PilotInternalRoot.OPEN)) {
					me.doors_open = true;
				} else {
					me.doors_open = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) && (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) && (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) {
					me.doors_locked_closed = true;
				} else {
					me.doors_locked_closed = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.doors_maneuvering = true;
				} else {
					me.doors_maneuvering = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) {
					me.gears_locked_extended = true;
				} else {
					me.gears_locked_extended = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) {
					me.gears_locked_retracted = true;
				} else {
					me.gears_locked_retracted = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.gears_maneuvering = true;
				} else {
					me.gears_maneuvering = false;
				}
				if ((me.gears_maneuvering == true) && (me.doors_maneuvering == true)) {
					me.state = ANOMALY;
					if (true) return true;
				} else {
					if ((me.gears_maneuvering == true) && (me.doors_open == false)) {
						me.state = ANOMALY;
						if (true) return true;
					} else {
						if ((me.gears_maneuvering == true) && (me.gears_locked_retracted == true)) {
							me.state = ANOMALY;
							if (true) return true;
						} else {
							if ((me.gears_maneuvering == true) && (me.gears_locked_extended == true)) {
								me.state = ANOMALY;
								if (true) return true;
							} else {
								if ((me.gears_locked_extended == true) && (me.gears_locked_retracted == true)) {
									me.state = ANOMALY;
									if (true) return true;
								} else {
									if ((me.doors_maneuvering == true) && (me.doors_locked_closed == true)) {
										me.state = ANOMALY;
										if (true) return true;
									} else {
										if ((me.doors_maneuvering == true) && (me.doors_open == true)) {
											me.state = ANOMALY;
											if (true) return true;
										} else {
											if ((me.doors_open == true) && (me.doors_locked_closed == true)) {
												me.state = ANOMALY;
												if (true) return true;
											} else {
												if ((me.gears_maneuvering == true) || (me.doors_locked_closed == false)) {
													orange_light = true;
												} else {
													orange_light = false;
												}
												if ((me.gears_locked_extended == true) && (me.doors_locked_closed == true)) {
													green_light = true;
												} else {
													green_light = false;
												}
												me.state = Wait_state;
												if (true) return true;
											}
										}
									}
								}
							}
						}
					}
				}
			} finally {
				green_lightRef.set(configuration, green_light);
				orange_lightRef.set(configuration, orange_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			modifiedBehaviors[orange_lightRef.ownerId] = true;
			modifiedBehaviors[green_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Wait_state) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			try {
				left_gear_position.input(id, actions);
				me.param_left_gear_position = left_gear_position.value(int.class,0);
				if ( left_gear_position.clockId != -1 ) {
					DBM.set(configuration.dbm, left_gear_position.clockId, 0);
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.OPEN) && (me.param_left_door_position == LGS_PilotInternalRoot.OPEN)) && (me.param_right_door_position == LGS_PilotInternalRoot.OPEN)) {
					me.doors_open = true;
				} else {
					me.doors_open = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) && (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) && (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) {
					me.doors_locked_closed = true;
				} else {
					me.doors_locked_closed = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.doors_maneuvering = true;
				} else {
					me.doors_maneuvering = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) {
					me.gears_locked_extended = true;
				} else {
					me.gears_locked_extended = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) {
					me.gears_locked_retracted = true;
				} else {
					me.gears_locked_retracted = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.gears_maneuvering = true;
				} else {
					me.gears_maneuvering = false;
				}
				if ((me.gears_maneuvering == true) && (me.doors_maneuvering == true)) {
					me.state = ANOMALY;
					if (true) return true;
				} else {
					if ((me.gears_maneuvering == true) && (me.doors_open == false)) {
						me.state = ANOMALY;
						if (true) return true;
					} else {
						if ((me.gears_maneuvering == true) && (me.gears_locked_retracted == true)) {
							me.state = ANOMALY;
							if (true) return true;
						} else {
							if ((me.gears_maneuvering == true) && (me.gears_locked_extended == true)) {
								me.state = ANOMALY;
								if (true) return true;
							} else {
								if ((me.gears_locked_extended == true) && (me.gears_locked_retracted == true)) {
									me.state = ANOMALY;
									if (true) return true;
								} else {
									if ((me.doors_maneuvering == true) && (me.doors_locked_closed == true)) {
										me.state = ANOMALY;
										if (true) return true;
									} else {
										if ((me.doors_maneuvering == true) && (me.doors_open == true)) {
											me.state = ANOMALY;
											if (true) return true;
										} else {
											if ((me.doors_open == true) && (me.doors_locked_closed == true)) {
												me.state = ANOMALY;
												if (true) return true;
											} else {
												if ((me.gears_maneuvering == true) || (me.doors_locked_closed == false)) {
													orange_light = true;
												} else {
													orange_light = false;
												}
												if ((me.gears_locked_extended == true) && (me.doors_locked_closed == true)) {
													green_light = true;
												} else {
													green_light = false;
												}
												me.state = Wait_state;
												if (true) return true;
											}
										}
									}
								}
							}
						}
					}
				}
			} finally {
				green_lightRef.set(configuration, green_light);
				orange_lightRef.set(configuration, orange_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			modifiedBehaviors[orange_lightRef.ownerId] = true;
			modifiedBehaviors[green_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Wait_state) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean green_light = green_lightRef.get(configuration);
			boolean orange_light = orange_lightRef.get(configuration);
			try {
				right_gear_position.input(id, actions);
				me.param_right_gear_position = right_gear_position.value(int.class,0);
				if ( right_gear_position.clockId != -1 ) {
					DBM.set(configuration.dbm, right_gear_position.clockId, 0);
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.OPEN) && (me.param_left_door_position == LGS_PilotInternalRoot.OPEN)) && (me.param_right_door_position == LGS_PilotInternalRoot.OPEN)) {
					me.doors_open = true;
				} else {
					me.doors_open = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) && (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) && (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED)) {
					me.doors_locked_closed = true;
				} else {
					me.doors_locked_closed = false;
				}
				if (((me.param_front_door_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_door_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.doors_maneuvering = true;
				} else {
					me.doors_maneuvering = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_EXTENDED)) {
					me.gears_locked_extended = true;
				} else {
					me.gears_locked_extended = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED) && (me.param_left_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) && (me.param_right_gear_position == LGS_PilotInternalRoot.LOCKED_RETRACTED)) {
					me.gears_locked_retracted = true;
				} else {
					me.gears_locked_retracted = false;
				}
				if (((me.param_front_gear_position == LGS_PilotInternalRoot.INTERMEDIATE) || (me.param_left_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) || (me.param_right_gear_position == LGS_PilotInternalRoot.INTERMEDIATE)) {
					me.gears_maneuvering = true;
				} else {
					me.gears_maneuvering = false;
				}
				if ((me.gears_maneuvering == true) && (me.doors_maneuvering == true)) {
					me.state = ANOMALY;
					if (true) return true;
				} else {
					if ((me.gears_maneuvering == true) && (me.doors_open == false)) {
						me.state = ANOMALY;
						if (true) return true;
					} else {
						if ((me.gears_maneuvering == true) && (me.gears_locked_retracted == true)) {
							me.state = ANOMALY;
							if (true) return true;
						} else {
							if ((me.gears_maneuvering == true) && (me.gears_locked_extended == true)) {
								me.state = ANOMALY;
								if (true) return true;
							} else {
								if ((me.gears_locked_extended == true) && (me.gears_locked_retracted == true)) {
									me.state = ANOMALY;
									if (true) return true;
								} else {
									if ((me.doors_maneuvering == true) && (me.doors_locked_closed == true)) {
										me.state = ANOMALY;
										if (true) return true;
									} else {
										if ((me.doors_maneuvering == true) && (me.doors_open == true)) {
											me.state = ANOMALY;
											if (true) return true;
										} else {
											if ((me.doors_open == true) && (me.doors_locked_closed == true)) {
												me.state = ANOMALY;
												if (true) return true;
											} else {
												if ((me.gears_maneuvering == true) || (me.doors_locked_closed == false)) {
													orange_light = true;
												} else {
													orange_light = false;
												}
												if ((me.gears_locked_extended == true) && (me.doors_locked_closed == true)) {
													green_light = true;
												} else {
													green_light = false;
												}
												me.state = Wait_state;
												if (true) return true;
											}
										}
									}
								}
							}
						}
					}
				}
			} finally {
				green_lightRef.set(configuration, green_light);
				orange_lightRef.set(configuration, orange_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean red_light = red_lightRef.get(configuration);
			modifiedBehaviors[red_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != ANOMALY) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean red_light = red_lightRef.get(configuration);
			try {
				red_light = LGS_PilotInternalRoot.LIGHT_ON;
				me.state = DEAD;
				if (true) return true;
			} finally {
				red_lightRef.set(configuration, red_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_position_DEAD = 0;
			front_door_position.input(id, actions);
			param_position_DEAD = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_position_DEAD = 0;
			left_door_position.input(id, actions);
			param_position_DEAD = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_position_DEAD = 0;
			right_door_position.input(id, actions);
			param_position_DEAD = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition16 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_position_DEAD = 0;
			front_gear_position.input(id, actions);
			param_position_DEAD = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition17 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_position_DEAD = 0;
			left_gear_position.input(id, actions);
			param_position_DEAD = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition18 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Status_managementConfiguration me = (Status_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_position_DEAD = 0;
			right_gear_position.input(id, actions);
			param_position_DEAD = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
		transition16,
		transition17,
		transition18,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Status_managementConfiguration me = new Status_managementConfiguration();
		int param_position_DEAD;
		//Initial action code.
		me.state = INIT_front_door;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Status_managementConfiguration me = (Status_managementConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Status_managementBehavior.INIT_front_door: 
			text.append("@INIT_front_door,");
			break;
		case Status_managementBehavior.INIT_left_door: 
			text.append("@INIT_left_door,");
			break;
		case Status_managementBehavior.INIT_right_door: 
			text.append("@INIT_right_door,");
			break;
		case Status_managementBehavior.INIT_front_gear: 
			text.append("@INIT_front_gear,");
			break;
		case Status_managementBehavior.INIT_left_gear: 
			text.append("@INIT_left_gear,");
			break;
		case Status_managementBehavior.INIT_right_gear: 
			text.append("@INIT_right_gear,");
			break;
		case Status_managementBehavior.Wait_state: 
			text.append("@Wait_state,");
			break;
		case Status_managementBehavior.ANOMALY: 
			text.append("@ANOMALY,");
			break;
		case Status_managementBehavior.DEAD: 
			text.append("@DEAD,");
			break;
		}
		text.append("\n\t- param_front_door_position=");
		text.append(Integer.toString(me.param_front_door_position));
		text.append("\n\t- param_left_door_position=");
		text.append(Integer.toString(me.param_left_door_position));
		text.append("\n\t- param_right_door_position=");
		text.append(Integer.toString(me.param_right_door_position));
		text.append("\n\t- param_front_gear_position=");
		text.append(Integer.toString(me.param_front_gear_position));
		text.append("\n\t- param_left_gear_position=");
		text.append(Integer.toString(me.param_left_gear_position));
		text.append("\n\t- param_right_gear_position=");
		text.append(Integer.toString(me.param_right_gear_position));
		text.append("\n\t- gears_locked_retracted=");
		text.append(Boolean.toString(me.gears_locked_retracted));
		text.append("\n\t- gears_maneuvering=");
		text.append(Boolean.toString(me.gears_maneuvering));
		text.append("\n\t- gears_locked_extended=");
		text.append(Boolean.toString(me.gears_locked_extended));
		text.append("\n\t- doors_open=");
		text.append(Boolean.toString(me.doors_open));
		text.append("\n\t- doors_maneuvering=");
		text.append(Boolean.toString(me.doors_maneuvering));
		text.append("\n\t- doors_locked_closed=");
		text.append(Boolean.toString(me.doors_locked_closed));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Status_managementConfiguration me = (Status_managementConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Status_managementBehavior.INIT_front_door: 
			text.append("@INIT_front_door,");
			break;
		case Status_managementBehavior.INIT_left_door: 
			text.append("@INIT_left_door,");
			break;
		case Status_managementBehavior.INIT_right_door: 
			text.append("@INIT_right_door,");
			break;
		case Status_managementBehavior.INIT_front_gear: 
			text.append("@INIT_front_gear,");
			break;
		case Status_managementBehavior.INIT_left_gear: 
			text.append("@INIT_left_gear,");
			break;
		case Status_managementBehavior.INIT_right_gear: 
			text.append("@INIT_right_gear,");
			break;
		case Status_managementBehavior.Wait_state: 
			text.append("@Wait_state,");
			break;
		case Status_managementBehavior.ANOMALY: 
			text.append("@ANOMALY,");
			break;
		case Status_managementBehavior.DEAD: 
			text.append("@DEAD,");
			break;
		}
		text.append(" param_front_door_position=");
		text.append(Integer.toString(me.param_front_door_position));
		text.append(" param_left_door_position=");
		text.append(Integer.toString(me.param_left_door_position));
		text.append(" param_right_door_position=");
		text.append(Integer.toString(me.param_right_door_position));
		text.append(" param_front_gear_position=");
		text.append(Integer.toString(me.param_front_gear_position));
		text.append(" param_left_gear_position=");
		text.append(Integer.toString(me.param_left_gear_position));
		text.append(" param_right_gear_position=");
		text.append(Integer.toString(me.param_right_gear_position));
		text.append(" gears_locked_retracted=");
		text.append(Boolean.toString(me.gears_locked_retracted));
		text.append(" gears_maneuvering=");
		text.append(Boolean.toString(me.gears_maneuvering));
		text.append(" gears_locked_extended=");
		text.append(Boolean.toString(me.gears_locked_extended));
		text.append(" doors_open=");
		text.append(Boolean.toString(me.doors_open));
		text.append(" doors_maneuvering=");
		text.append(Boolean.toString(me.doors_maneuvering));
		text.append(" doors_locked_closed=");
		text.append(Boolean.toString(me.doors_locked_closed));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Status_managementConfiguration me = new Status_managementConfiguration();
		me.state = boost.readShort();
		me.param_front_door_position = boost.readInt();
		me.param_left_door_position = boost.readInt();
		me.param_right_door_position = boost.readInt();
		me.param_front_gear_position = boost.readInt();
		me.param_left_gear_position = boost.readInt();
		me.param_right_gear_position = boost.readInt();
		me.gears_locked_retracted = boost.readBoolean();
		me.gears_maneuvering = boost.readBoolean();
		me.gears_locked_extended = boost.readBoolean();
		me.doors_open = boost.readBoolean();
		me.doors_maneuvering = boost.readBoolean();
		me.doors_locked_closed = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Status_managementConfiguration me = (Status_managementConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.param_front_door_position);
		boost.writeInt(me.param_left_door_position);
		boost.writeInt(me.param_right_door_position);
		boost.writeInt(me.param_front_gear_position);
		boost.writeInt(me.param_left_gear_position);
		boost.writeInt(me.param_right_gear_position);
		boost.writeBoolean(me.gears_locked_retracted);
		boost.writeBoolean(me.gears_maneuvering);
		boost.writeBoolean(me.gears_locked_extended);
		boost.writeBoolean(me.doors_open);
		boost.writeBoolean(me.doors_maneuvering);
		boost.writeBoolean(me.doors_locked_closed);
	}

}

