package lgs_pilotinternal;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class Status_managementConfiguration extends BehaviorConfiguration {

	public short state;

	public int param_front_door_position;

	public int param_left_door_position;

	public int param_right_door_position;

	public int param_front_gear_position;

	public int param_left_gear_position;

	public int param_right_gear_position;

	public boolean gears_locked_retracted;

	public boolean gears_maneuvering;

	public boolean gears_locked_extended;

	public boolean doors_open;

	public boolean doors_maneuvering;

	public boolean doors_locked_closed;

	//Create initial configuration
	public Status_managementConfiguration() {
		this.param_front_door_position = 0;
		this.param_left_door_position = 0;
		this.param_right_door_position = 0;
		this.param_front_gear_position = 0;
		this.param_left_gear_position = 0;
		this.param_right_gear_position = 0;
		this.gears_locked_retracted = false;
		this.gears_maneuvering = false;
		this.gears_locked_extended = false;
		this.doors_open = false;
		this.doors_maneuvering = false;
		this.doors_locked_closed = false;
	}

	//Create configuration as a copy
	public Status_managementConfiguration(Status_managementConfiguration other) {
		this.state = other.state;
		this.param_front_door_position = other.param_front_door_position;
		this.param_left_door_position = other.param_left_door_position;
		this.param_right_door_position = other.param_right_door_position;
		this.param_front_gear_position = other.param_front_gear_position;
		this.param_left_gear_position = other.param_left_gear_position;
		this.param_right_gear_position = other.param_right_gear_position;
		this.gears_locked_retracted = other.gears_locked_retracted;
		this.gears_maneuvering = other.gears_maneuvering;
		this.gears_locked_extended = other.gears_locked_extended;
		this.doors_open = other.doors_open;
		this.doors_maneuvering = other.doors_maneuvering;
		this.doors_locked_closed = other.doors_locked_closed;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new Status_managementConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof Status_managementConfiguration) {
			Status_managementConfiguration other = (Status_managementConfiguration) object;
			if (state != other.state) return false;
			if (param_front_door_position != other.param_front_door_position) return false;
			if (param_left_door_position != other.param_left_door_position) return false;
			if (param_right_door_position != other.param_right_door_position) return false;
			if (param_front_gear_position != other.param_front_gear_position) return false;
			if (param_left_gear_position != other.param_left_gear_position) return false;
			if (param_right_gear_position != other.param_right_gear_position) return false;
			if (gears_locked_retracted != other.gears_locked_retracted) return false;
			if (gears_maneuvering != other.gears_maneuvering) return false;
			if (gears_locked_extended != other.gears_locked_extended) return false;
			if (doors_open != other.doors_open) return false;
			if (doors_maneuvering != other.doors_maneuvering) return false;
			if (doors_locked_closed != other.doors_locked_closed) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + param_front_door_position;
		total = total * 37 + param_left_door_position;
		total = total * 37 + param_right_door_position;
		total = total * 37 + param_front_gear_position;
		total = total * 37 + param_left_gear_position;
		total = total * 37 + param_right_gear_position;
		total = total * 37 + (gears_locked_retracted? 1 : 0);
		total = total * 37 + (gears_maneuvering? 1 : 0);
		total = total * 37 + (gears_locked_extended? 1 : 0);
		total = total * 37 + (doors_open? 1 : 0);
		total = total * 37 + (doors_maneuvering? 1 : 0);
		total = total * 37 + (doors_locked_closed? 1 : 0);
		return total;
	}

}

