package onelighttempo;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class Test_LightComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public Test_LightComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("test_Light", idSeed++);
		BroadcastChannel goOn = new BroadcastChannel(name+":goOn", symbols, 1, 1, 0, false, 1, false);
		BroadcastChannel done = new BroadcastChannel(name+":done", symbols, 1, 1);
		channels = new Channel[] { goOn, done,  };
		
		components = new Component[] {
				new InterrupteurBehavior(symbols, goOn, done),
				new LightBehavior(symbols, goOn, done)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

