package wait_2proc_11_22;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Proc1Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Start = 1;

	public static final short End = 2;

	private final short informal0;

	private final short informal1;

	private final WaitChannel wait0;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public Proc1Behavior(SymbolsTable symbols) {
		super("proc1", idSeed++, symbols);
		informal0 = symbols.getInformalId("myVar:=myVar + 1");
		informal1 = symbols.getInformalId("end");
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 1, false, 1, false);
		channels = new Channel[] { wait0,  };
	}

	private final String[] stateNames = new String[] {"Start", "End"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Proc1Configuration me = (Proc1Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Start) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Proc1Configuration me = (Proc1Configuration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			me.myVar = (me.myVar) + (1);
			if (me.myVar == Wait_2proc_11_22Root.N) {
				actions.add(new InformalAction(id, informal0));
				actions.add(new InformalAction(id, informal1));
				me.state = End;
				if (true) return true;
			} else {
				me.state = Start;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Proc1Configuration me = new Proc1Configuration();
		//Initial action code.
		me.myVar = 0;
		me.state = Start;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Proc1Configuration me = (Proc1Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Proc1Behavior.Start: 
			text.append("@Start,");
			break;
		case Proc1Behavior.End: 
			text.append("@End,");
			break;
		}
		text.append("\n\t- myVar=");
		text.append(Integer.toString(me.myVar));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Proc1Configuration me = (Proc1Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Proc1Behavior.Start: 
			text.append("@Start,");
			break;
		case Proc1Behavior.End: 
			text.append("@End,");
			break;
		}
		text.append(" myVar=");
		text.append(Integer.toString(me.myVar));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Proc1Configuration me = new Proc1Configuration();
		me.state = boost.readShort();
		me.myVar = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Proc1Configuration me = (Proc1Configuration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.myVar);
	}

}

