package clocks_36_limit_at_23;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class AnalogSwitchBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Open = 1;

	public static final short Pre_open = 2;

	public static final short Pre_intermediate_from_open_to_closed = 3;

	public static final short Intermediate_from_open_to_closed = 4;

	public static final short Pre_closed1 = 5;

	public static final short Closed1 = 6;

	public static final short Pre_closed2 = 7;

	public static final short Closed2 = 8;

	public static final short Pre_intermediate_from_closed_to_open = 9;

	public static final short Intermediate_from_closed_to_open = 10;

	public static final short Blocked_open = 11;

	public static final short Blocked_closed = 12;

	public static final short Pre_blocked_open = 13;

	public static final short Pre_blocked_closed = 14;

	private final short informal0;

	private final short informal1;

	private final short informal2;

	private final short informal3;

	private final short informal4;

	private final short informal5;

	private final short informal6;

	private final short informal7;

	private final short informal8;

	private final short informal9;

	private final short informal10;

	private final short informal11;

	private final short informal12;

	private final short informal13;

	private final short informal14;

	private final short informal15;

	private final short informal16;

	private final short informal17;

	private final BroadcastChannel port_from_dispatch;

	private final BroadcastChannel port_to_geenral_EV;

	private final ReferencedArgumentBoolean analogSwitch_actually_closedRef;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final WaitChannel wait2;

	private final WaitChannel wait3;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public AnalogSwitchBehavior(SymbolsTable symbols, BroadcastChannel port_from_dispatch, BroadcastChannel port_to_geenral_EV, ReferencedArgumentBoolean analogSwitch_actually_closed) {
		super("AnalogSwitch", idSeed++, symbols);
		this.port_from_dispatch = port_from_dispatch;
		this.port_to_geenral_EV = port_to_geenral_EV;
		inputChannels = new Channel[]{this.port_from_dispatch};
		outputChannels = new Channel[]{this.port_to_geenral_EV};
		this.analogSwitch_actually_closedRef = analogSwitch_actually_closed;
		informal0 = symbols.getInformalId("AnalogSwitch_open->bl-open");
		informal1 = symbols.getInformalId("AnalogSwitch_open->bl-closed");
		informal2 = symbols.getInformalId("AnalogSwitch_open->interm-open");
		informal3 = symbols.getInformalId("AnalogSwitch_interm-open->bl-open");
		informal4 = symbols.getInformalId("AnalogSwitch_interm-open->bl-closed");
		informal5 = symbols.getInformalId("AnalogSwitch_interm-open->closed1");
		informal6 = symbols.getInformalId("AnalogSwitch_closed1->bl-open");
		informal7 = symbols.getInformalId("AnalogSwitch_closed1->bl-closed");
		informal8 = symbols.getInformalId("AnalogSwitch_closed1->closed2");
		informal9 = symbols.getInformalId("AnalogSwitch_closed1->interm-closed");
		informal10 = symbols.getInformalId("AnalogSwitch_closed2->bl-open");
		informal11 = symbols.getInformalId("AnalogSwitch_closed2->bl-closed");
		informal12 = symbols.getInformalId("AnalogSwitch_closed2->closed1");
		informal13 = symbols.getInformalId("AnalogSwitch_closed2->interm-closed");
		informal14 = symbols.getInformalId("AnalogSwitch_iterm-closed->bl-open");
		informal15 = symbols.getInformalId("AnalogSwitch_iterm-closed->bl-closed");
		informal16 = symbols.getInformalId("AnalogSwitch_iterm-closed->iterm-open");
		informal17 = symbols.getInformalId("AnalogSwitch_interm-closed->open");
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 8, false, 8, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 0, 200, false, 200, false);
		wait2 = new WaitChannel(null, symbols, this.getId(), (short) 0, 200, false, 200, false);
		wait3 = new WaitChannel(null, symbols, this.getId(), (short) 0, 12, false, 12, false);
		channels = new Channel[] { wait0, wait1, wait2, wait3,  };
	}

	private final String[] stateNames = new String[] {"open", "pre_open", "pre_intermediate_from_open_to_closed", "intermediate_from_open_to_closed", "pre_closed1", "closed1", "pre_closed2", "closed2", "pre_intermediate_from_closed_to_open", "intermediate_from_closed_to_open", "blocked_open", "blocked_closed", "pre_blocked_open", "pre_blocked_closed"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				port_from_dispatch.input(id, actions);
				me.param_from_dispatch = port_from_dispatch.value(int.class,0);
				if ( port_from_dispatch.clockId != -1 ) {
					DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
				}
				if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
					actions.add(new InformalAction(id, informal0));
					analogSwitch_actually_closed = false;
					me.state = Pre_blocked_open;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
					actions.add(new InformalAction(id, informal1));
					analogSwitch_actually_closed = true;
					me.state = Pre_blocked_closed;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.HANDLE) {
					actions.add(new InformalAction(id, informal2));
					analogSwitch_actually_closed = false;
					me.state = Intermediate_from_open_to_closed;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Open;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_open_to_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				port_from_dispatch.input(id, actions);
				me.param_from_dispatch = port_from_dispatch.value(int.class,0);
				if ( port_from_dispatch.clockId != -1 ) {
					DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
				}
				if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
					actions.add(new InformalAction(id, informal3));
					analogSwitch_actually_closed = false;
					me.state = Pre_blocked_open;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
					actions.add(new InformalAction(id, informal4));
					analogSwitch_actually_closed = true;
					me.state = Pre_blocked_closed;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Intermediate_from_open_to_closed;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_open_to_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				DBM.set(configuration.dbm, wait0.clockId, 0);
				actions.add(new DelayAction(id));
				analogSwitch_actually_closed = true;
				actions.add(new InformalAction(id, informal5));
				me.state = Pre_closed1;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_to_geenral_EV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Pre_closed1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			port_to_geenral_EV.output(id, actions, Clocks_36_limit_at_23Root.ON_EV);
			me.state = Closed1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				port_from_dispatch.input(id, actions);
				me.param_from_dispatch = port_from_dispatch.value(int.class,0);
				if ( port_from_dispatch.clockId != -1 ) {
					DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
				}
				if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
					actions.add(new InformalAction(id, informal6));
					analogSwitch_actually_closed = false;
					me.state = Pre_blocked_open;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
					actions.add(new InformalAction(id, informal7));
					analogSwitch_actually_closed = true;
					me.state = Pre_blocked_closed;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.HANDLE) {
					actions.add(new InformalAction(id, informal8));
					analogSwitch_actually_closed = true;
					me.state = Closed2;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Closed1;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				DBM.set(configuration.dbm, wait1.clockId, 0);
				actions.add(new DelayAction(id));
				actions.add(new InformalAction(id, informal9));
				analogSwitch_actually_closed = false;
				me.state = Pre_intermediate_from_closed_to_open;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				port_from_dispatch.input(id, actions);
				me.param_from_dispatch = port_from_dispatch.value(int.class,0);
				if ( port_from_dispatch.clockId != -1 ) {
					DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
				}
				if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
					actions.add(new InformalAction(id, informal10));
					analogSwitch_actually_closed = false;
					me.state = Pre_blocked_open;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
					actions.add(new InformalAction(id, informal11));
					analogSwitch_actually_closed = true;
					me.state = Pre_blocked_closed;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.HANDLE) {
					actions.add(new InformalAction(id, informal12));
					analogSwitch_actually_closed = true;
					me.state = Closed1;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Closed2;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait2.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Closed2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				DBM.set(configuration.dbm, wait2.clockId, 0);
				actions.add(new DelayAction(id));
				actions.add(new InformalAction(id, informal13));
				analogSwitch_actually_closed = false;
				me.state = Pre_intermediate_from_closed_to_open;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_to_geenral_EV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Pre_intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			port_to_geenral_EV.output(id, actions, Clocks_36_limit_at_23Root.OFF_EV);
			me.state = Intermediate_from_closed_to_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				port_from_dispatch.input(id, actions);
				me.param_from_dispatch = port_from_dispatch.value(int.class,0);
				if ( port_from_dispatch.clockId != -1 ) {
					DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
				}
				if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_OPEN_FAILURE) {
					actions.add(new InformalAction(id, informal14));
					analogSwitch_actually_closed = false;
					me.state = Pre_blocked_open;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.ANALOG_SWITCH_BLOCK_CLOSED_FAILURE) {
					actions.add(new InformalAction(id, informal15));
					analogSwitch_actually_closed = true;
					me.state = Pre_blocked_closed;
					if (true) return true;
				} else if ((me.param_from_dispatch) == Clocks_36_limit_at_23Root.HANDLE) {
					actions.add(new InformalAction(id, informal16));
					analogSwitch_actually_closed = false;
					me.state = Intermediate_from_open_to_closed;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Intermediate_from_closed_to_open;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait3.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			modifiedBehaviors[analogSwitch_actually_closedRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			boolean analogSwitch_actually_closed = analogSwitch_actually_closedRef.get(configuration);
			try {
				DBM.set(configuration.dbm, wait3.clockId, 0);
				actions.add(new DelayAction(id));
				analogSwitch_actually_closed = false;
				actions.add(new InformalAction(id, informal17));
				me.state = Open;
				if (true) return true;
			} finally {
				analogSwitch_actually_closedRef.set(configuration, analogSwitch_actually_closed);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_to_geenral_EV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Pre_blocked_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			port_to_geenral_EV.output(id, actions, Clocks_36_limit_at_23Root.OFF_EV);
			me.state = Blocked_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_to_geenral_EV.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Pre_blocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			port_to_geenral_EV.output(id, actions, Clocks_36_limit_at_23Root.ON_EV);
			me.state = Blocked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			me.state = Blocked_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			me.state = Blocked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		AnalogSwitchConfiguration me = new AnalogSwitchConfiguration();
		//Initial action code.
		me.state = Open;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case AnalogSwitchBehavior.Open: 
			text.append("@open,");
			break;
		case AnalogSwitchBehavior.Pre_open: 
			text.append("@pre_open,");
			break;
		case AnalogSwitchBehavior.Pre_intermediate_from_open_to_closed: 
			text.append("@pre_intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Intermediate_from_open_to_closed: 
			text.append("@intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Pre_closed1: 
			text.append("@pre_closed1,");
			break;
		case AnalogSwitchBehavior.Closed1: 
			text.append("@closed1,");
			break;
		case AnalogSwitchBehavior.Pre_closed2: 
			text.append("@pre_closed2,");
			break;
		case AnalogSwitchBehavior.Closed2: 
			text.append("@closed2,");
			break;
		case AnalogSwitchBehavior.Pre_intermediate_from_closed_to_open: 
			text.append("@pre_intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Intermediate_from_closed_to_open: 
			text.append("@intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Blocked_open: 
			text.append("@blocked_open,");
			break;
		case AnalogSwitchBehavior.Blocked_closed: 
			text.append("@blocked_closed,");
			break;
		case AnalogSwitchBehavior.Pre_blocked_open: 
			text.append("@pre_blocked_open,");
			break;
		case AnalogSwitchBehavior.Pre_blocked_closed: 
			text.append("@pre_blocked_closed,");
			break;
		}
		text.append("\n\t- param_from_dispatch=");
		text.append(Integer.toString(me.param_from_dispatch));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case AnalogSwitchBehavior.Open: 
			text.append("@open,");
			break;
		case AnalogSwitchBehavior.Pre_open: 
			text.append("@pre_open,");
			break;
		case AnalogSwitchBehavior.Pre_intermediate_from_open_to_closed: 
			text.append("@pre_intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Intermediate_from_open_to_closed: 
			text.append("@intermediate_from_open_to_closed,");
			break;
		case AnalogSwitchBehavior.Pre_closed1: 
			text.append("@pre_closed1,");
			break;
		case AnalogSwitchBehavior.Closed1: 
			text.append("@closed1,");
			break;
		case AnalogSwitchBehavior.Pre_closed2: 
			text.append("@pre_closed2,");
			break;
		case AnalogSwitchBehavior.Closed2: 
			text.append("@closed2,");
			break;
		case AnalogSwitchBehavior.Pre_intermediate_from_closed_to_open: 
			text.append("@pre_intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Intermediate_from_closed_to_open: 
			text.append("@intermediate_from_closed_to_open,");
			break;
		case AnalogSwitchBehavior.Blocked_open: 
			text.append("@blocked_open,");
			break;
		case AnalogSwitchBehavior.Blocked_closed: 
			text.append("@blocked_closed,");
			break;
		case AnalogSwitchBehavior.Pre_blocked_open: 
			text.append("@pre_blocked_open,");
			break;
		case AnalogSwitchBehavior.Pre_blocked_closed: 
			text.append("@pre_blocked_closed,");
			break;
		}
		text.append(" param_from_dispatch=");
		text.append(Integer.toString(me.param_from_dispatch));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		AnalogSwitchConfiguration me = new AnalogSwitchConfiguration();
		me.state = boost.readShort();
		me.param_from_dispatch = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		AnalogSwitchConfiguration me = (AnalogSwitchConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.param_from_dispatch);
	}

}

