package clocks_36_limit_at_23;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Bouchon_ES_1Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short A = 1;

	public static final short B = 2;

	public static final short C = 3;

	private final short informal154;

	private final short informal155;

	private final BroadcastChannel e;

	public Bouchon_ES_1Behavior(SymbolsTable symbols, BroadcastChannel e) {
		super("bouchon_ES_1", idSeed++, symbols);
		this.e = e;
		outputChannels = new Channel[]{this.e};
		informal154 = symbols.getInformalId("OFF EV");
		informal155 = symbols.getInformalId("ON EV");
	}

	private final String[] stateNames = new String[] {"A", "B", "C"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return e.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_ES_1Configuration me = (Bouchon_ES_1Configuration) configuration.behaviorConfigurations[id];
			if (me.state != A) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_ES_1Configuration me = (Bouchon_ES_1Configuration) configuration.behaviorConfigurations[id];
			e.output(id, actions, 1);
			actions.add(new InformalAction(id, informal154));
			me.state = B;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return e.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_ES_1Configuration me = (Bouchon_ES_1Configuration) configuration.behaviorConfigurations[id];
			if (me.state != B) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_ES_1Configuration me = (Bouchon_ES_1Configuration) configuration.behaviorConfigurations[id];
			e.output(id, actions, 0);
			actions.add(new InformalAction(id, informal155));
			me.state = C;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Bouchon_ES_1Configuration me = new Bouchon_ES_1Configuration();
		//Initial action code.
		me.state = A;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Bouchon_ES_1Configuration me = (Bouchon_ES_1Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Bouchon_ES_1Behavior.A: 
			text.append("@A,");
			break;
		case Bouchon_ES_1Behavior.B: 
			text.append("@B,");
			break;
		case Bouchon_ES_1Behavior.C: 
			text.append("@C,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Bouchon_ES_1Configuration me = (Bouchon_ES_1Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Bouchon_ES_1Behavior.A: 
			text.append("@A,");
			break;
		case Bouchon_ES_1Behavior.B: 
			text.append("@B,");
			break;
		case Bouchon_ES_1Behavior.C: 
			text.append("@C,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Bouchon_ES_1Configuration me = new Bouchon_ES_1Configuration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Bouchon_ES_1Configuration me = (Bouchon_ES_1Configuration) processConfiguration;
		boost.writeShort(me.state);
	}

}

