package clocks_36_limit_at_23;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Bouchon_front_gearBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Extended = 1;

	public static final short Retracted = 2;

	public static final short Intermediate = 3;

	public static final short Error = 4;

	private final short informal156;

	private final short informal157;

	private final short informal158;

	private final short informal159;

	private final BroadcastChannel locked_extended;

	private final BroadcastChannel locked_retracted;

	private final ReferencedArgumentBoolean errorRef;

	public Bouchon_front_gearBehavior(SymbolsTable symbols, BroadcastChannel locked_extended, BroadcastChannel locked_retracted, ReferencedArgumentBoolean error) {
		super("bouchon_front_gear", idSeed++, symbols);
		this.locked_extended = locked_extended;
		this.locked_retracted = locked_retracted;
		inputChannels = new Channel[]{this.locked_extended, this.locked_retracted};
		this.errorRef = error;
		informal156 = symbols.getInformalId("gear en position intermediate");
		informal157 = symbols.getInformalId("erreur");
		informal158 = symbols.getInformalId("gear en position extended");
		informal159 = symbols.getInformalId("gear en position retracted");
	}

	private final String[] stateNames = new String[] {"extended", "retracted", "intermediate", "error"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return locked_extended.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			modifiedBehaviors[errorRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			try {
				locked_extended.input(id, actions);
				me.x = locked_extended.value(boolean.class,0);
				if ( locked_extended.clockId != -1 ) {
					DBM.set(configuration.dbm, locked_extended.clockId, 0);
				}
				if ((me.x) == false) {
					actions.add(new InformalAction(id, informal156));
					me.state = Intermediate;
					if (true) return true;
				} else if ((me.x) == true) {
					actions.add(new InformalAction(id, informal157));
					error = true;
					me.state = Error;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Extended;
				if (true) return true;
			} finally {
				errorRef.set(configuration, error);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return locked_retracted.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			modifiedBehaviors[errorRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			try {
				locked_retracted.input(id, actions);
				me.y = locked_retracted.value(boolean.class,0);
				if ( locked_retracted.clockId != -1 ) {
					DBM.set(configuration.dbm, locked_retracted.clockId, 0);
				}
				actions.add(new InformalAction(id, informal157));
				error = true;
				me.state = Error;
				if (true) return true;
			} finally {
				errorRef.set(configuration, error);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return locked_extended.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			modifiedBehaviors[errorRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			try {
				locked_extended.input(id, actions);
				me.x = locked_extended.value(boolean.class,0);
				if ( locked_extended.clockId != -1 ) {
					DBM.set(configuration.dbm, locked_extended.clockId, 0);
				}
				actions.add(new InformalAction(id, informal157));
				error = true;
				me.state = Error;
				if (true) return true;
			} finally {
				errorRef.set(configuration, error);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return locked_retracted.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			modifiedBehaviors[errorRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			try {
				locked_retracted.input(id, actions);
				me.y = locked_retracted.value(boolean.class,0);
				if ( locked_retracted.clockId != -1 ) {
					DBM.set(configuration.dbm, locked_retracted.clockId, 0);
				}
				if ((me.y) == false) {
					actions.add(new InformalAction(id, informal156));
					me.state = Intermediate;
					if (true) return true;
				} else if ((me.y) == true) {
					actions.add(new InformalAction(id, informal157));
					error = true;
					me.state = Error;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Retracted;
				if (true) return true;
			} finally {
				errorRef.set(configuration, error);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return locked_extended.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			modifiedBehaviors[errorRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			try {
				locked_extended.input(id, actions);
				me.x = locked_extended.value(boolean.class,0);
				if ( locked_extended.clockId != -1 ) {
					DBM.set(configuration.dbm, locked_extended.clockId, 0);
				}
				if ((me.x) == true) {
					actions.add(new InformalAction(id, informal158));
					me.state = Extended;
					if (true) return true;
				} else if ((me.x) == false) {
					actions.add(new InformalAction(id, informal157));
					error = true;
					me.state = Error;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Intermediate;
				if (true) return true;
			} finally {
				errorRef.set(configuration, error);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return locked_retracted.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			modifiedBehaviors[errorRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			boolean error = errorRef.get(configuration);
			try {
				locked_retracted.input(id, actions);
				me.y = locked_retracted.value(boolean.class,0);
				if ( locked_retracted.clockId != -1 ) {
					DBM.set(configuration.dbm, locked_retracted.clockId, 0);
				}
				if ((me.y) == true) {
					actions.add(new InformalAction(id, informal159));
					me.state = Retracted;
					if (true) return true;
				} else if ((me.y) == false) {
					actions.add(new InformalAction(id, informal157));
					error = true;
					me.state = Error;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Intermediate;
				if (true) return true;
			} finally {
				errorRef.set(configuration, error);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return locked_extended.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Error) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			locked_extended.input(id, actions);
			me.x = locked_extended.value(boolean.class,0);
			if ( locked_extended.clockId != -1 ) {
				DBM.set(configuration.dbm, locked_extended.clockId, 0);
			}
			me.state = Error;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return locked_retracted.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Error) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) configuration.behaviorConfigurations[id];
			locked_retracted.input(id, actions);
			me.y = locked_retracted.value(boolean.class,0);
			if ( locked_retracted.clockId != -1 ) {
				DBM.set(configuration.dbm, locked_retracted.clockId, 0);
			}
			me.state = Error;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Bouchon_front_gearConfiguration me = new Bouchon_front_gearConfiguration();
		//Initial action code.
		me.state = Extended;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Bouchon_front_gearBehavior.Extended: 
			text.append("@extended,");
			break;
		case Bouchon_front_gearBehavior.Retracted: 
			text.append("@retracted,");
			break;
		case Bouchon_front_gearBehavior.Intermediate: 
			text.append("@intermediate,");
			break;
		case Bouchon_front_gearBehavior.Error: 
			text.append("@error,");
			break;
		}
		text.append("\n\t- x=");
		text.append(Boolean.toString(me.x));
		text.append("\n\t- y=");
		text.append(Boolean.toString(me.y));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Bouchon_front_gearBehavior.Extended: 
			text.append("@extended,");
			break;
		case Bouchon_front_gearBehavior.Retracted: 
			text.append("@retracted,");
			break;
		case Bouchon_front_gearBehavior.Intermediate: 
			text.append("@intermediate,");
			break;
		case Bouchon_front_gearBehavior.Error: 
			text.append("@error,");
			break;
		}
		text.append(" x=");
		text.append(Boolean.toString(me.x));
		text.append(" y=");
		text.append(Boolean.toString(me.y));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Bouchon_front_gearConfiguration me = new Bouchon_front_gearConfiguration();
		me.state = boost.readShort();
		me.x = boost.readBoolean();
		me.y = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Bouchon_front_gearConfiguration me = (Bouchon_front_gearConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.x);
		boost.writeBoolean(me.y);
	}

}

