package clocks_36_limit_at_23;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class DispatcherConfiguration extends BehaviorConfiguration {

	public short state;

	public int sent;

	public int received;

	//Create initial configuration
	public DispatcherConfiguration() {
		this.sent = 0;
		this.received = 0;
	}

	//Create configuration as a copy
	public DispatcherConfiguration(DispatcherConfiguration other) {
		this.state = other.state;
		this.sent = other.sent;
		this.received = other.received;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new DispatcherConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof DispatcherConfiguration) {
			DispatcherConfiguration other = (DispatcherConfiguration) object;
			if (state != other.state) return false;
			if (sent != other.sent) return false;
			if (received != other.received) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + sent;
		total = total * 37 + received;
		return total;
	}

}

