package clocks_36_limit_at_23;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentInt;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class DoorBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Open = 1;

	public static final short Suspended_open = 2;

	public static final short Intermediate_from_open_to_closed = 3;

	public static final short Intermediate_from_closed_to_open = 4;

	public static final short Suspended_Intermediate = 5;

	public static final short Final_locked_closed = 6;

	public static final short Locked_closed = 7;

	public static final short Temp_Locked_closed = 8;

	public static final short Unlocked_closed = 9;

	public static final short Suspended_Unlocked_closed = 10;

	public static final short Blocked_after_failure = 11;

	public static final short Broken_after_contrary_orders = 12;

	public static final short Emit_sensor_open = 13;

	public static final short Emit_suspended_open = 14;

	public static final short Emit_sensor_unlocked_closed = 15;

	public static final short Emit_sensor_locked_closed = 16;

	private final short informal92;

	private final short informal93;

	private final short informal94;

	private final short informal95;

	private final short informal96;

	private final short informal97;

	private final short informal98;

	private final short informal99;

	private final short informal100;

	private final short informal101;

	private final short informal102;

	private final short informal103;

	private final short informal104;

	private final short informal105;

	private final short informal106;

	private final short informal107;

	private final short informal108;

	private final short informal109;

	private final short informal110;

	private final short informal111;

	private final short informal112;

	private final short informal113;

	private final short informal114;

	private final short informal115;

	private final short informal116;

	private final short informal117;

	private final short informal118;

	private final short informal119;

	private final short informal120;

	private final short informal121;

	private final short informal122;

	private final short informal123;

	private final short informal124;

	private final short informal125;

	private final short informal126;

	private final short informal127;

	private final short informal128;

	private final short informal129;

	private final short informal130;

	private final short informal131;

	private final short informal132;

	private final BroadcastChannel close_pressure;

	private final BroadcastChannel open_pressure;

	private final BroadcastChannel port_from_dispatch;

	private final BroadcastChannel sensor_open;

	private final BroadcastChannel sensor_locked_closed;

	private final ReferencedArgumentInt doorPositionRef;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final WaitChannel wait2;

	private final WaitChannel wait3;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public DoorBehavior(SymbolsTable symbols, BroadcastChannel close_pressure, BroadcastChannel open_pressure, BroadcastChannel port_from_dispatch, BroadcastChannel sensor_open, BroadcastChannel sensor_locked_closed, ReferencedArgumentInt doorPosition) {
		super("Door", idSeed++, symbols);
		this.close_pressure = close_pressure;
		this.open_pressure = open_pressure;
		this.port_from_dispatch = port_from_dispatch;
		this.sensor_open = sensor_open;
		this.sensor_locked_closed = sensor_locked_closed;
		inputChannels = new Channel[]{this.close_pressure, this.open_pressure, this.port_from_dispatch};
		outputChannels = new Channel[]{this.sensor_open, this.sensor_locked_closed};
		this.doorPositionRef = doorPosition;
		informal92 = symbols.getInformalId("Door Open -> Blocked_after_failure");
		informal93 = symbols.getInformalId("Door Open -> Broken_after_contrary_orders");
		informal94 = symbols.getInformalId("Door Open : unexpected order");
		informal95 = symbols.getInformalId("Door Open -> suspended_Unlocked_open");
		informal96 = symbols.getInformalId("Door suspended_open -> Blocked_after_failure");
		informal97 = symbols.getInformalId("Door suspended_open -> Intermediate_e2r");
		informal98 = symbols.getInformalId("Door suspended_open : unexpected order");
		informal99 = symbols.getInformalId("Door suspended_Unlocked_open -> Open");
		informal100 = symbols.getInformalId("Door Intermediate_from_open_to_closed -> Blocked_after_failure");
		informal101 = symbols.getInformalId("Door Intermediate_from_open_to_closed : unexpected order");
		informal102 = symbols.getInformalId("Door Intermediate_from_open_to_closed  -> suspended_Intermediate");
		informal103 = symbols.getInformalId("Door Intermediate_from_open_to_closed -> Broken_after_contrary_orders");
		informal104 = symbols.getInformalId("Door temp_Locked_open : unexpected order");
		informal105 = symbols.getInformalId("Door suspended_Intermediate -> Blocked_after_failure");
		informal106 = symbols.getInformalId("Door suspended_Intermediate -> Intermediate_from_open_to_closed");
		informal107 = symbols.getInformalId("Door suspended_Intermediate : unexpected orders");
		informal108 = symbols.getInformalId("Door suspended_Intermediate -> Intermediate_from_closed_to_open");
		informal109 = symbols.getInformalId("Door Intermediate_from_closed_to_open -> Blocked_after_failure");
		informal110 = symbols.getInformalId("Door Intermediate_from_closed_to_open -> Broken_after_contrary_orders");
		informal111 = symbols.getInformalId("Door Intermediate_from_closed_to_open -> suspended_Intermediate");
		informal112 = symbols.getInformalId("Door Intermediate_from_closed_to_open -> Unlocked_open");
		informal113 = symbols.getInformalId("Door Final_locked_closed -> Blocked_after_failure");
		informal114 = symbols.getInformalId("Door Final_locked_closed -> temp_Locked_closed");
		informal115 = symbols.getInformalId("Door Final_locked_closed : unexpected order");
		informal116 = symbols.getInformalId("Door temp_Locked_closed -> Blocked_after_failure");
		informal117 = symbols.getInformalId("Door temp_Locked_closed : unexpected order");
		informal118 = symbols.getInformalId("Door temp_Locked_closed  -> Final_locked_closed");
		informal119 = symbols.getInformalId("Door temp_Locked_closed -> Broken_after_contrary_orders");
		informal120 = symbols.getInformalId("Door temp_Locked_closed -> Intermediate_r2e");
		informal121 = symbols.getInformalId("Door Locked_closed -> Blocked_after_failure");
		informal122 = symbols.getInformalId("Door Locked_closed -> Broken_after_contrary_orders");
		informal123 = symbols.getInformalId("Door Locked_closed : unexpected order");
		informal124 = symbols.getInformalId("Door Locked_closed -> Final_locked_closed");
		informal125 = symbols.getInformalId("Door Unlocked_closed -> Blocked_after_failure");
		informal126 = symbols.getInformalId("Door Unlocked_closed -> Broken_after_contrary_orders");
		informal127 = symbols.getInformalId("Door Unlocked_closed : unexpected order");
		informal128 = symbols.getInformalId("Door Unlocked_closed -> suspended_Unlocked_closed");
		informal129 = symbols.getInformalId("Door suspended_Unlocked_closed -> Blocked_after_failure");
		informal130 = symbols.getInformalId("Door suspended_Unlocked_closed -> Intermediate_r2e");
		informal131 = symbols.getInformalId("Door suspended_Unlocked_closed : unexpected order");
		informal132 = symbols.getInformalId("Door suspended_Unlocked_closed -> Unlocked_closed");
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 12, false, 19, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 0, 9, false, 14, false);
		wait2 = new WaitChannel(null, symbols, this.getId(), (short) 0, 6, false, 9, false);
		wait3 = new WaitChannel(null, symbols, this.getId(), (short) 0, 12, false, 19, false);
		channels = new Channel[] { wait0, wait1, wait2, wait3,  };
	}

	private final String[] stateNames = new String[] {"Open", "suspended_open", "Intermediate_from_open_to_closed", "Intermediate_from_closed_to_open", "suspended_Intermediate", "Final_locked_closed", "Locked_closed", "temp_Locked_closed", "Unlocked_closed", "suspended_Unlocked_closed", "Blocked_after_failure", "Broken_after_contrary_orders", "emit_sensor_open", "emit_suspended_open", "emit_sensor_unlocked_closed", "emit_sensor_locked_closed"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit_sensor_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			sensor_open.output(id, actions, true);
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal92));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal93));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal94));
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal95));
				me.state = Emit_suspended_open;
				if (true) return true;
			} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal94));
				me.state = Open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit_suspended_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			sensor_open.output(id, actions, false);
			me.state = Suspended_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal96));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			modifiedBehaviors[doorPositionRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			try {
				close_pressure.input(id, actions);
				me.param_close_pressure = close_pressure.value(int.class,0);
				if ( close_pressure.clockId != -1 ) {
					DBM.set(configuration.dbm, close_pressure.clockId, 0);
				}
				if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
					doorPosition = Clocks_36_limit_at_23Root.INTERMEDIATE;
					actions.add(new InformalAction(id, informal97));
					me.state = Intermediate_from_open_to_closed;
					if (true) return true;
				} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
					actions.add(new InformalAction(id, informal98));
					me.state = Suspended_open;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Suspended_open;
				if (true) return true;
			} finally {
				doorPositionRef.set(configuration, doorPosition);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal99));
				me.state = Emit_sensor_open;
				if (true) return true;
			} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal98));
				me.state = Suspended_open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_open_to_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal100));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			modifiedBehaviors[doorPositionRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_open_to_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			try {
				close_pressure.input(id, actions);
				me.param_close_pressure = close_pressure.value(int.class,0);
				if ( close_pressure.clockId != -1 ) {
					DBM.set(configuration.dbm, close_pressure.clockId, 0);
				}
				if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
					actions.add(new InformalAction(id, informal101));
					me.state = Intermediate_from_open_to_closed;
					if (true) return true;
				} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
					doorPosition = Clocks_36_limit_at_23Root.OPEN;
					actions.add(new InformalAction(id, informal102));
					me.state = Suspended_Intermediate;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Intermediate_from_open_to_closed;
				if (true) return true;
			} finally {
				doorPositionRef.set(configuration, doorPosition);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_open_to_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal103));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal104));
				me.state = Intermediate_from_open_to_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_open_to_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_open_to_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = Unlocked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Intermediate) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal105));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Intermediate) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal106));
				me.state = Intermediate_from_open_to_closed;
				if (true) return true;
			} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal107));
				me.state = Suspended_Intermediate;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Intermediate;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Intermediate) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal108));
				me.state = Intermediate_from_closed_to_open;
				if (true) return true;
			} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal107));
				me.state = Suspended_Intermediate;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Intermediate;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal109));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition16 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal110));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal107));
				me.state = Intermediate_from_closed_to_open;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_closed_to_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition17 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal107));
				me.state = Intermediate_from_closed_to_open;
				if (true) return true;
			} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal111));
				me.state = Suspended_Intermediate;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Intermediate_from_closed_to_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition18 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Intermediate_from_closed_to_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait1.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal112));
			me.state = Emit_sensor_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition19 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal113));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition20 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal114));
				me.state = Temp_Locked_closed;
				if (true) return true;
			} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal115));
				me.state = Final_locked_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Final_locked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition21 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Final_locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			actions.add(new InformalAction(id, informal115));
			me.state = Final_locked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition22 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal116));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition23 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			modifiedBehaviors[doorPositionRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			try {
				open_pressure.input(id, actions);
				me.param_open_pressure = open_pressure.value(int.class,0);
				if ( open_pressure.clockId != -1 ) {
					DBM.set(configuration.dbm, open_pressure.clockId, 0);
				}
				if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
					actions.add(new InformalAction(id, informal117));
					me.state = Temp_Locked_closed;
					if (true) return true;
				} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
					doorPosition = Clocks_36_limit_at_23Root.LOCKED_CLOSED;
					actions.add(new InformalAction(id, informal118));
					me.state = Final_locked_closed;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Temp_Locked_closed;
				if (true) return true;
			} finally {
				doorPositionRef.set(configuration, doorPosition);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition24 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal119));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal117));
				me.state = Temp_Locked_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Temp_Locked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition25 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait2.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			modifiedBehaviors[doorPositionRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Temp_Locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			try {
				DBM.set(configuration.dbm, wait2.clockId, 0);
				actions.add(new DelayAction(id));
				doorPosition = Clocks_36_limit_at_23Root.INTERMEDIATE;
				actions.add(new InformalAction(id, informal120));
				me.state = Emit_sensor_unlocked_closed;
				if (true) return true;
			} finally {
				doorPositionRef.set(configuration, doorPosition);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition26 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_locked_closed.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit_sensor_unlocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			sensor_locked_closed.output(id, actions, false);
			me.state = Intermediate_from_closed_to_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition27 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal121));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition28 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal122));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal123));
				me.state = Locked_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Locked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition29 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			modifiedBehaviors[doorPositionRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			try {
				close_pressure.input(id, actions);
				me.param_close_pressure = close_pressure.value(int.class,0);
				if ( close_pressure.clockId != -1 ) {
					DBM.set(configuration.dbm, close_pressure.clockId, 0);
				}
				if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
					doorPosition = Clocks_36_limit_at_23Root.LOCKED_CLOSED;
					actions.add(new InformalAction(id, informal124));
					me.state = Final_locked_closed;
					if (true) return true;
				} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
					actions.add(new InformalAction(id, informal123));
					me.state = Locked_closed;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Locked_closed;
				if (true) return true;
			} finally {
				doorPositionRef.set(configuration, doorPosition);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition30 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal125));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition31 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal126));
				me.state = Broken_after_contrary_orders;
				if (true) return true;
			} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal127));
				me.state = Unlocked_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Unlocked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition32 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal128));
				me.state = Suspended_Unlocked_closed;
				if (true) return true;
			} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal127));
				me.state = Unlocked_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Unlocked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition33 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait3.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Unlocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait3.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = Emit_sensor_locked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition34 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sensor_locked_closed.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Emit_sensor_locked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			sensor_locked_closed.output(id, actions, true);
			me.state = Locked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition35 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			actions.add(new InformalAction(id, informal129));
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition36 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			modifiedBehaviors[doorPositionRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			int doorPosition = doorPositionRef.get(configuration);
			try {
				open_pressure.input(id, actions);
				me.param_open_pressure = open_pressure.value(int.class,0);
				if ( open_pressure.clockId != -1 ) {
					DBM.set(configuration.dbm, open_pressure.clockId, 0);
				}
				if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
					doorPosition = Clocks_36_limit_at_23Root.INTERMEDIATE;
					actions.add(new InformalAction(id, informal130));
					me.state = Intermediate_from_closed_to_open;
					if (true) return true;
				} else if ((me.param_open_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
					actions.add(new InformalAction(id, informal131));
					me.state = Suspended_Unlocked_closed;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = Suspended_Unlocked_closed;
				if (true) return true;
			} finally {
				doorPositionRef.set(configuration, doorPosition);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition37 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Suspended_Unlocked_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_ON) {
				actions.add(new InformalAction(id, informal132));
				me.state = Unlocked_closed;
				if (true) return true;
			} else if ((me.param_close_pressure) == Clocks_36_limit_at_23Root.PRESSURE_OFF) {
				actions.add(new InformalAction(id, informal131));
				me.state = Suspended_Unlocked_closed;
				if (true) return true;
			} else {
				if (true) { return false; }
			}
			me.state = Suspended_Unlocked_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition38 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_after_failure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition39 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_after_failure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition40 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Blocked_after_failure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			me.state = Blocked_after_failure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition41 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Broken_after_contrary_orders) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			close_pressure.input(id, actions);
			me.param_close_pressure = close_pressure.value(int.class,0);
			if ( close_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, close_pressure.clockId, 0);
			}
			me.state = Broken_after_contrary_orders;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition42 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open_pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Broken_after_contrary_orders) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			open_pressure.input(id, actions);
			me.param_open_pressure = open_pressure.value(int.class,0);
			if ( open_pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, open_pressure.clockId, 0);
			}
			me.state = Broken_after_contrary_orders;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition43 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return port_from_dispatch.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Broken_after_contrary_orders) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final DoorConfiguration me = (DoorConfiguration) configuration.behaviorConfigurations[id];
			port_from_dispatch.input(id, actions);
			me.param_from_dispatch = port_from_dispatch.value(int.class,0);
			if ( port_from_dispatch.clockId != -1 ) {
				DBM.set(configuration.dbm, port_from_dispatch.clockId, 0);
			}
			me.state = Broken_after_contrary_orders;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
		transition16,
		transition17,
		transition18,
		transition19,
		transition20,
		transition21,
		transition22,
		transition23,
		transition24,
		transition25,
		transition26,
		transition27,
		transition28,
		transition29,
		transition30,
		transition31,
		transition32,
		transition33,
		transition34,
		transition35,
		transition36,
		transition37,
		transition38,
		transition39,
		transition40,
		transition41,
		transition42,
		transition43,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		DoorConfiguration me = new DoorConfiguration();
		//Initial action code.
		me.state = Final_locked_closed;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		DoorConfiguration me = (DoorConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case DoorBehavior.Open: 
			text.append("@Open,");
			break;
		case DoorBehavior.Suspended_open: 
			text.append("@suspended_open,");
			break;
		case DoorBehavior.Intermediate_from_open_to_closed: 
			text.append("@Intermediate_from_open_to_closed,");
			break;
		case DoorBehavior.Intermediate_from_closed_to_open: 
			text.append("@Intermediate_from_closed_to_open,");
			break;
		case DoorBehavior.Suspended_Intermediate: 
			text.append("@suspended_Intermediate,");
			break;
		case DoorBehavior.Final_locked_closed: 
			text.append("@Final_locked_closed,");
			break;
		case DoorBehavior.Locked_closed: 
			text.append("@Locked_closed,");
			break;
		case DoorBehavior.Temp_Locked_closed: 
			text.append("@temp_Locked_closed,");
			break;
		case DoorBehavior.Unlocked_closed: 
			text.append("@Unlocked_closed,");
			break;
		case DoorBehavior.Suspended_Unlocked_closed: 
			text.append("@suspended_Unlocked_closed,");
			break;
		case DoorBehavior.Blocked_after_failure: 
			text.append("@Blocked_after_failure,");
			break;
		case DoorBehavior.Broken_after_contrary_orders: 
			text.append("@Broken_after_contrary_orders,");
			break;
		case DoorBehavior.Emit_sensor_open: 
			text.append("@emit_sensor_open,");
			break;
		case DoorBehavior.Emit_suspended_open: 
			text.append("@emit_suspended_open,");
			break;
		case DoorBehavior.Emit_sensor_unlocked_closed: 
			text.append("@emit_sensor_unlocked_closed,");
			break;
		case DoorBehavior.Emit_sensor_locked_closed: 
			text.append("@emit_sensor_locked_closed,");
			break;
		}
		text.append("\n\t- param_from_dispatch=");
		text.append(Integer.toString(me.param_from_dispatch));
		text.append("\n\t- param_close_pressure=");
		text.append(Integer.toString(me.param_close_pressure));
		text.append("\n\t- param_open_pressure=");
		text.append(Integer.toString(me.param_open_pressure));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		DoorConfiguration me = (DoorConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case DoorBehavior.Open: 
			text.append("@Open,");
			break;
		case DoorBehavior.Suspended_open: 
			text.append("@suspended_open,");
			break;
		case DoorBehavior.Intermediate_from_open_to_closed: 
			text.append("@Intermediate_from_open_to_closed,");
			break;
		case DoorBehavior.Intermediate_from_closed_to_open: 
			text.append("@Intermediate_from_closed_to_open,");
			break;
		case DoorBehavior.Suspended_Intermediate: 
			text.append("@suspended_Intermediate,");
			break;
		case DoorBehavior.Final_locked_closed: 
			text.append("@Final_locked_closed,");
			break;
		case DoorBehavior.Locked_closed: 
			text.append("@Locked_closed,");
			break;
		case DoorBehavior.Temp_Locked_closed: 
			text.append("@temp_Locked_closed,");
			break;
		case DoorBehavior.Unlocked_closed: 
			text.append("@Unlocked_closed,");
			break;
		case DoorBehavior.Suspended_Unlocked_closed: 
			text.append("@suspended_Unlocked_closed,");
			break;
		case DoorBehavior.Blocked_after_failure: 
			text.append("@Blocked_after_failure,");
			break;
		case DoorBehavior.Broken_after_contrary_orders: 
			text.append("@Broken_after_contrary_orders,");
			break;
		case DoorBehavior.Emit_sensor_open: 
			text.append("@emit_sensor_open,");
			break;
		case DoorBehavior.Emit_suspended_open: 
			text.append("@emit_suspended_open,");
			break;
		case DoorBehavior.Emit_sensor_unlocked_closed: 
			text.append("@emit_sensor_unlocked_closed,");
			break;
		case DoorBehavior.Emit_sensor_locked_closed: 
			text.append("@emit_sensor_locked_closed,");
			break;
		}
		text.append(" param_from_dispatch=");
		text.append(Integer.toString(me.param_from_dispatch));
		text.append(" param_close_pressure=");
		text.append(Integer.toString(me.param_close_pressure));
		text.append(" param_open_pressure=");
		text.append(Integer.toString(me.param_open_pressure));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		DoorConfiguration me = new DoorConfiguration();
		me.state = boost.readShort();
		me.param_from_dispatch = boost.readInt();
		me.param_close_pressure = boost.readInt();
		me.param_open_pressure = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		DoorConfiguration me = (DoorConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.param_from_dispatch);
		boost.writeInt(me.param_close_pressure);
		boost.writeInt(me.param_open_pressure);
	}

}

