package clocks_36_limit_at_23;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class DoorConfiguration extends BehaviorConfiguration {

	public short state;

	public int param_from_dispatch;

	public int param_close_pressure;

	public int param_open_pressure;

	//Create initial configuration
	public DoorConfiguration() {
		this.param_from_dispatch = 0;
		this.param_close_pressure = 0;
		this.param_open_pressure = 0;
	}

	//Create configuration as a copy
	public DoorConfiguration(DoorConfiguration other) {
		this.state = other.state;
		this.param_from_dispatch = other.param_from_dispatch;
		this.param_close_pressure = other.param_close_pressure;
		this.param_open_pressure = other.param_open_pressure;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new DoorConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof DoorConfiguration) {
			DoorConfiguration other = (DoorConfiguration) object;
			if (state != other.state) return false;
			if (param_from_dispatch != other.param_from_dispatch) return false;
			if (param_close_pressure != other.param_close_pressure) return false;
			if (param_open_pressure != other.param_open_pressure) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + param_from_dispatch;
		total = total * 37 + param_close_pressure;
		total = total * 37 + param_open_pressure;
		return total;
	}

}

