package clocks_36_limit_at_23;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class GearConfiguration extends BehaviorConfiguration {

	public short state;

	public int param_from_dispatch;

	public int param_retract_pressure;

	public int param_extend_pressure;

	//Create initial configuration
	public GearConfiguration() {
		this.param_from_dispatch = 0;
		this.param_retract_pressure = 0;
		this.param_extend_pressure = 0;
	}

	//Create configuration as a copy
	public GearConfiguration(GearConfiguration other) {
		this.state = other.state;
		this.param_from_dispatch = other.param_from_dispatch;
		this.param_retract_pressure = other.param_retract_pressure;
		this.param_extend_pressure = other.param_extend_pressure;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new GearConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof GearConfiguration) {
			GearConfiguration other = (GearConfiguration) object;
			if (state != other.state) return false;
			if (param_from_dispatch != other.param_from_dispatch) return false;
			if (param_retract_pressure != other.param_retract_pressure) return false;
			if (param_extend_pressure != other.param_extend_pressure) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + param_from_dispatch;
		total = total * 37 + param_retract_pressure;
		total = total * 37 + param_extend_pressure;
		return total;
	}

}

