package clocks_36_limit_at_23;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentInt;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class SYSBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public int[] toContext;

	public int hydraulicPressureAfterCloseEV;

	public int hydraulicPressureAfterOpenEV;

	public int frontGearPosition;

	public int frontDoorPosition;

	public int leftGearPosition;

	public int leftDoorPosition;

	public int rightGearPosition;

	public int rightDoorPosition;

	public SYSBehavior(SymbolsTable symbols) {
		super("SYS", idSeed++, symbols);
		this.toContext = new int[]{};
		this.hydraulicPressureAfterCloseEV = 0;
		this.hydraulicPressureAfterOpenEV = 0;
		this.frontGearPosition = 0;
		this.frontDoorPosition = 0;
		this.leftGearPosition = 0;
		this.leftDoorPosition = 0;
		this.rightGearPosition = 0;
		this.rightDoorPosition = 0;
	}

	public ReferencedArgumentBoolean getHandleUpRef() {
return 		new ReferencedArgumentBoolean(id) {
			@Override
			public boolean get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.handleUp;
			}

			@Override
			public void set(Configuration configuration, boolean value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.handleUp = value;
			}

		}

;	}

	public ReferencedArgumentInt getHydraulicPressureInsideCircuitRef() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.hydraulicPressureInsideCircuit;
			}

			@Override
			public void set(Configuration configuration, int value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.hydraulicPressureInsideCircuit = value;
			}

		}

;	}

	public ReferencedArgumentInt getHydraulicPressureAfterExtendEVRef() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.hydraulicPressureAfterExtendEV;
			}

			@Override
			public void set(Configuration configuration, int value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.hydraulicPressureAfterExtendEV = value;
			}

		}

;	}

	public ReferencedArgumentBoolean getAnalogSwitch_is_closedRef() {
return 		new ReferencedArgumentBoolean(id) {
			@Override
			public boolean get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.analogSwitch_is_closed;
			}

			@Override
			public void set(Configuration configuration, boolean value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.analogSwitch_is_closed = value;
			}

		}

;	}

	public ReferencedArgumentInt getHydraulicPressureBeforeGeneralEVRef() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.hydraulicPressureBeforeGeneralEV;
			}

			@Override
			public void set(Configuration configuration, int value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.hydraulicPressureBeforeGeneralEV = value;
			}

		}

;	}

	public ReferencedArgument<int[]> getDispatcher_1Ref() {
return 		new ReferencedArgument<int[]>(id) {
			@Override
			public int[] get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.dispatcher_1;
			}

			@Override
			public void set(Configuration configuration, int[] value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.dispatcher_1 = value;
			}

			@Override
			public  Class<int[]> getArgumentType() {
				return int[].class;
			}

		}

;	}

	public ReferencedArgumentInt getHydraulicPressureAfterRetractEVRef() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.hydraulicPressureAfterRetractEV;
			}

			@Override
			public void set(Configuration configuration, int value) {
				SYSConfiguration me = (SYSConfiguration) configuration.behaviorConfigurations[ownerId];
				me.hydraulicPressureAfterRetractEV = value;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		SYSConfiguration me = new SYSConfiguration();
		//Initial action code.
		me.dispatcher_1 = new int[] {};
		toContext = new int[] {};
		me.handleUp = false;
		me.analogSwitch_is_closed = false;
		me.hydraulicPressureBeforeGeneralEV = 100;
		me.hydraulicPressureInsideCircuit = 0;
		me.hydraulicPressureAfterRetractEV = 0;
		me.hydraulicPressureAfterExtendEV = 0;
		hydraulicPressureAfterCloseEV = 0;
		hydraulicPressureAfterOpenEV = 0;
		frontGearPosition = Clocks_36_limit_at_23Root.LOCKED_EXTENDED;
		frontDoorPosition = Clocks_36_limit_at_23Root.LOCKED_CLOSED;
		leftGearPosition = Clocks_36_limit_at_23Root.LOCKED_EXTENDED;
		leftDoorPosition = Clocks_36_limit_at_23Root.LOCKED_CLOSED;
		rightGearPosition = Clocks_36_limit_at_23Root.LOCKED_EXTENDED;
		rightDoorPosition = Clocks_36_limit_at_23Root.LOCKED_CLOSED;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SYSConfiguration me = (SYSConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- Dispatcher_1=");
		text.append(Arrays.toString(me.dispatcher_1));
		text.append("\n\t- handleUp=");
		text.append(Boolean.toString(me.handleUp));
		text.append("\n\t- AnalogSwitch_is_closed=");
		text.append(Boolean.toString(me.analogSwitch_is_closed));
		text.append("\n\t- HydraulicPressureBeforeGeneralEV=");
		text.append(Integer.toString(me.hydraulicPressureBeforeGeneralEV));
		text.append("\n\t- HydraulicPressureInsideCircuit=");
		text.append(Integer.toString(me.hydraulicPressureInsideCircuit));
		text.append("\n\t- HydraulicPressureAfterRetractEV=");
		text.append(Integer.toString(me.hydraulicPressureAfterRetractEV));
		text.append("\n\t- HydraulicPressureAfterExtendEV=");
		text.append(Integer.toString(me.hydraulicPressureAfterExtendEV));
		text.append("\n\t- error=");
		text.append(Boolean.toString(me.error));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SYSConfiguration me = (SYSConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" Dispatcher_1=");
		text.append(Arrays.toString(me.dispatcher_1));
		text.append(" handleUp=");
		text.append(Boolean.toString(me.handleUp));
		text.append(" AnalogSwitch_is_closed=");
		text.append(Boolean.toString(me.analogSwitch_is_closed));
		text.append(" HydraulicPressureBeforeGeneralEV=");
		text.append(Integer.toString(me.hydraulicPressureBeforeGeneralEV));
		text.append(" HydraulicPressureInsideCircuit=");
		text.append(Integer.toString(me.hydraulicPressureInsideCircuit));
		text.append(" HydraulicPressureAfterRetractEV=");
		text.append(Integer.toString(me.hydraulicPressureAfterRetractEV));
		text.append(" HydraulicPressureAfterExtendEV=");
		text.append(Integer.toString(me.hydraulicPressureAfterExtendEV));
		text.append(" error=");
		text.append(Boolean.toString(me.error));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		SYSConfiguration me = new SYSConfiguration();
		me.dispatcher_1 = new int[Clocks_36_limit_at_23Root.FIFO_SIZE];
		me.dispatcher_1 = new int[boost.readInt()];
		for (int i=0; i<me.dispatcher_1.length; i++) {
			me.dispatcher_1[i] = boost.readInt();
		}
		me.handleUp = boost.readBoolean();
		me.analogSwitch_is_closed = boost.readBoolean();
		me.hydraulicPressureBeforeGeneralEV = boost.readInt();
		me.hydraulicPressureInsideCircuit = boost.readInt();
		me.hydraulicPressureAfterRetractEV = boost.readInt();
		me.hydraulicPressureAfterExtendEV = boost.readInt();
		me.error = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		SYSConfiguration me = (SYSConfiguration) processConfiguration;
		boost.writeInt(me.dispatcher_1.length);
		for (int i=0; i<me.dispatcher_1.length; i++) {
			boost.writeInt(me.dispatcher_1[i]);
		}
		boost.writeBoolean(me.handleUp);
		boost.writeBoolean(me.analogSwitch_is_closed);
		boost.writeInt(me.hydraulicPressureBeforeGeneralEV);
		boost.writeInt(me.hydraulicPressureInsideCircuit);
		boost.writeInt(me.hydraulicPressureAfterRetractEV);
		boost.writeInt(me.hydraulicPressureAfterExtendEV);
		boost.writeBoolean(me.error);
	}

}

