package clocks_36_limit_at_23;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class SYSComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public SYSComposition(SymbolsTable symbols) {
		SYSBehavior me = new SYSBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		BroadcastChannel sync_dispatch_to_analogswitch = new BroadcastChannel(me.name+":sync_dispatch_to_analogswitch", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_generalEV = new BroadcastChannel(me.name+":sync_dispatch_to_generalEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_retractEV = new BroadcastChannel(me.name+":sync_dispatch_to_retractEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_extendEV = new BroadcastChannel(me.name+":sync_dispatch_to_extendEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_closeEV = new BroadcastChannel(me.name+":sync_dispatch_to_closeEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_openEV = new BroadcastChannel(me.name+":sync_dispatch_to_openEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_front_gear = new BroadcastChannel(me.name+":sync_dispatch_to_front_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_front_door = new BroadcastChannel(me.name+":sync_dispatch_to_front_door", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_left_gear = new BroadcastChannel(me.name+":sync_dispatch_to_left_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_left_door = new BroadcastChannel(me.name+":sync_dispatch_to_left_door", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_right_gear = new BroadcastChannel(me.name+":sync_dispatch_to_right_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_dispatch_to_right_door = new BroadcastChannel(me.name+":sync_dispatch_to_right_door", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_analogSwitch2generalEV = new BroadcastChannel(me.name+":sync_analogSwitch2generalEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_generalEV2retractEV = new BroadcastChannel(me.name+":sync_generalEV2retractEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_generalEV2extendEV = new BroadcastChannel(me.name+":sync_generalEV2extendEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_generalEV2closeEV = new BroadcastChannel(me.name+":sync_generalEV2closeEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_generalEV2openEV = new BroadcastChannel(me.name+":sync_generalEV2openEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_soft2generalEV = new BroadcastChannel(me.name+":sync_soft2generalEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_soft2retractEV = new BroadcastChannel(me.name+":sync_soft2retractEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_soft2extendEV = new BroadcastChannel(me.name+":sync_soft2extendEV", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_retractEV_to_front_gear = new BroadcastChannel(me.name+":sync_retractEV_to_front_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_extendEV_to_front_gear = new BroadcastChannel(me.name+":sync_extendEV_to_front_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_retractEV_to_left_gear = new BroadcastChannel(me.name+":sync_retractEV_to_left_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_extendEV_to_left_gear = new BroadcastChannel(me.name+":sync_extendEV_to_left_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_retractEV_to_right_gear = new BroadcastChannel(me.name+":sync_retractEV_to_right_gear", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel sync_extendEV_to_right_gear = new BroadcastChannel(me.name+":sync_extendEV_to_right_gear", symbols, 1, 1, 0, false, 0, false);
		channels = new Channel[] { sync_dispatch_to_analogswitch, sync_dispatch_to_generalEV, sync_dispatch_to_retractEV, sync_dispatch_to_extendEV, sync_dispatch_to_closeEV, sync_dispatch_to_openEV, sync_dispatch_to_front_gear, sync_dispatch_to_front_door, sync_dispatch_to_left_gear, sync_dispatch_to_left_door, sync_dispatch_to_right_gear, sync_dispatch_to_right_door, sync_analogSwitch2generalEV, sync_generalEV2retractEV, sync_generalEV2extendEV, sync_generalEV2closeEV, sync_generalEV2openEV, sync_soft2generalEV, sync_soft2retractEV, sync_soft2extendEV, sync_retractEV_to_front_gear, sync_extendEV_to_front_gear, sync_retractEV_to_left_gear, sync_extendEV_to_left_gear, sync_retractEV_to_right_gear, sync_extendEV_to_right_gear,  };
		
		components = new Component[] {
				me,
				new DispatcherBehavior(symbols, sync_dispatch_to_analogswitch, sync_dispatch_to_generalEV, sync_dispatch_to_retractEV, sync_dispatch_to_extendEV, sync_dispatch_to_closeEV, sync_dispatch_to_openEV, sync_dispatch_to_front_gear, sync_dispatch_to_front_door, sync_dispatch_to_left_gear, sync_dispatch_to_left_door, sync_dispatch_to_right_gear, sync_dispatch_to_right_door, me.getDispatcher_1Ref(), me.getHandleUpRef()),
				new AnalogSwitchBehavior(symbols, sync_dispatch_to_analogswitch, sync_analogSwitch2generalEV, me.getAnalogSwitch_is_closedRef()),
				new General_EVBehavior(symbols, sync_soft2generalEV, sync_analogSwitch2generalEV, sync_dispatch_to_generalEV, sync_generalEV2retractEV, sync_generalEV2extendEV, sync_generalEV2closeEV, sync_generalEV2openEV, me.getHydraulicPressureBeforeGeneralEVRef(), me.getHydraulicPressureInsideCircuitRef()),
				new Generic_EVBehavior(symbols, sync_soft2retractEV, sync_generalEV2retractEV, sync_dispatch_to_retractEV, sync_retractEV_to_front_gear, sync_retractEV_to_left_gear, sync_retractEV_to_right_gear, me.getHydraulicPressureInsideCircuitRef(), me.getHydraulicPressureAfterRetractEVRef()),
				new Generic_EVBehavior(symbols, sync_soft2extendEV, sync_generalEV2extendEV, sync_dispatch_to_extendEV, sync_extendEV_to_front_gear, sync_extendEV_to_left_gear, sync_extendEV_to_right_gear, me.getHydraulicPressureInsideCircuitRef(), me.getHydraulicPressureAfterExtendEVRef()),
				new Bouchon_Rint_1Behavior(symbols, sync_dispatch_to_closeEV),
				new Bouchon_Rint_1Behavior(symbols, sync_dispatch_to_openEV),
				new Bouchon_Rint_1Behavior(symbols, sync_dispatch_to_front_gear),
				new Bouchon_Rint_1Behavior(symbols, sync_dispatch_to_front_door),
				new Bouchon_Rint_1Behavior(symbols, sync_dispatch_to_left_gear),
				new Bouchon_Rint_1Behavior(symbols, sync_dispatch_to_left_door),
				new Bouchon_Rint_1Behavior(symbols, sync_dispatch_to_right_gear),
				new Bouchon_Rint_1Behavior(symbols, sync_dispatch_to_right_door),
				new Bouchon_Rint_1Behavior(symbols, sync_generalEV2closeEV),
				new Bouchon_Rint_1Behavior(symbols, sync_generalEV2openEV),
				new Bouchon_ES_1Behavior(symbols, sync_soft2generalEV),
				new Bouchon_ES_1Behavior(symbols, sync_soft2retractEV),
				new Bouchon_ES_1Behavior(symbols, sync_soft2extendEV),
				new Bouchon_Rint_1Behavior(symbols, sync_retractEV_to_front_gear),
				new Bouchon_Rint_1Behavior(symbols, sync_extendEV_to_front_gear),
				new Bouchon_Rint_1Behavior(symbols, sync_retractEV_to_left_gear),
				new Bouchon_Rint_1Behavior(symbols, sync_extendEV_to_left_gear),
				new Bouchon_Rint_1Behavior(symbols, sync_retractEV_to_right_gear),
				new Bouchon_Rint_1Behavior(symbols, sync_extendEV_to_right_gear)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

