package clocks_36_limit_at_23;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class SYSConfiguration extends BehaviorConfiguration {

	public int[] dispatcher_1;

	public boolean handleUp;

	public boolean analogSwitch_is_closed;

	public int hydraulicPressureBeforeGeneralEV;

	public int hydraulicPressureInsideCircuit;

	public int hydraulicPressureAfterRetractEV;

	public int hydraulicPressureAfterExtendEV;

	public boolean error;

	//Create initial configuration
	public SYSConfiguration() {
		this.dispatcher_1 = new int[]{};
		this.handleUp = false;
		this.analogSwitch_is_closed = false;
		this.hydraulicPressureBeforeGeneralEV = 0;
		this.hydraulicPressureInsideCircuit = 0;
		this.hydraulicPressureAfterRetractEV = 0;
		this.hydraulicPressureAfterExtendEV = 0;
		this.error = false;
	}

	//Create configuration as a copy
	public SYSConfiguration(SYSConfiguration other) {
		this.dispatcher_1 = new int[other.dispatcher_1.length];
		for (int i=0; i<other.dispatcher_1.length; i++) {
			this.dispatcher_1[i] = other.dispatcher_1[i];
		}
		this.handleUp = other.handleUp;
		this.analogSwitch_is_closed = other.analogSwitch_is_closed;
		this.hydraulicPressureBeforeGeneralEV = other.hydraulicPressureBeforeGeneralEV;
		this.hydraulicPressureInsideCircuit = other.hydraulicPressureInsideCircuit;
		this.hydraulicPressureAfterRetractEV = other.hydraulicPressureAfterRetractEV;
		this.hydraulicPressureAfterExtendEV = other.hydraulicPressureAfterExtendEV;
		this.error = other.error;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new SYSConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof SYSConfiguration) {
			SYSConfiguration other = (SYSConfiguration) object;
			if (!Arrays.equals(dispatcher_1, other.dispatcher_1)) return false;
			if (handleUp != other.handleUp) return false;
			if (analogSwitch_is_closed != other.analogSwitch_is_closed) return false;
			if (hydraulicPressureBeforeGeneralEV != other.hydraulicPressureBeforeGeneralEV) return false;
			if (hydraulicPressureInsideCircuit != other.hydraulicPressureInsideCircuit) return false;
			if (hydraulicPressureAfterRetractEV != other.hydraulicPressureAfterRetractEV) return false;
			if (hydraulicPressureAfterExtendEV != other.hydraulicPressureAfterExtendEV) return false;
			if (error != other.error) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.hashCode(dispatcher_1);
		total = total * 37 + (handleUp? 1 : 0);
		total = total * 37 + (analogSwitch_is_closed? 1 : 0);
		total = total * 37 + hydraulicPressureBeforeGeneralEV;
		total = total * 37 + hydraulicPressureInsideCircuit;
		total = total * 37 + hydraulicPressureAfterRetractEV;
		total = total * 37 + hydraulicPressureAfterExtendEV;
		total = total * 37 + (error? 1 : 0);
		return total;
	}

}

