package t1;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class P1Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S0 = 1;

	public static final short Stop = 2;

	private final BroadcastChannel chan;

	public P1Behavior(SymbolsTable symbols, BroadcastChannel chan) {
		super("P1", idSeed++, symbols);
		this.chan = chan;
		inputChannels = new Channel[]{this.chan};
	}

	private final String[] stateNames = new String[] {"s0", "stop"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return chan.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			P1Configuration me = (P1Configuration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final P1Configuration me = (P1Configuration) configuration.behaviorConfigurations[id];
			chan.input(id, actions);
			me.param_handle = chan.value(boolean.class,0);
			if ( chan.clockId != -1 ) {
				DBM.set(configuration.dbm, chan.clockId, 0);
			}
			me.state = Stop;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		P1Configuration me = new P1Configuration();
		//Initial action code.
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		P1Configuration me = (P1Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case P1Behavior.S0: 
			text.append("@s0,");
			break;
		case P1Behavior.Stop: 
			text.append("@stop,");
			break;
		}
		text.append("\n\t- param_handle=");
		text.append(Boolean.toString(me.param_handle));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		P1Configuration me = (P1Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case P1Behavior.S0: 
			text.append("@s0,");
			break;
		case P1Behavior.Stop: 
			text.append("@stop,");
			break;
		}
		text.append(" param_handle=");
		text.append(Boolean.toString(me.param_handle));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		P1Configuration me = new P1Configuration();
		me.state = boost.readShort();
		me.param_handle = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		P1Configuration me = (P1Configuration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.param_handle);
	}

}

