package test17;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Proc2Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short State1 = 1;

	public static final short Stop = 2;

	private final ReferencedArgument<T_msg[]> inputP1Ref;

	public Proc2Behavior(SymbolsTable symbols, ReferencedArgument<T_msg[]> inputP1) {
		super("proc2", idSeed++, symbols);
		this.inputP1Ref = inputP1;
	}

	private final String[] stateNames = new String[] {"state1", "stop"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			Proc2Configuration me = (Proc2Configuration) configuration.behaviorConfigurations[id];
			T_msg[] inputP1 = inputP1Ref.get(configuration);
			modifiedBehaviors[inputP1Ref.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Proc2Configuration me = (Proc2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != State1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Proc2Configuration me = (Proc2Configuration) configuration.behaviorConfigurations[id];
			T_msg[] inputP1 = inputP1Ref.get(configuration);
			try {
				inputP1 = FiacreQueueUtil.enqueue(id, inputP1,new T_msg.M1(), actions);
				inputP1 = FiacreQueueUtil.enqueue(id, inputP1,new T_msg.M2(), actions);
				me.state = Stop;
				if (true) return true;
			} finally {
				inputP1Ref.set(configuration, inputP1);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Proc2Configuration me = new Proc2Configuration();
		//Initial action code.
		me.state = State1;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Proc2Configuration me = (Proc2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Proc2Behavior.State1: 
			text.append("@state1,");
			break;
		case Proc2Behavior.Stop: 
			text.append("@stop,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Proc2Configuration me = (Proc2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Proc2Behavior.State1: 
			text.append("@state1,");
			break;
		case Proc2Behavior.Stop: 
			text.append("@stop,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Proc2Configuration me = new Proc2Configuration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Proc2Configuration me = (Proc2Configuration) processConfiguration;
		boost.writeShort(me.state);
	}

}

