package test17;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class Test17Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public Test17Behavior(SymbolsTable symbols) {
		super("test17", idSeed++, symbols);
	}

	public ReferencedArgument<T_msg[]> getInputP1Ref() {
return 		new ReferencedArgument<T_msg[]>(id) {
			@Override
			public T_msg[] get(Configuration configuration) {
				Test17Configuration me = (Test17Configuration) configuration.behaviorConfigurations[ownerId];
				return me.inputP1;
			}

			@Override
			public void set(Configuration configuration, T_msg[] value) {
				Test17Configuration me = (Test17Configuration) configuration.behaviorConfigurations[ownerId];
				me.inputP1 = value;
			}

			@Override
			public  Class<T_msg[]> getArgumentType() {
				return T_msg[].class;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Test17Configuration me = new Test17Configuration();
		//Initial action code.
		me.inputP1 = new T_msg[] {};
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Test17Configuration me = (Test17Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- inputP1=");
		text.append(Arrays.deepToString(me.inputP1));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Test17Configuration me = (Test17Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" inputP1=");
		text.append(Arrays.deepToString(me.inputP1));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Test17Configuration me = new Test17Configuration();
		me.inputP1 = new T_msg[Test17Root.SIZE_FIFO];
		me.inputP1 = new T_msg[boost.readInt()];
		for (int i=0; i<me.inputP1.length; i++) {
			me.inputP1[i] = boost.readObject(T_msg.class);
		}
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Test17Configuration me = (Test17Configuration) processConfiguration;
		boost.writeInt(me.inputP1.length);
		for (int i=0; i<me.inputP1.length; i++) {
			boost.writeObject(me.inputP1[i]);
		}
	}

}

