package double01;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class ProcBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short State1 = 1;

	public static final short State2 = 2;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final WaitChannel wait2;

	private final WaitChannel wait3;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public ProcBehavior(SymbolsTable symbols) {
		super("proc", idSeed++, symbols);
		symbols.registerClockIndexes(this.getId(), (short) 2);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 1, false, 1, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 1, 3, false, 3, false);
		wait2 = new WaitChannel(null, symbols, this.getId(), (short) 0, 1, false, 1, false);
		wait3 = new WaitChannel(null, symbols, this.getId(), (short) 1, 3, false, 3, false);
		channels = new Channel[] { wait0, wait1, wait2, wait3,  };
	}

	private final String[] stateNames = new String[] {"state1", "state2"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ProcConfiguration me = (ProcConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ProcConfiguration me = (ProcConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = State1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ProcConfiguration me = (ProcConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ProcConfiguration me = (ProcConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait1.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = State2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait2.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ProcConfiguration me = (ProcConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ProcConfiguration me = (ProcConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait2.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = State2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait3.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ProcConfiguration me = (ProcConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ProcConfiguration me = (ProcConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait3.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = State1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		ProcConfiguration me = new ProcConfiguration();
		//Initial action code.
		me.state = State1;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ProcConfiguration me = (ProcConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ProcBehavior.State1: 
			text.append("@state1,");
			break;
		case ProcBehavior.State2: 
			text.append("@state2,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ProcConfiguration me = (ProcConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ProcBehavior.State1: 
			text.append("@state1,");
			break;
		case ProcBehavior.State2: 
			text.append("@state2,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		ProcConfiguration me = new ProcConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		ProcConfiguration me = (ProcConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

