package simple02_with_ports;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class ProcComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public ProcComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("proc", idSeed++);
		BroadcastChannel wait12 = new BroadcastChannel(name+":wait12", symbols, 1, 1, 1, false, 2, false);
		channels = new Channel[] { wait12,  };
		
		components = new Component[] {
				new Main_procBehavior(symbols, wait12),
				new Wait_procBehavior(symbols, wait12)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

