package simple03_with_ports;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Wait_procBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Waiting = 1;

	private final BroadcastChannel wait12;

	public Wait_procBehavior(SymbolsTable symbols, BroadcastChannel wait12) {
		super("wait_proc", idSeed++, symbols);
		this.wait12 = wait12;
		outputChannels = new Channel[]{this.wait12};
	}

	private final String[] stateNames = new String[] {"waiting"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait12.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Wait_procConfiguration me = (Wait_procConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Waiting) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Wait_procConfiguration me = (Wait_procConfiguration) configuration.behaviorConfigurations[id];
			wait12.output(id, actions);
			me.state = Waiting;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Wait_procConfiguration me = new Wait_procConfiguration();
		//Initial action code.
		me.state = Waiting;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Wait_procConfiguration me = (Wait_procConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Wait_procBehavior.Waiting: 
			text.append("@waiting,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Wait_procConfiguration me = (Wait_procConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Wait_procBehavior.Waiting: 
			text.append("@waiting,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Wait_procConfiguration me = new Wait_procConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Wait_procConfiguration me = (Wait_procConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

