package test_loop_and_wait;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class BlockBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Run = 1;

	private final ReferencedArgumentBoolean goRef;

	public BlockBehavior(SymbolsTable symbols, ReferencedArgumentBoolean go) {
		super("block", idSeed++, symbols);
		this.goRef = go;
	}

	private final String[] stateNames = new String[] {"run"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			BlockConfiguration me = (BlockConfiguration) configuration.behaviorConfigurations[id];
			boolean go = goRef.get(configuration);
			modifiedBehaviors[goRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			BlockConfiguration me = (BlockConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Run) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final BlockConfiguration me = (BlockConfiguration) configuration.behaviorConfigurations[id];
			boolean go = goRef.get(configuration);
			try {
				go = true;
				me.state = Run;
				if (true) return true;
			} finally {
				goRef.set(configuration, go);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			BlockConfiguration me = (BlockConfiguration) configuration.behaviorConfigurations[id];
			boolean go = goRef.get(configuration);
			modifiedBehaviors[goRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			BlockConfiguration me = (BlockConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Run) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final BlockConfiguration me = (BlockConfiguration) configuration.behaviorConfigurations[id];
			boolean go = goRef.get(configuration);
			try {
				go = false;
				me.state = Run;
				if (true) return true;
			} finally {
				goRef.set(configuration, go);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		BlockConfiguration me = new BlockConfiguration();
		//Initial action code.
		me.state = Run;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		BlockConfiguration me = (BlockConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case BlockBehavior.Run: 
			text.append("@run,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		BlockConfiguration me = (BlockConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case BlockBehavior.Run: 
			text.append("@run,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		BlockConfiguration me = new BlockConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		BlockConfiguration me = (BlockConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

