package test_loop_and_wait;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class ClockBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Run = 1;

	private final BroadcastChannel tick;

	public ClockBehavior(SymbolsTable symbols, BroadcastChannel tick) {
		super("clock", idSeed++, symbols);
		this.tick = tick;
		outputChannels = new Channel[]{this.tick};
	}

	private final String[] stateNames = new String[] {"run"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return tick.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ClockConfiguration me = (ClockConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Run) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ClockConfiguration me = (ClockConfiguration) configuration.behaviorConfigurations[id];
			tick.output(id, actions);
			me.state = Run;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		ClockConfiguration me = new ClockConfiguration();
		//Initial action code.
		me.state = Run;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ClockConfiguration me = (ClockConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ClockBehavior.Run: 
			text.append("@run,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ClockConfiguration me = (ClockConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ClockBehavior.Run: 
			text.append("@run,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		ClockConfiguration me = new ClockConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		ClockConfiguration me = (ClockConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

