package test_loop_and_wait;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class CompBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public CompBehavior(SymbolsTable symbols) {
		super("comp", idSeed++, symbols);
	}

	public ReferencedArgumentBoolean getGoRef() {
return 		new ReferencedArgumentBoolean(id) {
			@Override
			public boolean get(Configuration configuration) {
				CompConfiguration me = (CompConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.go;
			}

			@Override
			public void set(Configuration configuration, boolean value) {
				CompConfiguration me = (CompConfiguration) configuration.behaviorConfigurations[ownerId];
				me.go = value;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		CompConfiguration me = new CompConfiguration();
		//Initial action code.
		me.go = true;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CompConfiguration me = (CompConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- go=");
		text.append(Boolean.toString(me.go));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CompConfiguration me = (CompConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" go=");
		text.append(Boolean.toString(me.go));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		CompConfiguration me = new CompConfiguration();
		me.go = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		CompConfiguration me = (CompConfiguration) processConfiguration;
		boost.writeBoolean(me.go);
	}

}

