package test_loop_and_wait;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class CompComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public CompComposition(SymbolsTable symbols) {
		CompBehavior me = new CompBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		BroadcastChannel tick = new BroadcastChannel(me.name+":tick", symbols, 1, 1, 1, false, 1, false);
		channels = new Channel[] { tick,  };
		
		components = new Component[] {
				me,
				new ProcBehavior(symbols, tick, me.getGoRef()),
				new ClockBehavior(symbols, tick),
				new BlockBehavior(symbols, me.getGoRef())
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

