package triple01_with_ports;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class Main_procBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short State1 = 1;

	public static final short State2 = 2;

	private final BroadcastChannel state1_wait11;

	private final BroadcastChannel state1_wait22;

	private final BroadcastChannel state2_wait11;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public Main_procBehavior(SymbolsTable symbols, BroadcastChannel state1_wait11, BroadcastChannel state1_wait22, BroadcastChannel state2_wait11) {
		super("main_proc", idSeed++, symbols);
		this.state1_wait11 = state1_wait11;
		this.state1_wait22 = state1_wait22;
		this.state2_wait11 = state2_wait11;
		inputChannels = new Channel[]{this.state1_wait11, this.state1_wait22, this.state2_wait11};
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 3, false, 3, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 0, 3, false, 3, false);
		channels = new Channel[] { wait0, wait1,  };
	}

	private final String[] stateNames = new String[] {"state1", "state2"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return state1_wait11.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			state1_wait11.input(id, actions);
			if ( state1_wait11.clockId != -1 ) {
				DBM.set(configuration.dbm, state1_wait11.clockId, 0);
			}
			me.state = State1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return state1_wait22.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			state1_wait22.input(id, actions);
			if ( state1_wait22.clockId != -1 ) {
				DBM.set(configuration.dbm, state1_wait22.clockId, 0);
			}
			me.state = State1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = State2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return state2_wait11.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			state2_wait11.input(id, actions);
			if ( state2_wait11.clockId != -1 ) {
				DBM.set(configuration.dbm, state2_wait11.clockId, 0);
			}
			me.state = State2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != State2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Main_procConfiguration me = (Main_procConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait1.clockId, 0);
			actions.add(new DelayAction(id));
			me.state = State1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Main_procConfiguration me = new Main_procConfiguration();
		//Initial action code.
		me.state = State1;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Main_procConfiguration me = (Main_procConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Main_procBehavior.State1: 
			text.append("@state1,");
			break;
		case Main_procBehavior.State2: 
			text.append("@state2,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Main_procConfiguration me = (Main_procConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Main_procBehavior.State1: 
			text.append("@state1,");
			break;
		case Main_procBehavior.State2: 
			text.append("@state2,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Main_procConfiguration me = new Main_procConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Main_procConfiguration me = (Main_procConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

