package triple01_with_ports;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class ProcComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public ProcComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("proc", idSeed++);
		BroadcastChannel state1_wait11 = new BroadcastChannel(name+":state1_wait11", symbols, 1, 1, 1, false, 1, false);
		BroadcastChannel state1_wait22 = new BroadcastChannel(name+":state1_wait22", symbols, 1, 1, 2, false, 2, false);
		BroadcastChannel state2_wait11 = new BroadcastChannel(name+":state2_wait11", symbols, 1, 1, 1, false, 1, false);
		channels = new Channel[] { state1_wait11, state1_wait22, state2_wait11,  };
		
		components = new Component[] {
				new Main_procBehavior(symbols, state1_wait11, state1_wait22, state2_wait11),
				new Wait_procBehavior(symbols, state1_wait11, state1_wait22, state2_wait11)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

