package triple02_with_ports;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class ProcComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public ProcComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("proc", idSeed++);
		BroadcastChannel state1_wait13 = new BroadcastChannel(name+":state1_wait13", symbols, 1, 1, 1, false, 3, false);
		BroadcastChannel state1_wait24 = new BroadcastChannel(name+":state1_wait24", symbols, 1, 1, 2, false, 4, false);
		BroadcastChannel state2_wait13 = new BroadcastChannel(name+":state2_wait13", symbols, 1, 1, 1, false, 3, false);
		channels = new Channel[] { state1_wait13, state1_wait24, state2_wait13,  };
		
		components = new Component[] {
				new Main_procBehavior(symbols, state1_wait13, state1_wait24, state2_wait13),
				new Wait_procBehavior(symbols, state1_wait13, state1_wait24, state2_wait13)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

