package twocounters;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class CounterBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S0 = 1;

	public CounterBehavior(SymbolsTable symbols) {
		super("counter", idSeed++, symbols);
	}

	private final String[] stateNames = new String[] {"s0"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CounterConfiguration me = (CounterConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CounterConfiguration me = (CounterConfiguration) configuration.behaviorConfigurations[id];
			if (((me.v) >= (2)) == true) {
			} else {
				if (true) { return false; }
			}
			me.v = 0;
			me.state = S0;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CounterConfiguration me = (CounterConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CounterConfiguration me = (CounterConfiguration) configuration.behaviorConfigurations[id];
			if (((me.v) < (2)) == true) {
			} else {
				if (true) { return false; }
			}
			me.v = (me.v) + (1);
			me.state = S0;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CounterConfiguration me = (CounterConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CounterConfiguration me = (CounterConfiguration) configuration.behaviorConfigurations[id];
			if (((me.v) < (2)) == true) {
			} else {
				if (true) { return false; }
			}
			me.v = (me.v) + (2);
			me.state = S0;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		CounterConfiguration me = new CounterConfiguration();
		//Initial action code.
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CounterConfiguration me = (CounterConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case CounterBehavior.S0: 
			text.append("@s0,");
			break;
		}
		text.append("\n\t- v=");
		text.append(Integer.toString(me.v));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CounterConfiguration me = (CounterConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case CounterBehavior.S0: 
			text.append("@s0,");
			break;
		}
		text.append(" v=");
		text.append(Integer.toString(me.v));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		CounterConfiguration me = new CounterConfiguration();
		me.state = boost.readShort();
		me.v = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		CounterConfiguration me = (CounterConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.v);
	}

}

