package lgs_pilotinternal;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.InformalAction;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentBoolean;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

@SuppressWarnings("all")
public class EV_managementBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short INIT_front_door = 1;

	public static final short INIT_left_door = 2;

	public static final short INIT_right_door = 3;

	public static final short INIT_front_gear = 4;

	public static final short INIT_left_gear = 5;

	public static final short INIT_right_gear = 6;

	public static final short INIT_handle = 7;

	public static final short INIT_switch = 8;

	public static final short INIT_pressure = 9;

	public static final short End_INIT = 10;

	public static final short INIT_general = 11;

	public static final short INIT_open = 12;

	public static final short INIT_retract = 13;

	public static final short INIT_close = 14;

	public static final short INIT_extend = 15;

	public static final short Start_unpressurized_down = 16;

	public static final short Start_unpressurized_up = 17;

	public static final short UP_wait_switch_on = 18;

	public static final short UP_generalEV_ON = 19;

	public static final short UP_wait_pressure = 20;

	public static final short UP_openEV_ON = 21;

	public static final short UP_wait_door_opened = 22;

	public static final short UP_retractEV_ON = 23;

	public static final short UP_wait_gear_retracted = 24;

	public static final short UP_retractEV_OFF = 25;

	public static final short UP_openEV_OFF = 26;

	public static final short UP_wait_before_closing_doors = 27;

	public static final short UP_closeEV_ON = 28;

	public static final short UP_wait_door_closed = 29;

	public static final short UP_closeEV_OFF = 30;

	public static final short UP_generalEV_OFF = 31;

	public static final short UP_wait_end_pressure = 32;

	public static final short DOWN_wait_switch_on = 33;

	public static final short DOWN_generalEV_ON = 34;

	public static final short DOWN_wait_pressure = 35;

	public static final short DOWN_openEV_ON = 36;

	public static final short DOWN_wait_door_opened = 37;

	public static final short DOWN_extendEV_ON = 38;

	public static final short DOWN_wait_gear_extended = 39;

	public static final short DOWN_extendEV_OFF = 40;

	public static final short DOWN_openEV_OFF = 41;

	public static final short DOWN_wait_before_closing_doors = 42;

	public static final short DOWN_closeEV_ON = 43;

	public static final short DOWN_wait_door_closed = 44;

	public static final short DOWN_closeEV_OFF = 45;

	public static final short DOWN_generalEV_OFF = 46;

	public static final short DOWN_wait_end_pressure = 47;

	public static final short UP2DOWN_wait_before_extending_gears = 48;

	public static final short DOWN2UP_wait_before_retracting_gears = 49;

	public static final short UP2DOWN_wait_before_opening_doors = 50;

	public static final short DOWN2UP_wait_before_opening_doors = 51;

	public static final short ANOMALY = 52;

	public static final short DEAD = 53;

	private final short informal152;

	private final short informal153;

	private final short informal154;

	private final short informal155;

	private final short informal156;

	private final short informal157;

	private final short informal158;

	private final short informal159;

	private final short informal160;

	private final short informal161;

	private final short informal162;

	private final short informal163;

	private final short informal164;

	private final short informal165;

	private final short informal166;

	private final short informal167;

	private final short informal168;

	private final short informal169;

	private final short informal170;

	private final BroadcastChannel handle;

	private final BroadcastChannel switch_;

	private final BroadcastChannel pressure;

	private final BroadcastChannel front_door_position;

	private final BroadcastChannel left_door_position;

	private final BroadcastChannel right_door_position;

	private final BroadcastChannel front_gear_position;

	private final BroadcastChannel left_gear_position;

	private final BroadcastChannel right_gear_position;

	private final BroadcastChannel general;

	private final BroadcastChannel open;

	private final BroadcastChannel retract;

	private final BroadcastChannel close;

	private final BroadcastChannel extend;

	private final ReferencedArgument<int[]> toContextRef;

	private final ReferencedArgumentBoolean red_lightRef;

	private final WaitChannel wait0;

	private final WaitChannel wait1;

	private final WaitChannel wait2;

	private final WaitChannel wait3;

	private final WaitChannel wait4;

	private final WaitChannel wait5;

	private final WaitChannel wait6;

	private final WaitChannel wait7;

	private final WaitChannel wait8;

	private final WaitChannel wait9;

	private final WaitChannel wait10;

	private final WaitChannel wait11;

	private final WaitChannel wait12;

	private final WaitChannel wait13;

	private final WaitChannel wait14;

	private final WaitChannel wait15;

	private final WaitChannel wait16;

	private final WaitChannel wait17;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public EV_managementBehavior(SymbolsTable symbols, BroadcastChannel handle, BroadcastChannel switch_, BroadcastChannel pressure, BroadcastChannel front_door_position, BroadcastChannel left_door_position, BroadcastChannel right_door_position, BroadcastChannel front_gear_position, BroadcastChannel left_gear_position, BroadcastChannel right_gear_position, BroadcastChannel general, BroadcastChannel open, BroadcastChannel retract, BroadcastChannel close, BroadcastChannel extend, ReferencedArgument<int[]> toContext, ReferencedArgumentBoolean red_light) {
		super("EV_management", idSeed++, symbols);
		this.handle = handle;
		this.switch_ = switch_;
		this.pressure = pressure;
		this.front_door_position = front_door_position;
		this.left_door_position = left_door_position;
		this.right_door_position = right_door_position;
		this.front_gear_position = front_gear_position;
		this.left_gear_position = left_gear_position;
		this.right_gear_position = right_gear_position;
		this.general = general;
		this.open = open;
		this.retract = retract;
		this.close = close;
		this.extend = extend;
		inputChannels = new Channel[]{this.handle, this.switch_, this.pressure, this.front_door_position, this.left_door_position, this.right_door_position, this.front_gear_position, this.left_gear_position, this.right_gear_position};
		outputChannels = new Channel[]{this.general, this.open, this.retract, this.close, this.extend};
		this.toContextRef = toContext;
		this.red_lightRef = red_light;
		informal152 = symbols.getInformalId("switch non ouvert à temps");
		informal153 = symbols.getInformalId("generalEV ON");
		informal154 = symbols.getInformalId("Pressure non arrivée à temps");
		informal155 = symbols.getInformalId("open ON");
		informal156 = symbols.getInformalId("porte non ouverte à temps");
		informal157 = symbols.getInformalId("retract ON");
		informal158 = symbols.getInformalId("train non retracté à temps");
		informal159 = symbols.getInformalId("retract OFF");
		informal160 = symbols.getInformalId("open OFF");
		informal161 = symbols.getInformalId("close ON");
		informal162 = symbols.getInformalId("porte non refermée à temps");
		informal163 = symbols.getInformalId("close OFF");
		informal164 = symbols.getInformalId("general OFF");
		informal165 = symbols.getInformalId("pressure non partie à temps");
		informal166 = symbols.getInformalId("pressure non arrivée à temps");
		informal167 = symbols.getInformalId("extend ON");
		informal168 = symbols.getInformalId("train non étendu à temps");
		informal169 = symbols.getInformalId("extend OFF");
		informal170 = symbols.getInformalId("porte non fermée à temps");
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 10, false, 10, false);
		wait1 = new WaitChannel(null, symbols, this.getId(), (short) 0, 20, false, 20, false);
		wait2 = new WaitChannel(null, symbols, this.getId(), (short) 0, 100, false, 100, false);
		wait3 = new WaitChannel(null, symbols, this.getId(), (short) 0, 100, false, 100, false);
		wait4 = new WaitChannel(null, symbols, this.getId(), (short) 0, 40, false, 40, false);
		wait5 = new WaitChannel(null, symbols, this.getId(), (short) 0, 100, false, 100, false);
		wait6 = new WaitChannel(null, symbols, this.getId(), (short) 0, 40, false, 40, false);
		wait7 = new WaitChannel(null, symbols, this.getId(), (short) 0, 40, false, 40, false);
		wait8 = new WaitChannel(null, symbols, this.getId(), (short) 0, 40, false, 40, false);
		wait9 = new WaitChannel(null, symbols, this.getId(), (short) 0, 40, false, 40, false);
		wait10 = new WaitChannel(null, symbols, this.getId(), (short) 0, 40, false, 40, false);
		wait11 = new WaitChannel(null, symbols, this.getId(), (short) 0, 10, false, 10, false);
		wait12 = new WaitChannel(null, symbols, this.getId(), (short) 0, 20, false, 20, false);
		wait13 = new WaitChannel(null, symbols, this.getId(), (short) 0, 100, false, 100, false);
		wait14 = new WaitChannel(null, symbols, this.getId(), (short) 0, 100, false, 100, false);
		wait15 = new WaitChannel(null, symbols, this.getId(), (short) 0, 40, false, 40, false);
		wait16 = new WaitChannel(null, symbols, this.getId(), (short) 0, 100, false, 100, false);
		wait17 = new WaitChannel(null, symbols, this.getId(), (short) 0, 40, false, 40, false);
		channels = new Channel[] { wait0, wait1, wait2, wait3, wait4, wait5, wait6, wait7, wait8, wait9, wait10, wait11, wait12, wait13, wait14, wait15, wait16, wait17,  };
	}

	private final String[] stateNames = new String[] {"INIT_front_door", "INIT_left_door", "INIT_right_door", "INIT_front_gear", "INIT_left_gear", "INIT_right_gear", "INIT_handle", "INIT_switch", "INIT_pressure", "end_INIT", "INIT_general", "INIT_open", "INIT_retract", "INIT_close", "INIT_extend", "start_unpressurized_down", "start_unpressurized_up", "UP_wait_switch_on", "UP_generalEV_ON", "UP_wait_pressure", "UP_openEV_ON", "UP_wait_door_opened", "UP_retractEV_ON", "UP_wait_gear_retracted", "UP_retractEV_OFF", "UP_openEV_OFF", "UP_wait_before_closing_doors", "UP_closeEV_ON", "UP_wait_door_closed", "UP_closeEV_OFF", "UP_generalEV_OFF", "UP_wait_end_pressure", "DOWN_wait_switch_on", "DOWN_generalEV_ON", "DOWN_wait_pressure", "DOWN_openEV_ON", "DOWN_wait_door_opened", "DOWN_extendEV_ON", "DOWN_wait_gear_extended", "DOWN_extendEV_OFF", "DOWN_openEV_OFF", "DOWN_wait_before_closing_doors", "DOWN_closeEV_ON", "DOWN_wait_door_closed", "DOWN_closeEV_OFF", "DOWN_generalEV_OFF", "DOWN_wait_end_pressure", "UP2DOWN_wait_before_extending_gears", "DOWN2UP_wait_before_retracting_gears", "UP2DOWN_wait_before_opening_doors", "DOWN2UP_wait_before_opening_doors", "ANOMALY", "DEAD"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_handle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = INIT_switch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_switch) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = INIT_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = INIT_general;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return general.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_general) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			general.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			me.state = INIT_retract;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_retract) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			retract.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			me.state = INIT_extend;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_extend) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			extend.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			me.state = INIT_close;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_close) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			close.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			me.state = INIT_open;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_open) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			open.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			me.state = INIT_front_door;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_front_door) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = INIT_left_door;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_left_door) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = INIT_right_door;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition10 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_right_door) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = INIT_front_gear;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition11 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_front_gear) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = INIT_left_gear;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition12 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_left_gear) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = INIT_right_gear;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition13 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != INIT_right_gear) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = End_INIT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition14 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			int[] toContext = toContextRef.get(configuration);
			modifiedBehaviors[toContextRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != End_INIT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			int[] toContext = toContextRef.get(configuration);
			try {
				if ( (toContext.length >= 1 )) {
					me.state = End_INIT;
					if (true) return true;
				} else {
					toContext = FiacreQueueUtil.enqueue(id, toContext,LGS_PilotInternalRoot.OK, actions);
					me.state = Start_unpressurized_down;
					if (true) return true;
				}
			} finally {
				toContextRef.set(configuration, toContext);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition15 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
				if (me.param_switch == LGS_PilotInternalRoot.SWITCH_ON) {
					me.state = UP_generalEV_ON;
					if (true) return true;
				} else {
					me.state = UP_wait_switch_on;
					if (true) return true;
				}
			} else {
				me.state = Start_unpressurized_down;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition16 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = Start_unpressurized_down;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition17 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition18 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition19 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition20 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition21 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition22 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition23 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_down) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition24 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
				if (me.param_switch == LGS_PilotInternalRoot.SWITCH_ON) {
					me.state = DOWN_generalEV_ON;
					if (true) return true;
				} else {
					me.state = DOWN_wait_switch_on;
					if (true) return true;
				}
			} else {
				me.state = Start_unpressurized_up;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition25 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = Start_unpressurized_up;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition26 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition27 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition28 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition29 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition30 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition31 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition32 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start_unpressurized_up) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition33 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			if (me.param_switch == LGS_PilotInternalRoot.SWITCH_ON) {
				if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
					me.state = UP_generalEV_ON;
					if (true) return true;
				} else {
					me.state = Start_unpressurized_down;
					if (true) return true;
				}
			} else {
				me.state = UP_wait_switch_on;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition34 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal152));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition35 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP_wait_switch_on;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition36 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition37 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition38 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition39 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition40 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition41 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition42 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition43 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return general.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_generalEV_ON) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			general.output(id, actions, LGS_PilotInternalRoot.EV_ON);
			actions.add(new InformalAction(id, informal153));
			me.state = UP_wait_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition44 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			if (me.param_pressure == LGS_PilotInternalRoot.PRESSURE_ON) {
				if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
					me.state = UP_openEV_ON;
					if (true) return true;
				} else {
					me.state = DOWN_generalEV_OFF;
					if (true) return true;
				}
			} else {
				me.state = UP_wait_pressure;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition45 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait1.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal154));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition46 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP_wait_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition47 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition48 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition49 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition50 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition51 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition52 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition53 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition54 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_openEV_ON) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			open.output(id, actions, LGS_PilotInternalRoot.EV_ON);
			actions.add(new InformalAction(id, informal155));
			me.state = UP_wait_door_opened;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition55 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			if (me.param_front_door_position != LGS_PilotInternalRoot.OPEN) {
				me.state = UP_wait_door_opened;
				if (true) return true;
			} else {
				if (me.param_left_door_position != LGS_PilotInternalRoot.OPEN) {
					me.state = UP_wait_door_opened;
					if (true) return true;
				} else {
					if (me.param_right_door_position != LGS_PilotInternalRoot.OPEN) {
						me.state = UP_wait_door_opened;
						if (true) return true;
					} else {
						if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
							me.state = UP_retractEV_ON;
							if (true) return true;
						} else {
							me.state = DOWN_openEV_OFF;
							if (true) return true;
						}
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition56 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			if (me.param_left_door_position != LGS_PilotInternalRoot.OPEN) {
				me.state = UP_wait_door_opened;
				if (true) return true;
			} else {
				if (me.param_front_door_position != LGS_PilotInternalRoot.OPEN) {
					me.state = UP_wait_door_opened;
					if (true) return true;
				} else {
					if (me.param_right_door_position != LGS_PilotInternalRoot.OPEN) {
						me.state = UP_wait_door_opened;
						if (true) return true;
					} else {
						if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
							me.state = UP_retractEV_ON;
							if (true) return true;
						} else {
							me.state = DOWN_openEV_OFF;
							if (true) return true;
						}
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition57 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			if (me.param_right_door_position != LGS_PilotInternalRoot.OPEN) {
				me.state = UP_wait_door_opened;
				if (true) return true;
			} else {
				if (me.param_front_door_position != LGS_PilotInternalRoot.OPEN) {
					me.state = UP_wait_door_opened;
					if (true) return true;
				} else {
					if (me.param_left_door_position != LGS_PilotInternalRoot.OPEN) {
						me.state = UP_wait_door_opened;
						if (true) return true;
					} else {
						if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
							me.state = UP_retractEV_ON;
							if (true) return true;
						} else {
							me.state = DOWN_openEV_OFF;
							if (true) return true;
						}
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition58 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait2.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait2.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal156));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition59 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP_wait_door_opened;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition60 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition61 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition62 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition63 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition64 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition65 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_retractEV_ON) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			retract.output(id, actions, LGS_PilotInternalRoot.EV_ON);
			actions.add(new InformalAction(id, informal157));
			me.state = UP_wait_gear_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition66 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			if (me.param_front_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
				me.state = UP_wait_gear_retracted;
				if (true) return true;
			} else {
				if (me.param_left_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
					me.state = UP_wait_gear_retracted;
					if (true) return true;
				} else {
					if (me.param_right_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
						me.state = UP_wait_gear_retracted;
						if (true) return true;
					} else {
						me.state = UP_retractEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition67 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			if (me.param_left_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
				me.state = UP_wait_gear_retracted;
				if (true) return true;
			} else {
				if (me.param_front_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
					me.state = UP_wait_gear_retracted;
					if (true) return true;
				} else {
					if (me.param_right_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
						me.state = UP_wait_gear_retracted;
						if (true) return true;
					} else {
						me.state = UP_retractEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition68 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			if (me.param_right_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
				me.state = UP_wait_gear_retracted;
				if (true) return true;
			} else {
				if (me.param_front_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
					me.state = UP_wait_gear_retracted;
					if (true) return true;
				} else {
					if (me.param_left_gear_position != LGS_PilotInternalRoot.LOCKED_RETRACTED) {
						me.state = UP_wait_gear_retracted;
						if (true) return true;
					} else {
						me.state = UP_retractEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition69 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait3.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait3.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal158));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition70 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP_wait_gear_retracted;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition71 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition72 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition73 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition74 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition75 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_gear_retracted) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition76 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return retract.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_retractEV_OFF) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			retract.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
				actions.add(new InformalAction(id, informal159));
				me.state = UP_openEV_OFF;
				if (true) return true;
			} else {
				me.state = UP2DOWN_wait_before_extending_gears;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition77 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_openEV_OFF) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			open.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			actions.add(new InformalAction(id, informal160));
			me.state = UP_wait_before_closing_doors;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition78 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait4.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait4.clockId, 0);
			actions.add(new DelayAction(id));
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
				me.state = UP_closeEV_ON;
				if (true) return true;
			} else {
				me.state = DOWN_openEV_ON;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition79 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP_wait_before_closing_doors;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition80 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition81 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition82 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			if (me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				me.state = UP_wait_before_closing_doors;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition83 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			if (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				me.state = UP_wait_before_closing_doors;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition84 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			if (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				me.state = UP_wait_before_closing_doors;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition85 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition86 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition87 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition88 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_closeEV_ON) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			close.output(id, actions, LGS_PilotInternalRoot.EV_ON);
			actions.add(new InformalAction(id, informal161));
			me.state = UP_wait_door_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition89 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			if (me.param_front_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = UP_wait_door_closed;
				if (true) return true;
			} else {
				if (me.param_left_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
					me.state = UP_wait_door_closed;
					if (true) return true;
				} else {
					if (me.param_right_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
						me.state = UP_wait_door_closed;
						if (true) return true;
					} else {
						me.state = UP_closeEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition90 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			if (me.param_left_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = UP_wait_door_closed;
				if (true) return true;
			} else {
				if (me.param_front_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
					me.state = UP_wait_door_closed;
					if (true) return true;
				} else {
					if (me.param_right_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
						me.state = UP_wait_door_closed;
						if (true) return true;
					} else {
						me.state = UP_closeEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition91 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			if (me.param_right_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = UP_wait_door_closed;
				if (true) return true;
			} else {
				if (me.param_front_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
					me.state = UP_wait_door_closed;
					if (true) return true;
				} else {
					if (me.param_left_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
						me.state = UP_wait_door_closed;
						if (true) return true;
					} else {
						me.state = UP_closeEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition92 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait5.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait5.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal162));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition93 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP_wait_door_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition94 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition95 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition96 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition97 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition98 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition99 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_closeEV_OFF) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			close.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
				actions.add(new InformalAction(id, informal163));
				me.state = UP_generalEV_OFF;
				if (true) return true;
			} else {
				me.state = UP2DOWN_wait_before_opening_doors;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition100 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return general.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_generalEV_OFF) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			general.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			actions.add(new InformalAction(id, informal164));
			me.state = UP_wait_end_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition101 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			if (me.param_pressure == LGS_PilotInternalRoot.PRESSURE_OFF) {
				if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
					me.state = Start_unpressurized_up;
					if (true) return true;
				} else {
					if (me.param_switch == LGS_PilotInternalRoot.SWITCH_ON) {
						me.state = DOWN_generalEV_ON;
						if (true) return true;
					} else {
						me.state = DOWN_wait_switch_on;
						if (true) return true;
					}
				}
			} else {
				me.state = UP_wait_end_pressure;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition102 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait6.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait6.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal165));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition103 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP_wait_end_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition104 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition105 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition106 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition107 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition108 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition109 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition110 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition111 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait7.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait7.clockId, 0);
			actions.add(new DelayAction(id));
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
				me.state = DOWN_extendEV_ON;
				if (true) return true;
			} else {
				me.state = UP_openEV_OFF;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition112 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP2DOWN_wait_before_extending_gears;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition113 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition114 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition115 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition116 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition117 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition118 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition119 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition120 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_extending_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition121 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait8.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait8.clockId, 0);
			actions.add(new DelayAction(id));
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
				me.state = UP_retractEV_ON;
				if (true) return true;
			} else {
				me.state = DOWN_openEV_OFF;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition122 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN2UP_wait_before_retracting_gears;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition123 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition124 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition125 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition126 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition127 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition128 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition129 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition130 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_retracting_gears) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition131 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait9.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait9.clockId, 0);
			actions.add(new DelayAction(id));
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
				me.state = DOWN_openEV_ON;
				if (true) return true;
			} else {
				me.state = UP_generalEV_OFF;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition132 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = UP2DOWN_wait_before_opening_doors;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition133 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition134 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition135 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition136 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition137 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition138 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition139 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition140 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != UP2DOWN_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition141 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait10.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait10.clockId, 0);
			actions.add(new DelayAction(id));
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_UP) {
				me.state = UP_openEV_ON;
				if (true) return true;
			} else {
				me.state = DOWN_generalEV_OFF;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition142 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN2UP_wait_before_opening_doors;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition143 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition144 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition145 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition146 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition147 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition148 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition149 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition150 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN2UP_wait_before_opening_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition151 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			if (me.param_switch == LGS_PilotInternalRoot.SWITCH_ON) {
				if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
					me.state = DOWN_generalEV_ON;
					if (true) return true;
				} else {
					me.state = Start_unpressurized_up;
					if (true) return true;
				}
			} else {
				me.state = DOWN_wait_switch_on;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition152 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait11.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait11.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal152));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition153 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN_wait_switch_on;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition154 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition155 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition156 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition157 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition158 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition159 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition160 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_switch_on) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition161 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return general.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_generalEV_ON) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			general.output(id, actions, LGS_PilotInternalRoot.EV_ON);
			actions.add(new InformalAction(id, informal153));
			me.state = DOWN_wait_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition162 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			if (me.param_pressure == LGS_PilotInternalRoot.PRESSURE_ON) {
				if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
					me.state = DOWN_openEV_ON;
					if (true) return true;
				} else {
					me.state = UP_generalEV_OFF;
					if (true) return true;
				}
			} else {
				me.state = DOWN_wait_pressure;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition163 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait12.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait12.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal166));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition164 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN_wait_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition165 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition166 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition167 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition168 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition169 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition170 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition171 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition172 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_openEV_ON) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			open.output(id, actions, LGS_PilotInternalRoot.EV_ON);
			actions.add(new InformalAction(id, informal155));
			me.state = DOWN_wait_door_opened;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition173 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			if (me.param_front_door_position != LGS_PilotInternalRoot.OPEN) {
				me.state = DOWN_wait_door_opened;
				if (true) return true;
			} else {
				if (me.param_left_door_position != LGS_PilotInternalRoot.OPEN) {
					me.state = DOWN_wait_door_opened;
					if (true) return true;
				} else {
					if (me.param_right_door_position != LGS_PilotInternalRoot.OPEN) {
						me.state = DOWN_wait_door_opened;
						if (true) return true;
					} else {
						if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
							me.state = DOWN_extendEV_ON;
							if (true) return true;
						} else {
							me.state = UP_openEV_OFF;
							if (true) return true;
						}
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition174 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			if (me.param_left_door_position != LGS_PilotInternalRoot.OPEN) {
				me.state = DOWN_wait_door_opened;
				if (true) return true;
			} else {
				if (me.param_front_door_position != LGS_PilotInternalRoot.OPEN) {
					me.state = DOWN_wait_door_opened;
					if (true) return true;
				} else {
					if (me.param_right_door_position != LGS_PilotInternalRoot.OPEN) {
						me.state = DOWN_wait_door_opened;
						if (true) return true;
					} else {
						if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
							me.state = DOWN_extendEV_ON;
							if (true) return true;
						} else {
							me.state = UP_openEV_OFF;
							if (true) return true;
						}
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition175 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			if (me.param_right_door_position != LGS_PilotInternalRoot.OPEN) {
				me.state = DOWN_wait_door_opened;
				if (true) return true;
			} else {
				if (me.param_front_door_position != LGS_PilotInternalRoot.OPEN) {
					me.state = DOWN_wait_door_opened;
					if (true) return true;
				} else {
					if (me.param_left_door_position != LGS_PilotInternalRoot.OPEN) {
						me.state = DOWN_wait_door_opened;
						if (true) return true;
					} else {
						if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
							me.state = DOWN_extendEV_ON;
							if (true) return true;
						} else {
							me.state = UP_openEV_OFF;
							if (true) return true;
						}
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition176 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait13.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait13.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal156));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition177 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN_wait_door_opened;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition178 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition179 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition180 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition181 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition182 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_opened) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition183 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_extendEV_ON) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			extend.output(id, actions, LGS_PilotInternalRoot.EV_ON);
			actions.add(new InformalAction(id, informal167));
			me.state = DOWN_wait_gear_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition184 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			if (me.param_front_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
				me.state = DOWN_wait_gear_extended;
				if (true) return true;
			} else {
				if (me.param_left_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
					me.state = DOWN_wait_gear_extended;
					if (true) return true;
				} else {
					if (me.param_right_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
						me.state = DOWN_wait_gear_extended;
						if (true) return true;
					} else {
						me.state = DOWN_extendEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition185 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			if (me.param_left_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
				me.state = DOWN_wait_gear_extended;
				if (true) return true;
			} else {
				if (me.param_front_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
					me.state = DOWN_wait_gear_extended;
					if (true) return true;
				} else {
					if (me.param_right_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
						me.state = DOWN_wait_gear_extended;
						if (true) return true;
					} else {
						me.state = DOWN_extendEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition186 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			if (me.param_right_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
				me.state = DOWN_wait_gear_extended;
				if (true) return true;
			} else {
				if (me.param_front_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
					me.state = DOWN_wait_gear_extended;
					if (true) return true;
				} else {
					if (me.param_left_gear_position != LGS_PilotInternalRoot.LOCKED_EXTENDED) {
						me.state = DOWN_wait_gear_extended;
						if (true) return true;
					} else {
						me.state = DOWN_extendEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition187 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait14.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait14.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal168));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition188 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN_wait_gear_extended;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition189 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition190 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition191 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition192 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition193 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_gear_extended) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition194 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return extend.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_extendEV_OFF) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			extend.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
				actions.add(new InformalAction(id, informal169));
				me.state = DOWN_openEV_OFF;
				if (true) return true;
			} else {
				me.state = DOWN2UP_wait_before_retracting_gears;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition195 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return open.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_openEV_OFF) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			open.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			actions.add(new InformalAction(id, informal160));
			me.state = DOWN_wait_before_closing_doors;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition196 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait15.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait15.clockId, 0);
			actions.add(new DelayAction(id));
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
				me.state = DOWN_closeEV_ON;
				if (true) return true;
			} else {
				me.state = UP_openEV_ON;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition197 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN_wait_before_closing_doors;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition198 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition199 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition200 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			if (me.param_front_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				me.state = DOWN_wait_before_closing_doors;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition201 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			if (me.param_left_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				me.state = DOWN_wait_before_closing_doors;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition202 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			if (me.param_right_door_position == LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = ANOMALY;
				if (true) return true;
			} else {
				me.state = DOWN_wait_before_closing_doors;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition203 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition204 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition205 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_before_closing_doors) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition206 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_closeEV_ON) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			close.output(id, actions, LGS_PilotInternalRoot.EV_ON);
			actions.add(new InformalAction(id, informal161));
			me.state = DOWN_wait_door_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition207 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			if (me.param_front_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = DOWN_wait_door_closed;
				if (true) return true;
			} else {
				if (me.param_left_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
					me.state = DOWN_wait_door_closed;
					if (true) return true;
				} else {
					if (me.param_right_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
						me.state = DOWN_wait_door_closed;
						if (true) return true;
					} else {
						me.state = DOWN_closeEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition208 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			if (me.param_left_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = DOWN_wait_door_closed;
				if (true) return true;
			} else {
				if (me.param_front_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
					me.state = DOWN_wait_door_closed;
					if (true) return true;
				} else {
					if (me.param_right_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
						me.state = DOWN_wait_door_closed;
						if (true) return true;
					} else {
						me.state = DOWN_closeEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition209 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			if (me.param_right_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
				me.state = DOWN_wait_door_closed;
				if (true) return true;
			} else {
				if (me.param_front_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
					me.state = DOWN_wait_door_closed;
					if (true) return true;
				} else {
					if (me.param_left_door_position != LGS_PilotInternalRoot.LOCKED_CLOSED) {
						me.state = DOWN_wait_door_closed;
						if (true) return true;
					} else {
						me.state = DOWN_closeEV_OFF;
						if (true) return true;
					}
				}
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition210 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait16.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait16.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal170));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition211 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN_wait_door_closed;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition212 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition213 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition214 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition215 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition216 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_door_closed) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition217 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return close.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_closeEV_OFF) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			close.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
				actions.add(new InformalAction(id, informal163));
				me.state = DOWN_generalEV_OFF;
				if (true) return true;
			} else {
				me.state = DOWN2UP_wait_before_opening_doors;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition218 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return general.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_generalEV_OFF) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			general.output(id, actions, LGS_PilotInternalRoot.EV_OFF);
			actions.add(new InformalAction(id, informal164));
			me.state = DOWN_wait_end_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition219 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			pressure.input(id, actions);
			me.param_pressure = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			if (me.param_pressure == LGS_PilotInternalRoot.PRESSURE_OFF) {
				if (me.param_handle == LGS_PilotInternalRoot.HANDLE_DOWN) {
					me.state = Start_unpressurized_down;
					if (true) return true;
				} else {
					if (me.param_switch == LGS_PilotInternalRoot.SWITCH_ON) {
						me.state = UP_generalEV_ON;
						if (true) return true;
					} else {
						me.state = UP_wait_switch_on;
						if (true) return true;
					}
				}
			} else {
				me.state = DOWN_wait_end_pressure;
				if (true) return true;
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition220 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait17.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait17.clockId, 0);
			actions.add(new DelayAction(id));
			actions.add(new InformalAction(id, informal165));
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition221 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			handle.input(id, actions);
			me.param_handle = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DOWN_wait_end_pressure;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition222 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			switch_.input(id, actions);
			me.param_switch = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition223 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_door_position.input(id, actions);
			me.param_front_door_position = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition224 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_door_position.input(id, actions);
			me.param_left_door_position = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition225 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_door_position.input(id, actions);
			me.param_right_door_position = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition226 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			front_gear_position.input(id, actions);
			me.param_front_gear_position = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition227 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			left_gear_position.input(id, actions);
			me.param_left_gear_position = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition228 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DOWN_wait_end_pressure) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			right_gear_position.input(id, actions);
			me.param_right_gear_position = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = ANOMALY;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition229 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean red_light = red_lightRef.get(configuration);
			modifiedBehaviors[red_lightRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != ANOMALY) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean red_light = red_lightRef.get(configuration);
			try {
				red_light = LGS_PilotInternalRoot.LIGHT_ON;
				me.state = DEAD;
				if (true) return true;
			} finally {
				red_lightRef.set(configuration, red_light);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition230 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return handle.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean param_bool_DEAD = false;
			handle.input(id, actions);
			param_bool_DEAD = handle.value(boolean.class,0);
			if ( handle.clockId != -1 ) {
				DBM.set(configuration.dbm, handle.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition231 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return switch_.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean param_bool_DEAD = false;
			switch_.input(id, actions);
			param_bool_DEAD = switch_.value(boolean.class,0);
			if ( switch_.clockId != -1 ) {
				DBM.set(configuration.dbm, switch_.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition232 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return pressure.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			boolean param_bool_DEAD = false;
			pressure.input(id, actions);
			param_bool_DEAD = pressure.value(boolean.class,0);
			if ( pressure.clockId != -1 ) {
				DBM.set(configuration.dbm, pressure.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition233 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_int_DEAD = 0;
			front_door_position.input(id, actions);
			param_int_DEAD = front_door_position.value(int.class,0);
			if ( front_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_door_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition234 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_int_DEAD = 0;
			left_door_position.input(id, actions);
			param_int_DEAD = left_door_position.value(int.class,0);
			if ( left_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_door_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition235 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_door_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_int_DEAD = 0;
			right_door_position.input(id, actions);
			param_int_DEAD = right_door_position.value(int.class,0);
			if ( right_door_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_door_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition236 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return front_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_int_DEAD = 0;
			front_gear_position.input(id, actions);
			param_int_DEAD = front_gear_position.value(int.class,0);
			if ( front_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, front_gear_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition237 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return left_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_int_DEAD = 0;
			left_gear_position.input(id, actions);
			param_int_DEAD = left_gear_position.value(int.class,0);
			if ( left_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, left_gear_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition238 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return right_gear_position.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != DEAD) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final EV_managementConfiguration me = (EV_managementConfiguration) configuration.behaviorConfigurations[id];
			int param_int_DEAD = 0;
			right_gear_position.input(id, actions);
			param_int_DEAD = right_gear_position.value(int.class,0);
			if ( right_gear_position.clockId != -1 ) {
				DBM.set(configuration.dbm, right_gear_position.clockId, 0);
			}
			me.state = DEAD;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
		transition10,
		transition11,
		transition12,
		transition13,
		transition14,
		transition15,
		transition16,
		transition17,
		transition18,
		transition19,
		transition20,
		transition21,
		transition22,
		transition23,
		transition24,
		transition25,
		transition26,
		transition27,
		transition28,
		transition29,
		transition30,
		transition31,
		transition32,
		transition33,
		transition34,
		transition35,
		transition36,
		transition37,
		transition38,
		transition39,
		transition40,
		transition41,
		transition42,
		transition43,
		transition44,
		transition45,
		transition46,
		transition47,
		transition48,
		transition49,
		transition50,
		transition51,
		transition52,
		transition53,
		transition54,
		transition55,
		transition56,
		transition57,
		transition58,
		transition59,
		transition60,
		transition61,
		transition62,
		transition63,
		transition64,
		transition65,
		transition66,
		transition67,
		transition68,
		transition69,
		transition70,
		transition71,
		transition72,
		transition73,
		transition74,
		transition75,
		transition76,
		transition77,
		transition78,
		transition79,
		transition80,
		transition81,
		transition82,
		transition83,
		transition84,
		transition85,
		transition86,
		transition87,
		transition88,
		transition89,
		transition90,
		transition91,
		transition92,
		transition93,
		transition94,
		transition95,
		transition96,
		transition97,
		transition98,
		transition99,
		transition100,
		transition101,
		transition102,
		transition103,
		transition104,
		transition105,
		transition106,
		transition107,
		transition108,
		transition109,
		transition110,
		transition111,
		transition112,
		transition113,
		transition114,
		transition115,
		transition116,
		transition117,
		transition118,
		transition119,
		transition120,
		transition121,
		transition122,
		transition123,
		transition124,
		transition125,
		transition126,
		transition127,
		transition128,
		transition129,
		transition130,
		transition131,
		transition132,
		transition133,
		transition134,
		transition135,
		transition136,
		transition137,
		transition138,
		transition139,
		transition140,
		transition141,
		transition142,
		transition143,
		transition144,
		transition145,
		transition146,
		transition147,
		transition148,
		transition149,
		transition150,
		transition151,
		transition152,
		transition153,
		transition154,
		transition155,
		transition156,
		transition157,
		transition158,
		transition159,
		transition160,
		transition161,
		transition162,
		transition163,
		transition164,
		transition165,
		transition166,
		transition167,
		transition168,
		transition169,
		transition170,
		transition171,
		transition172,
		transition173,
		transition174,
		transition175,
		transition176,
		transition177,
		transition178,
		transition179,
		transition180,
		transition181,
		transition182,
		transition183,
		transition184,
		transition185,
		transition186,
		transition187,
		transition188,
		transition189,
		transition190,
		transition191,
		transition192,
		transition193,
		transition194,
		transition195,
		transition196,
		transition197,
		transition198,
		transition199,
		transition200,
		transition201,
		transition202,
		transition203,
		transition204,
		transition205,
		transition206,
		transition207,
		transition208,
		transition209,
		transition210,
		transition211,
		transition212,
		transition213,
		transition214,
		transition215,
		transition216,
		transition217,
		transition218,
		transition219,
		transition220,
		transition221,
		transition222,
		transition223,
		transition224,
		transition225,
		transition226,
		transition227,
		transition228,
		transition229,
		transition230,
		transition231,
		transition232,
		transition233,
		transition234,
		transition235,
		transition236,
		transition237,
		transition238,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		EV_managementConfiguration me = new EV_managementConfiguration();
		boolean param_bool_DEAD;
		int param_int_DEAD;
		//Initial action code.
		me.state = INIT_handle;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		EV_managementConfiguration me = (EV_managementConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case EV_managementBehavior.INIT_front_door: 
			text.append("@INIT_front_door,");
			break;
		case EV_managementBehavior.INIT_left_door: 
			text.append("@INIT_left_door,");
			break;
		case EV_managementBehavior.INIT_right_door: 
			text.append("@INIT_right_door,");
			break;
		case EV_managementBehavior.INIT_front_gear: 
			text.append("@INIT_front_gear,");
			break;
		case EV_managementBehavior.INIT_left_gear: 
			text.append("@INIT_left_gear,");
			break;
		case EV_managementBehavior.INIT_right_gear: 
			text.append("@INIT_right_gear,");
			break;
		case EV_managementBehavior.INIT_handle: 
			text.append("@INIT_handle,");
			break;
		case EV_managementBehavior.INIT_switch: 
			text.append("@INIT_switch,");
			break;
		case EV_managementBehavior.INIT_pressure: 
			text.append("@INIT_pressure,");
			break;
		case EV_managementBehavior.End_INIT: 
			text.append("@end_INIT,");
			break;
		case EV_managementBehavior.INIT_general: 
			text.append("@INIT_general,");
			break;
		case EV_managementBehavior.INIT_open: 
			text.append("@INIT_open,");
			break;
		case EV_managementBehavior.INIT_retract: 
			text.append("@INIT_retract,");
			break;
		case EV_managementBehavior.INIT_close: 
			text.append("@INIT_close,");
			break;
		case EV_managementBehavior.INIT_extend: 
			text.append("@INIT_extend,");
			break;
		case EV_managementBehavior.Start_unpressurized_down: 
			text.append("@start_unpressurized_down,");
			break;
		case EV_managementBehavior.Start_unpressurized_up: 
			text.append("@start_unpressurized_up,");
			break;
		case EV_managementBehavior.UP_wait_switch_on: 
			text.append("@UP_wait_switch_on,");
			break;
		case EV_managementBehavior.UP_generalEV_ON: 
			text.append("@UP_generalEV_ON,");
			break;
		case EV_managementBehavior.UP_wait_pressure: 
			text.append("@UP_wait_pressure,");
			break;
		case EV_managementBehavior.UP_openEV_ON: 
			text.append("@UP_openEV_ON,");
			break;
		case EV_managementBehavior.UP_wait_door_opened: 
			text.append("@UP_wait_door_opened,");
			break;
		case EV_managementBehavior.UP_retractEV_ON: 
			text.append("@UP_retractEV_ON,");
			break;
		case EV_managementBehavior.UP_wait_gear_retracted: 
			text.append("@UP_wait_gear_retracted,");
			break;
		case EV_managementBehavior.UP_retractEV_OFF: 
			text.append("@UP_retractEV_OFF,");
			break;
		case EV_managementBehavior.UP_openEV_OFF: 
			text.append("@UP_openEV_OFF,");
			break;
		case EV_managementBehavior.UP_wait_before_closing_doors: 
			text.append("@UP_wait_before_closing_doors,");
			break;
		case EV_managementBehavior.UP_closeEV_ON: 
			text.append("@UP_closeEV_ON,");
			break;
		case EV_managementBehavior.UP_wait_door_closed: 
			text.append("@UP_wait_door_closed,");
			break;
		case EV_managementBehavior.UP_closeEV_OFF: 
			text.append("@UP_closeEV_OFF,");
			break;
		case EV_managementBehavior.UP_generalEV_OFF: 
			text.append("@UP_generalEV_OFF,");
			break;
		case EV_managementBehavior.UP_wait_end_pressure: 
			text.append("@UP_wait_end_pressure,");
			break;
		case EV_managementBehavior.DOWN_wait_switch_on: 
			text.append("@DOWN_wait_switch_on,");
			break;
		case EV_managementBehavior.DOWN_generalEV_ON: 
			text.append("@DOWN_generalEV_ON,");
			break;
		case EV_managementBehavior.DOWN_wait_pressure: 
			text.append("@DOWN_wait_pressure,");
			break;
		case EV_managementBehavior.DOWN_openEV_ON: 
			text.append("@DOWN_openEV_ON,");
			break;
		case EV_managementBehavior.DOWN_wait_door_opened: 
			text.append("@DOWN_wait_door_opened,");
			break;
		case EV_managementBehavior.DOWN_extendEV_ON: 
			text.append("@DOWN_extendEV_ON,");
			break;
		case EV_managementBehavior.DOWN_wait_gear_extended: 
			text.append("@DOWN_wait_gear_extended,");
			break;
		case EV_managementBehavior.DOWN_extendEV_OFF: 
			text.append("@DOWN_extendEV_OFF,");
			break;
		case EV_managementBehavior.DOWN_openEV_OFF: 
			text.append("@DOWN_openEV_OFF,");
			break;
		case EV_managementBehavior.DOWN_wait_before_closing_doors: 
			text.append("@DOWN_wait_before_closing_doors,");
			break;
		case EV_managementBehavior.DOWN_closeEV_ON: 
			text.append("@DOWN_closeEV_ON,");
			break;
		case EV_managementBehavior.DOWN_wait_door_closed: 
			text.append("@DOWN_wait_door_closed,");
			break;
		case EV_managementBehavior.DOWN_closeEV_OFF: 
			text.append("@DOWN_closeEV_OFF,");
			break;
		case EV_managementBehavior.DOWN_generalEV_OFF: 
			text.append("@DOWN_generalEV_OFF,");
			break;
		case EV_managementBehavior.DOWN_wait_end_pressure: 
			text.append("@DOWN_wait_end_pressure,");
			break;
		case EV_managementBehavior.UP2DOWN_wait_before_extending_gears: 
			text.append("@UP2DOWN_wait_before_extending_gears,");
			break;
		case EV_managementBehavior.DOWN2UP_wait_before_retracting_gears: 
			text.append("@DOWN2UP_wait_before_retracting_gears,");
			break;
		case EV_managementBehavior.UP2DOWN_wait_before_opening_doors: 
			text.append("@UP2DOWN_wait_before_opening_doors,");
			break;
		case EV_managementBehavior.DOWN2UP_wait_before_opening_doors: 
			text.append("@DOWN2UP_wait_before_opening_doors,");
			break;
		case EV_managementBehavior.ANOMALY: 
			text.append("@ANOMALY,");
			break;
		case EV_managementBehavior.DEAD: 
			text.append("@DEAD,");
			break;
		}
		text.append("\n\t- param_handle=");
		text.append(Boolean.toString(me.param_handle));
		text.append("\n\t- param_switch=");
		text.append(Boolean.toString(me.param_switch));
		text.append("\n\t- param_pressure=");
		text.append(Boolean.toString(me.param_pressure));
		text.append("\n\t- param_front_door_position=");
		text.append(Integer.toString(me.param_front_door_position));
		text.append("\n\t- param_left_door_position=");
		text.append(Integer.toString(me.param_left_door_position));
		text.append("\n\t- param_right_door_position=");
		text.append(Integer.toString(me.param_right_door_position));
		text.append("\n\t- param_front_gear_position=");
		text.append(Integer.toString(me.param_front_gear_position));
		text.append("\n\t- param_left_gear_position=");
		text.append(Integer.toString(me.param_left_gear_position));
		text.append("\n\t- param_right_gear_position=");
		text.append(Integer.toString(me.param_right_gear_position));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		EV_managementConfiguration me = (EV_managementConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case EV_managementBehavior.INIT_front_door: 
			text.append("@INIT_front_door,");
			break;
		case EV_managementBehavior.INIT_left_door: 
			text.append("@INIT_left_door,");
			break;
		case EV_managementBehavior.INIT_right_door: 
			text.append("@INIT_right_door,");
			break;
		case EV_managementBehavior.INIT_front_gear: 
			text.append("@INIT_front_gear,");
			break;
		case EV_managementBehavior.INIT_left_gear: 
			text.append("@INIT_left_gear,");
			break;
		case EV_managementBehavior.INIT_right_gear: 
			text.append("@INIT_right_gear,");
			break;
		case EV_managementBehavior.INIT_handle: 
			text.append("@INIT_handle,");
			break;
		case EV_managementBehavior.INIT_switch: 
			text.append("@INIT_switch,");
			break;
		case EV_managementBehavior.INIT_pressure: 
			text.append("@INIT_pressure,");
			break;
		case EV_managementBehavior.End_INIT: 
			text.append("@end_INIT,");
			break;
		case EV_managementBehavior.INIT_general: 
			text.append("@INIT_general,");
			break;
		case EV_managementBehavior.INIT_open: 
			text.append("@INIT_open,");
			break;
		case EV_managementBehavior.INIT_retract: 
			text.append("@INIT_retract,");
			break;
		case EV_managementBehavior.INIT_close: 
			text.append("@INIT_close,");
			break;
		case EV_managementBehavior.INIT_extend: 
			text.append("@INIT_extend,");
			break;
		case EV_managementBehavior.Start_unpressurized_down: 
			text.append("@start_unpressurized_down,");
			break;
		case EV_managementBehavior.Start_unpressurized_up: 
			text.append("@start_unpressurized_up,");
			break;
		case EV_managementBehavior.UP_wait_switch_on: 
			text.append("@UP_wait_switch_on,");
			break;
		case EV_managementBehavior.UP_generalEV_ON: 
			text.append("@UP_generalEV_ON,");
			break;
		case EV_managementBehavior.UP_wait_pressure: 
			text.append("@UP_wait_pressure,");
			break;
		case EV_managementBehavior.UP_openEV_ON: 
			text.append("@UP_openEV_ON,");
			break;
		case EV_managementBehavior.UP_wait_door_opened: 
			text.append("@UP_wait_door_opened,");
			break;
		case EV_managementBehavior.UP_retractEV_ON: 
			text.append("@UP_retractEV_ON,");
			break;
		case EV_managementBehavior.UP_wait_gear_retracted: 
			text.append("@UP_wait_gear_retracted,");
			break;
		case EV_managementBehavior.UP_retractEV_OFF: 
			text.append("@UP_retractEV_OFF,");
			break;
		case EV_managementBehavior.UP_openEV_OFF: 
			text.append("@UP_openEV_OFF,");
			break;
		case EV_managementBehavior.UP_wait_before_closing_doors: 
			text.append("@UP_wait_before_closing_doors,");
			break;
		case EV_managementBehavior.UP_closeEV_ON: 
			text.append("@UP_closeEV_ON,");
			break;
		case EV_managementBehavior.UP_wait_door_closed: 
			text.append("@UP_wait_door_closed,");
			break;
		case EV_managementBehavior.UP_closeEV_OFF: 
			text.append("@UP_closeEV_OFF,");
			break;
		case EV_managementBehavior.UP_generalEV_OFF: 
			text.append("@UP_generalEV_OFF,");
			break;
		case EV_managementBehavior.UP_wait_end_pressure: 
			text.append("@UP_wait_end_pressure,");
			break;
		case EV_managementBehavior.DOWN_wait_switch_on: 
			text.append("@DOWN_wait_switch_on,");
			break;
		case EV_managementBehavior.DOWN_generalEV_ON: 
			text.append("@DOWN_generalEV_ON,");
			break;
		case EV_managementBehavior.DOWN_wait_pressure: 
			text.append("@DOWN_wait_pressure,");
			break;
		case EV_managementBehavior.DOWN_openEV_ON: 
			text.append("@DOWN_openEV_ON,");
			break;
		case EV_managementBehavior.DOWN_wait_door_opened: 
			text.append("@DOWN_wait_door_opened,");
			break;
		case EV_managementBehavior.DOWN_extendEV_ON: 
			text.append("@DOWN_extendEV_ON,");
			break;
		case EV_managementBehavior.DOWN_wait_gear_extended: 
			text.append("@DOWN_wait_gear_extended,");
			break;
		case EV_managementBehavior.DOWN_extendEV_OFF: 
			text.append("@DOWN_extendEV_OFF,");
			break;
		case EV_managementBehavior.DOWN_openEV_OFF: 
			text.append("@DOWN_openEV_OFF,");
			break;
		case EV_managementBehavior.DOWN_wait_before_closing_doors: 
			text.append("@DOWN_wait_before_closing_doors,");
			break;
		case EV_managementBehavior.DOWN_closeEV_ON: 
			text.append("@DOWN_closeEV_ON,");
			break;
		case EV_managementBehavior.DOWN_wait_door_closed: 
			text.append("@DOWN_wait_door_closed,");
			break;
		case EV_managementBehavior.DOWN_closeEV_OFF: 
			text.append("@DOWN_closeEV_OFF,");
			break;
		case EV_managementBehavior.DOWN_generalEV_OFF: 
			text.append("@DOWN_generalEV_OFF,");
			break;
		case EV_managementBehavior.DOWN_wait_end_pressure: 
			text.append("@DOWN_wait_end_pressure,");
			break;
		case EV_managementBehavior.UP2DOWN_wait_before_extending_gears: 
			text.append("@UP2DOWN_wait_before_extending_gears,");
			break;
		case EV_managementBehavior.DOWN2UP_wait_before_retracting_gears: 
			text.append("@DOWN2UP_wait_before_retracting_gears,");
			break;
		case EV_managementBehavior.UP2DOWN_wait_before_opening_doors: 
			text.append("@UP2DOWN_wait_before_opening_doors,");
			break;
		case EV_managementBehavior.DOWN2UP_wait_before_opening_doors: 
			text.append("@DOWN2UP_wait_before_opening_doors,");
			break;
		case EV_managementBehavior.ANOMALY: 
			text.append("@ANOMALY,");
			break;
		case EV_managementBehavior.DEAD: 
			text.append("@DEAD,");
			break;
		}
		text.append(" param_handle=");
		text.append(Boolean.toString(me.param_handle));
		text.append(" param_switch=");
		text.append(Boolean.toString(me.param_switch));
		text.append(" param_pressure=");
		text.append(Boolean.toString(me.param_pressure));
		text.append(" param_front_door_position=");
		text.append(Integer.toString(me.param_front_door_position));
		text.append(" param_left_door_position=");
		text.append(Integer.toString(me.param_left_door_position));
		text.append(" param_right_door_position=");
		text.append(Integer.toString(me.param_right_door_position));
		text.append(" param_front_gear_position=");
		text.append(Integer.toString(me.param_front_gear_position));
		text.append(" param_left_gear_position=");
		text.append(Integer.toString(me.param_left_gear_position));
		text.append(" param_right_gear_position=");
		text.append(Integer.toString(me.param_right_gear_position));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		EV_managementConfiguration me = new EV_managementConfiguration();
		me.state = boost.readShort();
		me.param_handle = boost.readBoolean();
		me.param_switch = boost.readBoolean();
		me.param_pressure = boost.readBoolean();
		me.param_front_door_position = boost.readInt();
		me.param_left_door_position = boost.readInt();
		me.param_right_door_position = boost.readInt();
		me.param_front_gear_position = boost.readInt();
		me.param_left_gear_position = boost.readInt();
		me.param_right_gear_position = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		EV_managementConfiguration me = (EV_managementConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.param_handle);
		boost.writeBoolean(me.param_switch);
		boost.writeBoolean(me.param_pressure);
		boost.writeInt(me.param_front_door_position);
		boost.writeInt(me.param_left_door_position);
		boost.writeInt(me.param_right_door_position);
		boost.writeInt(me.param_front_gear_position);
		boost.writeInt(me.param_left_gear_position);
		boost.writeInt(me.param_right_gear_position);
	}

}

